/*
 * bpfx-inter.h
 * Copyright (C) 2008-2010, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <config.h>

#ifndef __LIBx1f4_bpfx_inter_H__
#define __LIBx1f4_bpfx_inter_H__

#include <bpfx-names.h>
#include <bpfx-types.h>

#if !defined _libx1f4l2_fast_bpfset
# define _libx1f4l2_fast_bpfset		x1f4_fast_bpfset
#endif				/* !_libx1f4l2_fast_bpfset */
#if !defined _libx1f4l2_flat_bpfset
# define _libx1f4l2_flat_bpfset		x1f4_flat_bpfset
#endif				/* !_libx1f4l2_flat_bpfset */

extern int _libx1f4l2_blue_bppset
    (void *, integral_q, integral_q **, void **, unsigned *, integral_q **,
     integral_q **, integral_q, unsigned *);
extern int _libx1f4l2_ceil_bpfset(void *);
extern int _libx1f4l2_fare_bppset
    (void *, void *, void *, unsigned, void **, unsigned);
extern int _libx1f4l2_fast_bpfset(void *, unsigned, struct screen_type *);
extern int _libx1f4l2_flat_bpfset(void *);
extern int _libx1f4l2_fold_bppset
    (void *, integral_q *, integral_q *, integral_q *, unsigned, unsigned,
     void *);
extern int _libx1f4l2_four_bppset
    (void *, integral_q, integral_q **, integral_q, void **, unsigned *,
     integral_q **, integral_q **, integral_q **, integral_q, unsigned *);
extern int _libx1f4l2_gray_bppset
    (void *, integral_q, integral_q **, void **, unsigned *, integral_q **,
     integral_q **, integral_q, unsigned *);
extern int _libx1f4l2_hale_bppset
    (void *, void *, void *, unsigned, void **, unsigned);
extern int _libx1f4l2_join_bppset
    (void *, unsigned, void *, integral_q **, integral_q **, unsigned *,
     integral_q *, integral_q **, integral_q **, unsigned, integral_q,
     integral_q *);
extern int _libx1f4l2_lane_bppset
    (void *, unsigned, void *, integral_q **, integral_q **, unsigned *,
     integral_q *, integral_q **, integral_q **, unsigned, integral_q,
     integral_q *);
extern int _libx1f4l2_lift_bppset
    (void *, void *, integral_q *, integral_q **, integral_q **, integral_q,
     void **, unsigned *, integral_q **, integral_q **, integral_q **,
     integral_q *, void *, integral_q);
extern int _libx1f4l2_long_bppset(void *, void *, unsigned);
extern int _libx1f4l2_nine_bppset
    (void *, integral_q, integral_q **, integral_q, void **, unsigned *,
     integral_q **, integral_q **, integral_q **, integral_q, unsigned *);
extern int _libx1f4l2_pack_bppset
    (void *, void *, integral_q *, integral_q **, integral_q **, integral_q,
     void **, unsigned *, integral_q **, integral_q **, integral_q **,
     integral_q *, void *, integral_q);
extern int _libx1f4l2_root_bppset(void *, void *, unsigned);
extern int _libx1f4l2_sand_bppset
    (void *, unsigned, void *, integral_q **, integral_q **, unsigned *,
     integral_q *, integral_q **, integral_q **, unsigned, integral_q,
     integral_q *);
extern int _libx1f4l2_tale_bppset
    (void *, void *, integral_q *, integral_q **, integral_q **, integral_q,
     void **, unsigned *, integral_q **, integral_q **, integral_q **,
     integral_q *, void *, integral_q);

#endif				/* __LIBx1f4_bpfx_inter_H__ */
