/*
 * bppx.7.c
 * Copyright (C) 2009-2010, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <bpfx-names.h>
#include <bpfx-types.h>
#include <bppx-break.h>
#include <bppx-scope.h>
#include <bppx-types.h>

#define bpfset(bpfset)			((struct bpfset_type *) (bpfset))

static int clip(void *, integral_q);
static int pick(void *, integral_q, unsigned *);

static int
clip(void *node, integral_q mode)
{
    int status;
    integral_q *call;
    unsigned size;

    call = node;

    size = *call;
    if (size) {
	call++;

	size--;
	while (size) {
	    unsigned half;

	    half = (size + 1) >> 1;
	    if (mode < call[half]) {
		size = half - 1;
	    } else {
		call += half;
		size -= half;
	    }
	}

	if (*call == mode) {
	    status = 1;
	} else {
	    status = 0;
	}
    } else {
	status = 0;
    }

    return status;
}


static int
pick(void *node, integral_q mode, unsigned *pick)
{
    integral_q *call;
    unsigned size;

    call = node;

    size = *call;

    call++;

    size--;
    while (size) {
	unsigned half;

	half = (size + 1) >> 1;
	if (mode < call[half]) {
	    size = half - 1;
	} else {
	    call += half;
	    size -= half;
	}
    }

    if (mode < *call) {
    } else {
	call++;
    }

    *pick = call - 1 - (integral_q *) node;

    return 0;
}


int
x1f4_find_bppset(void *bpfset, integral_q mode)
{
    int status;
    unsigned rate;

    rate = bpfset(bpfset)->link_a.fpnews.link_v.rate;
    if (rate) {
	unsigned copy;
	void *node;

	node = bpfset(bpfset)->link_a.fpnews.node;

	pick(node, mode, &copy);

	node = ND(node)[copy];

	rate--;

	while (rate) {
	    seek_copy(node, mode, copy);

	    node = PD(node)[copy];

	    rate--;
	}

	high_find(node, mode, status);
    } else {
	status = clip(bpfset(bpfset)->link_a.fpnews.node, mode);
    }

    return status;
}
