/*
 * bppx.n.c
 * Copyright (C) 2009-2010, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <bpfx-config.h>

#include <bpfx-defs.h>
#include <bpfx-inter.h>
#include <bpfx-lines.h>
#include <bpfx-names.h>
#include <bpfx-types.h>
#include <bppx-types.h>

#define __LOSE_CALL__			__BALANCE_COMMON_INTERNAL__

#undef Q
#define Q(e)				((integral_q) (e))

#define bpfset(bpfset)			((struct bpfset_type *) (bpfset))

int
_libx1f4l2_lift_bppset(void *bpfset, void *date, integral_q *data,
		       integral_q **path, integral_q **lead, integral_q pipe,
		       void **lift, unsigned *mile, integral_q **lock,
		       integral_q **lane, integral_q **turn, integral_q *text,
		       void *near, integral_q mode)
{
    int status;
    integral_q *club, *file, *tier;
    unsigned call;
    void *node;

    call = *mile;

    club = *lead;

    file = *lock;

    node = *lift;

    tier = *lane;

    if (0) {
    } else {
	integral_q last, next;
	unsigned deck, ever;
#if __LOSE_CALL__
	unsigned hold = 0;
#endif				/* __LOSE_CALL__ */

	if (1) {
	    if (club) {
		last = *club & ~Lx55555555;
		if (last) {
#if __LOSE_CALL__
		    if (last & (last - 1)) {
			deck = 4;
#endif				/* __LOSE_CALL__ */
			ever = 0;
#if __LOSE_CALL__
			next = ~Q(0);
		    } else {
			if (tier) {
#endif				/* __LOSE_CALL__ */
			    deck = 1;
#if __LOSE_CALL__
			    next = *tier & ~Lx55555555;
			    if (next) {
				if (next & (next - 1)) {
				    ever = 4;
				} else {
				    ever = 1;
				}
			    } else {
				ever = 0;
			    }
			} else {
			    deck = 4;
			    ever = 0;
			    next = ~Q(0);
			}
		    }
#endif				/* __LOSE_CALL__ */
		} else {
		    deck = 0;
		    if (tier) {
			next = *tier & ~Lx55555555;
			if (next) {
#if __LOSE_CALL__
			    if (next & (next - 1)) {
				ever = 4;
			    } else {
#endif				/* __LOSE_CALL__ */
				ever = 1;
#if __LOSE_CALL__
			    }
#endif				/* __LOSE_CALL__ */
			} else {
			    ever = 0;
			}
		    } else {
			ever = 0;
#if __LOSE_CALL__
			next = ~Q(0);
#endif				/* __LOSE_CALL__ */
#if __LOSE_CALL__
			if (pipe & Q(1) << integral_q_last) {
			    hold = integral_q_bits - 3;
			} else {
			    if (pipe & Q(1) << (integral_q_bits - 3)) {
				hold = integral_q_bits - 4;
			    } else {
				hold = integral_q_bits - 5;
			    }
			}

			last = *KD(PD(node)[hold]) & ~Lx55555555;
			if (last & (last - 1)) {
			    deck = 4;
			} else {
			    deck = 1;
			}
#endif				/* __LOSE_CALL__ */
		    }
		}
	    } else {
		deck = 0;
#if __LOSE_CALL__
		last = ~Q(0);
#endif				/* __LOSE_CALL__ */
		next = *tier & ~Lx55555555;
		if (next) {
#if __LOSE_CALL__
		    ever = 4;
#else
		    ever = 1;
#endif				/* __LOSE_CALL__ */
		} else {
		    ever = 0;
#if __LOSE_CALL__
		    if (call) {
			if (pipe & Q(1) << 3) {
			    hold = 3;
			} else {
			    if (pipe & Q(1) << 5) {
				hold = 4;
			    } else {
				hold = 5;
			    }
			}
		    } else {
			if (pipe & Q(1) << 3) {
			    hold = 2;
			} else {
			    hold = 3;
			}
		    }

		    next = *KD(PD(node)[hold]) & ~Lx55555555;
		    if (next & (next - 1)) {
			ever = 4;
		    } else {
			ever = 1;
		    }
#endif				/* __LOSE_CALL__ */
		}
	    }
	}

	if (deck | ever) {
	    status = 0;

#if __LOSE_CALL__
	    if ((deck | ever) & 4) {
		if (call ^ (integral_q_bits - 1)) {
		    if (pipe & ((Q(1) << call) - 1) << 1) {
		    } else {
			ever += 2;
		    }
		} else {
		    deck += 2;
		}

		if (deck < ever) {
		    integral_q data, *fast, *side, text;

		    if (hold) {
			club = tier;

			tier = PD(node)[hold];
		    }

		    fast = tier;

		    text = next;
		    text &= (text - 1) << 1;

		    *KD(fast) = Lx55555555 | (next & ~text);

		    text >>= 2;
		    if (text) {
			fast += 2;

			side = fast + integral_q_bits - 1;

			last = *fast;

			data = *side;

			text >>= 2;

			for (; text; text >>= 2) {
			    *fast = *(fast + 2);
			    fast += 2;
			    *side = *(side + 2);
			    side += 2;
			}
			{
			    *fast = *(fast + 1);
			}
			{
			    *side = *(side + 1);
			}
		    } else {
			last = fast[1];

			data = fast[integral_q_bits];
		    }

		    if (hold) {
			fast = club + 2;

			side = fast + integral_q_bits - 1;

			if (hold & 1) {
			    if (pipe & Q(1) << hold) {
				text = KD(node)[hold];

				KD(node)[hold] = last;
			    } else {
				hold--;

				text = KD(node)[hold];

				KD(node)[hold] = last;

				hold++;
			    }
			} else {
			    text = KD(node)[hold];

			    KD(node)[hold] = last;
			}

			last = *fast;

			next = data;

			data = *side;

			ever = half_integral_q_bits - 2;
			for (; ever; ever--) {
			    *fast = *(fast + 2);
			    fast += 2;
			    *side = *(side + 2);
			    side += 2;
			}
			{
			    *side = *(side + 2);
			    side += 2;
			}
			{
			    *fast = text;
			}
			{
			    *side = next;
			}
		    }

		    fast = file;

		    *KD(fast) = Lx55555555 | Q(1) << integral_q_last;

		    if (0) {
		    } else {
			fast += integral_q_last;

			*fast = **turn;

			fast += integral_q_bits;

			{
			    *(fast - 1) = *fast;
			}

			{
			    *fast = data;
			}
		    }

		    **turn = last;
		} else {
		    integral_q data, *fast, *side, text;

		    if (hold) {
			tier = club;

			club = PD(node)[hold];
		    }

		    fast = club;

		    text = last;

		    if (text & Q(1) << integral_q_last) {
			next = fast[integral_q_last];

		        fast += (integral_q_bits << 1) - 1;

			data = *fast;
			*fast = *(fast - 1);

			*KD(club) = Lx55555555
			    | (last ^ Q(1) << integral_q_last);
		    } else {
			fast += integral_q_bits - 2;

			side = fast + integral_q_bits + 1;

			next = *fast;

			data = *side;

			text <<= 2;

			for (; !(text & Q(1) << integral_q_last); text <<= 2) {
			    *fast = *(fast - 2);
			    fast -= 2;
			    *side = *(side - 2);
			    side -= 2;
			}
			{
			    *fast = *(fast - 1);
			}
			{
			    *side = *(side - 2);
			    side -= 2;
			}
			{
			    *side = *(side - 1);
			}

			*KD(club) = Lx55555555
			    | (last ^ Q(1) << (fast - club - 1));
		    }

		    if (hold) {
			fast = tier + integral_q_bits - 2;

			side = fast + integral_q_bits + 1;

			if (1) {
			    hold++;

			    text = KD(node)[hold];

			    KD(node)[hold] = next;

			    hold--;
			}

			next = *fast;

			last = data;

			data = *side;

			ever = half_integral_q_bits - 2;
			for (; ever; ever--) {
			    *fast = *(fast - 2);
			    fast -= 2;
			    *side = *(side - 2);
			    side -= 2;
			}
			{
			    *side = *(side - 2);
			    side -= 2;
			}
			{
			    *fast = text;
			}
			{
			    *side = last;
			}
		    }

		    fast = file;

		    *KD(fast) = Lx55555555 | 2;

		    if (0) {
		    } else {
			fast += 1;

			side = fast + integral_q_bits - 1;

			{
			    *fast = **path;
			}
			{
			    *side = data;
			}
		    }

		    **path = next;
		}
	    } else {
		if (club) {
		    if (tier) {
		    } else {
			if (pipe & Q(1) << integral_q_last) {
			    call = integral_q_bits - 2;
			} else {
			    call = integral_q_bits - 3;
			}

			*mile = call;

			*lane = file;
			*lock = club;
			*lead = PD(node)[hold];

			*turn = *path;
			if (pipe & Q(1) << integral_q_last) {
			    *path = KD(node) + integral_q_bits - 2;
			} else {
			    if (pipe & Q(1) << (integral_q_bits - 3)) {
				*path = KD(node) + integral_q_bits - 3;
			    } else {
				*path = KD(node) + integral_q_bits - 4;
			    }
			}
		    }
		} else {
		    if (call) {
			if (pipe & Q(1) << 3) {
			    call = 2;
			} else {
			    call = 3;
			}
		    } else {
			call++;
		    }

		    *mile = call;

		    *lead = file;
		    *lock = tier;
		    *lane = PD(node)[hold];

		    *path = *turn;
		    *turn = KD(node) + call + 1;
		}

		status = _libx1f4l2_pack_bppset
		    (bpfset, date, data, path, lead, pipe, lift, mile, lock,
		     lane, turn, text, near, mode);
	    }
#endif				/* __LOSE_CALL__ */
	} else {
#if __LOSE_CALL__
	    status = _libx1f4l2_pack_bppset
		(bpfset, date, data, path, lead, pipe, lift, mile, lock, lane,
		 turn, text, near, mode);
#else
	    status = _libx1f4l2_tale_bppset
		(bpfset, date, data, path, lead, pipe, lift, mile, lock, lane,
		 turn, text, near, mode);
#endif				/* __LOSE_CALL__ */
	}
    }

    return status;
}
