/*
 * bppx.q.c
 * Copyright (C) 2009-2010, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <bcount.h>
#include <bpfx-lines.h>
#include <bpfx-names.h>
#include <bpfx-types.h>
#include <bppx-types.h>

#define __HALF_TRANSFER__		1

#define __UNROLL_TRANSFER__		0

#undef Q
#define Q(e)				((integral_q) (e))

#define bpfset(bpfset)			((struct bpfset_type *) (bpfset))

int
_libx1f4l2_nine_bppset(void *bpfset, integral_q last, integral_q **lead,
		       integral_q pipe, void **lift, unsigned *mile,
		       integral_q **land, integral_q **lock, integral_q **lane,
		       integral_q next, unsigned *rate)
{
    integral_q *club, *file, *head, *tier;
    unsigned call, copy, deck, ever;
    void *node;

    club = *lead;

    file = *lock;

    tier = *lane;

    node = *lift;

    call = *mile;

    copy = *rate;

    if (1) {
	integral_q *fast, text;

	fast = club;

	text = *fast;
	if (text & Q(1) << integral_q_last) {
	    fast += integral_q_bits;
	    next = *(fast - 1);
	} else {
	    fast += integral_q_bits - 2;

	    next = *fast;

	    text <<= 2;

# if __UNROLL_TRANSFER__
	    for (; !(text & Q(10) << (integral_q_bits - 4)); text <<= 4) {
		*fast = *(fast - 2);
		fast -= 2;
		*fast = *(fast - 2);
		fast -= 2;
	    }
	    if (!(text & Q(2) << (integral_q_bits - 2))) {
		*fast = *(fast - 2);
		fast -= 2;
	    }
# else
	    for (; !(text & Q(1) << integral_q_last); text <<= 2) {
		*fast = *(fast - 2);
		fast -= 2;
	    }
# endif				/* __UNROLL_TRANSFER__ */
	    {
		*fast = *(fast - 1);
	    }
	}

	*KD(club) = last ^ Q(1) << (fast - club - 1);

	fast = file;

	if (copy & 1) {
	    *KD(fast) = Lx55555555 | 2;

	    *(fast + 1) = next;
	} else {
	    text = *fast & ~Lx55555555;

	    if (text >> copy) {
		if (text >> copy < Q(1) << copy) {
		    *KD(fast) = Lx55555555 | 2;

		    fast += copy;

		    last = text >> copy >> 2;

# if __UNROLL_TRANSFER__
		    mode = last >> 2;
		    for (; mode; mode >>= 4) {
			*fast = *(fast + 2);
			fast += 2;
			*fast = *(fast + 2);
			fast += 2;
		    }
		    if (last & Lx22222222) {
			*fast = *(fast + 2);
			fast += 2;
		    }
# else
		    for (; last; last >>= 2) {
			*fast = *(fast + 2);
			fast += 2;
		    }
# endif				/* __UNROLL_TRANSFER__ */
		    {
			*fast = *(fast + 1);
		    }

		    {
			*(file + 1) = next;
		    }
		} else {
		    *KD(fast) = text | Lx55555555;

		    fast += copy;

		    ever = (copy - 2) >> 1;
# if __UNROLL_TRANSFER__
		    deck = ever >> 1;
		    for (; deck; deck--) {
			*fast = *(fast - 2);
			fast -= 2;
			*fast = *(fast - 2);
			fast -= 2;
		    }
		    if (ever & 1) {
			*fast = *(fast - 2);
			fast -= 2;
		    }
# else
		    for (; ever; ever--) {
			*fast = *(fast - 2);
			fast -= 2;
		    }
# endif				/* __UNROLL_TRANSFER__ */
		    {
			*fast = next;
		    }
		}
	    } else {
		*KD(fast) = Lx55555555 | 2;

		fast += copy;

		last = text << (integral_q_bits - copy + 1);

# if __UNROLL_TRANSFER__
		mode = last << 2;
		for (; mode; mode <<= 4) {
		    *fast = *(fast - 2);
		    fast -= 2;
		    *fast = *(fast - 2);
		    fast -= 2;
		}
		if (last & Lx44444444) {
		    *fast = *(fast - 2);
		    fast -= 2;
		}
# else
		for (; last; last <<= 2) {
		    *fast = *(fast - 2);
		    fast -= 2;
		}
# endif				/* __UNROLL_TRANSFER__ */
		{
		    *fast = *(fast - 1);
		}

		{
		    *(file + 1) = next;
		}
	    }
	}
    }

    tier = file;

    file = club;

    head = *land;

    *head = next;

    if (1) {
	if (pipe & Q(1) << integral_q_last) {
	    call = integral_q_bits - 2;
	    club = PD(node)[integral_q_bits - 3];
	    head = KD(node) + integral_q_bits - 2;
	} else {
	    call = integral_q_bits - 3;
	    if (pipe & Q(1) << (integral_q_bits - 3)) {
		club = PD(node)[integral_q_bits - 4];
		head = KD(node) + integral_q_bits - 3;
	    } else {
		club = PD(node)[integral_q_bits - 5];
		head = KD(node) + integral_q_bits - 4;
	    }
	}
    }

    last = *club & ~Lx55555555;
    if (last & (last - 1)) {
#if __HALF_TRANSFER__
	if (1) {
	    integral_q *fast, *side, text;

	    fast = file;

	    l2_q_bitcount(deck, last);
	    deck &= ~1;

	    fast = file;

	    *KD(fast) = Lx55555555 | ((Q(1) << deck) - 1);

	    fast += deck - 1;

	    side = fast - 1;

	    deck >>= 1;

	    ever = deck - 1;
	    for (; ever; ever--) {
		*fast = *side;
		side -= 2;
		fast--;
	    }

	    side = club;

	    text = *side;

	    side += integral_q_bits;

	    while (deck & ~1) {
		if (text & Q(1) << integral_q_last) {
		    side--;
		    *fast = *side;
		    fast--;
		    side--;
		    *fast = *side;
		    fast--;

		    deck -= 2;
		} else {
		    deck--;

		    side -= 2;
		    *fast = *side;
		    fast--;
		}

		text <<= 2;
	    }
	    if (deck) {
		if (text & Q(1) << integral_q_last) {
		    side--;
		    *fast = *side;

		    side--;

		    *head = *fast;

		    fast = club + integral_q_bits - 2;

		    text <<= 1;
		} else {
		    side -= 2;
		    *fast = *side;

		    side--;

		    *head = *fast;

		    fast = club + integral_q_bits - 2;

		    text <<= 2;

		    if (side < fast) {
			if (text & Q(1) << integral_q_last) {
			    *fast = *side;
			    fast -= 2;
			}

			side--;

			text <<= 1;
		    }
		}
	    } else {
		side--;

		*head = *(fast + 1);

		fast = club + integral_q_bits - 2;

		if (side < fast) {
		    if (text & Q(1) << integral_q_last) {
			*fast = *side;
			fast -= 2;
		    }

		    side--;

		    text <<= 1;
		}
	    }
	    while (side < fast) {
		if (text & Q(1) << (integral_q_bits - 2)) {
		    *fast = *side;
		    fast -= 2;
		    side--;
		    *fast = *side;
		    fast -= 2;
		    side--;
		} else {
		    *fast = *side;
		    fast -= 2;
		    side -= 2;
		}

		text <<= 2;
	    }

	    *KD(club) &= Lx55555555 | ((Q(1) << (fast - club)) - 1);
	}
#else
	if (1) {
	    integral_q *fast, text;

	    fast = club;

	    text = *fast;
	    if (text & Q(1) << integral_q_last) {
		fast += integral_q_bits;
		next = *(fast - 1);
	    } else {
		fast += integral_q_bits - 2;

		next = *fast;

		text <<= 2;

# if __UNROLL_TRANSFER__
		for (; !(text & Q(10) << (integral_q_bits - 4)); text <<= 4) {
		    *fast = *(fast - 2);
		    fast -= 2;
		    *fast = *(fast - 2);
		    fast -= 2;
		}
		if (!(text & Q(2) << (integral_q_bits - 2))) {
		    *fast = *(fast - 2);
		    fast -= 2;
		}
# else
		for (; !(text & Q(1) << integral_q_last); text <<= 2) {
		    *fast = *(fast - 2);
		    fast -= 2;
		}
# endif				/* __UNROLL_TRANSFER__ */
		{
		    *fast = *(fast - 1);
		}
	    }

	    *KD(club) = (last ^ Q(1) << (fast - club - 1)) | Lx55555555;

	    fast = file;

	    if (1) {
		*KD(fast) = Lx55555555 | 2;

		*(fast + 1) = next;
	    }
	}

	*head = next;
#endif				/* __HALF_TRANSFER__ */
    } else {
	*rate = 1;

	*mile = call;

	*lane = tier;

	*lock = file;

	*land = head;

	*lead = club;
    }

    return 0;
}
