/*
 * bppx.s.c
 * Copyright (C) 2009-2010, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <bpfx-defs.h>
#include <bpfx-lines.h>
#include <bpfx-names.h>
#include <bpfx-types.h>

#undef Q
#define Q(e)				((integral_q) (e))

#define bpfset(bpfset)			((struct bpfset_type *) (bpfset))

int
_libx1f4l2_fold_bppset(void *bpfset, integral_q *club, integral_q *file,
		       integral_q *tier, unsigned pick, unsigned copy,
		       void *node)
{
    int status;
    unsigned deck;

    if (pick) {
	integral_q *fast, *side, text;

	fast = club;

	text = *fast;

	if (text & 2) {
	    if (0) {
		fast += 4;

		side = fast - 1;
	    } else {
		fast += 1;

		side = (integral_q *) node + 1;

		*side = *fast;
		fast++;
		side++;
		*side = *fast;
		fast += 2;
		side++;
	    }

	    deck = half_integral_q_bits - 2;
	    for (; deck; deck--) {
		*side = *fast;
		fast += 2;
		side++;
	    }
	} else {
	    fast += 2;

	    if (0) {
		side = fast - 1;
	    } else {
		side = (integral_q *) node + 1;
	    }

	    {
		*side = *fast;
		fast += 2;
		side++;
	    }

	    text &= ~Lx55555555;

	    text >>= 4;

	    for (; text; text >>= 2) {
		*side = *fast;
		fast += 2;
		side++;
	    }
	    {
		*side = *(fast - 1);
		side++;
	    }

	    deck = (integral_q_bits - (fast - club)) >> 1;
	    for (; deck; deck--) {
		*side = *fast;
		fast += 2;
		side++;
	    }
	}

	fast = file;

	if (copy & 1) {
	    fast += 2;

	    deck = half_integral_q_bits - 1;
	    for (; deck; deck--) {
		*side = *fast;
		fast += 2;
		side++;
	    }
	} else {
	    text = *fast & ~Lx55555555;

	    if (!(text & ((Q(1) << copy) - 1))) {
		fast += 2;

		deck = (copy - 2) >> 1;
		for (; deck; deck--) {
		    *side = *fast;
		    fast += 2;
		    side++;
		}

		fast += 2;

		text >>= copy;

		text >>= 2;

		for (; text; text >>= 2) {
		    *side = *fast;
		    fast += 2;
		    side++;
		}
		{
		    *side = *(fast - 1);
		    side++;
		}

		deck = (file + integral_q_bits - fast) >> 1;
		for (; deck; deck--) {
		    *side = *fast;
		    fast += 2;
		    side++;
		}
	    } else {
		fast += 2;

		text >>= 2;

		for (; text; text >>= 2) {
		    *side = *fast;
		    fast += 2;
		    side++;
		}
		{
		    *side = *(fast - 1);
		    side++;
		}

		deck = (file + copy - fast) >> 1;
		for (; deck; deck--) {
		    *side = *fast;
		    fast += 2;
		    side++;
		}

		fast += 2;

		deck = (integral_q_bits - 2 - copy) >> 1;
		for (; deck; deck--) {
		    *side = *fast;
		    fast += 2;
		    side++;
		}
	    }
	}

	side -= integral_q_bits;

	{
	    int excess;

	    *side = integral_q_bits - 1;

	    bpfset(bpfset)->link_a.fpnews.link_v.rate = 0;

	    status = bpfset(bpfset)->link_m.free
		(bpfset(bpfset)->link_m.data, club);
	    if (status) {
		status = FREE_ERROR;
	    }

	    excess = bpfset(bpfset)->link_m.free
		(bpfset(bpfset)->link_m.data, file);
	    if (excess) {
		status = FREE_ERROR;
	    }
	}
    } else {
	integral_q *fast, *side, text;

	fast = tier;

	text = *fast;

	if (text & Q(1) << integral_q_last) {
	    if (0) {
		fast += integral_q_bits - 4;

		side = fast + 1;
	    } else {
		fast += integral_q_bits - 1;

		side = (integral_q *) node + integral_q_bits - 1;

		*side = *fast;
		fast--;
		side--;
		*side = *fast;
		fast -= 2;
		side--;
	    }

	    deck = half_integral_q_bits - 2;
	    for (; deck; deck--) {
		*side = *fast;
		fast -= 2;
		side--;
	    }
	} else {
	    fast += integral_q_bits - 2;

	    if (0) {
		side = fast + 1;
	    } else {
		side = (integral_q *) node + integral_q_bits - 1;
	    }

	    {
		*side = *fast;
		fast -= 2;
		side--;
	    }

	    text &= ~Lx55555555;

	    text <<= 4;

	    for (; text; text <<= 2) {
		*side = *fast;
		fast -= 2;
		side--;
	    }
	    {
		*side = *(fast + 1);
		side--;
	    }

	    deck = (fast - tier) >> 1;
	    for (; deck; deck--) {
		*side = *fast;
		fast -= 2;
		side--;
	    }
	}

	fast = file;

	if (copy & 1) {
	    fast += integral_q_bits - 2;

	    deck = half_integral_q_bits - 1;
	    for (; deck; deck--) {
		*side = *fast;
		fast -= 2;
		side--;
	    }
	} else {
	    text = *fast & ~Lx55555555;

	    if (!(text & ((Q(1) << copy) - 1))) {
		fast += integral_q_bits - 2;

		text <<= 2;

		for (; text; text <<= 2) {
		    *side = *fast;
		    fast -= 2;
		    side--;
		}
		{
		    *side = *(fast + 1);
		    side--;
		}

		deck = (fast - file - copy) >> 1;
		for (; deck; deck--) {
		    *side = *fast;
		    fast -= 2;
		    side--;
		}

		fast -= 2;

		deck = (copy - 2) >> 1;
		for (; deck; deck--) {
		    *side = *fast;
		    fast -= 2;
		    side--;
		}
	    } else {
		fast += integral_q_bits - 2;

		deck = integral_q_bits - copy;

		text <<= deck;

		deck -= 2;
		deck >>= 1;
		for (; deck; deck--) {
		    *side = *fast;
		    fast -= 2;
		    side--;
		}

		fast -= 2;

		text <<= 2;

		for (; text; text <<= 2) {
		    *side = *fast;
		    fast -= 2;
		    side--;
		}
		{
		    *side = *(fast + 1);
		    side--;
		}

		deck = (fast - file) >> 1;
		for (; deck; deck--) {
		    *side = *fast;
		    fast -= 2;
		    side--;
		}
	    }
	}

	{
	    int excess;

	    *side = integral_q_bits - 1;

	    bpfset(bpfset)->link_a.fpnews.link_v.rate = 0;

	    status = bpfset(bpfset)->link_m.free
		(bpfset(bpfset)->link_m.data, file);
	    if (status) {
		status = FREE_ERROR;
	    }

	    excess = bpfset(bpfset)->link_m.free
		(bpfset(bpfset)->link_m.data, tier);
	    if (excess) {
		status = FREE_ERROR;
	    }
	}
    }

    return status;
}
