/*
 * dfxv.3.c
 * Copyright (C) 2008-2010, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <config.h>

#include <stddef.h>

#include <dfxx-defs.h>
#include <dfxx-inter.h>
#include <dfxx-names.h>
#include <dfxx-types.h>

#if SIZEOF_VOID_P == SIZEOF_LONG
# define integral_q			unsigned long
#else
# define integral_q			unsigned
#endif				/* SIZEOF_VOID_P == SIZEOF_LONG */

#define dflist(dflist)			((struct dflist_type *) (dflist))

int
x1f4_slip_dflist(void *dflist)
{
    int status;
    unsigned size;

    size = dflist(dflist)->link_a.fplist.link_v.size;

    if (!size) {
	status = DECK_ERROR;
    } else {
	struct fpnode_type *fpnode_data, *fpnode_text;

	fpnode_text = dflist(dflist)->link_a.fplist.fplink.fpnode_data[0];

	fpnode_data = fpnode_text->fpnode_case;

	status = dflist(dflist)->link_m.free
	    (dflist(dflist)->link_m.data, fpnode_text);
	if (status) {
	    status = FREE_ERROR;
	} else {
	    --size;

	    if (size) {
		dflist(dflist)->link_a.fplist.fplink.fpnode_data[0] =
		    fpnode_data;

		fpnode_data->fpnode_case = (void *)
		    ((integral_q) fpnode_text
		     ^ (integral_q) fpnode_data->fpnode_case);
	    } else {
		dflist(dflist)->link_a.fplist.fplink.fpnode_data[0] = NULL;
		dflist(dflist)->link_a.fplist.fplink.fpnode_data[1] = NULL;
	    }

	    dflist(dflist)->link_a.fplist.link_v.size = size;
	}
    }

    return status;
}
