/*
 * dfxx.7.c
 * Copyright (C) 2008-2010, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <config.h>

#include <stddef.h>

#include <dfxx-names.h>
#include <dfxx-types.h>

#if SIZEOF_VOID_P == SIZEOF_LONG
# define integral_q			unsigned long
#else
# define integral_q			unsigned
#endif				/* SIZEOF_VOID_P == SIZEOF_LONG */

#define dflist(dflist)			((struct dflist_type *) (dflist))

int
x1f4_lime_dflist(void *dflist, void *back, int (*call) (void *, void *))
{
    int delete;
    struct fpnode_type *fpnode_data;

    fpnode_data = dflist(dflist)->link_a.fplist.fplink.fpnode_data[1];
    if (fpnode_data) {
	struct fpnode_type *fqnode_data = NULL;

	do {
	    delete = call(back, fpnode_data + 1);
	    if (delete) {
		break;
	    }

	    fqnode_data = (void *)
		((integral_q) fqnode_data
		 ^ (integral_q) fpnode_data->fpnode_case);
	    if (fqnode_data) {
	    } else {
		break;
	    }

	    delete = call(back, fqnode_data + 1);
	    if (delete) {
		break;
	    }

	    fpnode_data = (void *)
		((integral_q) fpnode_data
		 ^ (integral_q) fqnode_data->fpnode_case);
	} while (fpnode_data);
    } else {
	delete = 0;
    }

    return delete;
}
