/*
 * l2xy.3.c
 * Copyright (C) 2008-2010, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stddef.h>

#include <l2xx-defs.h>
#include <l2xx-inter.h>
#include <l2xx-names.h>
#include <l2xx-types.h>

#define l2list(l2list)			((struct l2list_type *) (l2list))

int
x1f4_head_l2list(void *l2list, unsigned size, void **push)
{
    int status;
    void *l2node;

    status = l2list(l2list)->link_m.link
	(l2list(l2list)->link_m.data, &l2node,
	 sizeof(struct fpnode_type) + size);
    if (status) {
	status = LINK_ERROR;
    } else {
	struct fpnode_type *fpnode_data;
	unsigned size;

	fpnode_data = l2node;

	size = l2list(l2list)->link_a.fplist.link_v.size;
	if (size) {
	    struct fpnode_type *fpnode_text;

	    fpnode_text = l2list(l2list)->link_a.fplist.fplink.fpnode_data[1];

	    l2list(l2list)->link_a.fplist.fplink.fpnode_data[1] = fpnode_data;

	    fpnode_data->fpnode_data[0] = NULL;
	    fpnode_data->fpnode_data[1] = fpnode_text;

	    fpnode_text->fpnode_data[0] = fpnode_data;

	    l2list(l2list)->link_a.fplist.link_v.size = size + 1;
	} else {
	    l2list(l2list)->link_a.fplist.link_v.size = 1;

	    fpnode_data->fpnode_data[0] = NULL;
	    fpnode_data->fpnode_data[1] = NULL;

	    l2list(l2list)->link_a.fplist.fplink.fpnode_data[0] = fpnode_data;
	    l2list(l2list)->link_a.fplist.fplink.fpnode_data[1] = fpnode_data;
	}

	*push = fpnode_data + 1;
    }

    return status;
}
