/*
 * l4xx-list.h
 * Copyright (C) 2008-2009, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <config.h>

#ifndef __LIBx1f4_l4xx_list_H__
#define __LIBx1f4_l4xx_list_H__

#define COUNT_LIST(list_data, stride, scale, this) \
    {									      \
	while (1) {							      \
	    (list_data) = (list_data)->scale;				      \
	    if (!(list_data)) {						      \
		break;							      \
	    } else {							      \
		(this)++;						      \
	    }								      \
	}								      \
    }

#define SHIFT_LIST(list_data, stride, scale, this) \
    {									      \
	while ((this)) {						      \
	    (list_data) = (list_data)->scale;				      \
	    (this)--;							      \
	}								      \
    }

#define SCALE_LIST(list_data, stride, scale, this) \
    {									      \
	while ((stride) < (this)) {					      \
	    struct list64_type *next_list;				      \
									      \
	    next_list = (list_data)->scale;				      \
	    if (!next_list) {						      \
		break;							      \
	    } else {							      \
		(list_data) = next_list;				      \
		(this) -= (stride);					      \
	    }								      \
	}								      \
    }

#define TRACK_LIST(list_data, stride, scale, this) \
    {									      \
	while (1) {							      \
	    struct list64_type *next_list;				      \
									      \
	    next_list = (list_data)->scale;				      \
	    if (!next_list) {						      \
		break;							      \
	    } else {							      \
		(list_data) = next_list;				      \
		(this) += (stride);					      \
	    }								      \
	}								      \
    }

#endif				/* __LIBx1f4_l4xx_list_H__ */
