/*
 * l4xx.1.c
 * Copyright (C) 2008-2009, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <config.h>

#include <l4xx-defs.h>
#include <l4xx-types.h>

static int fini_list(struct l4list_type *);

static int
fini_list(struct l4list_type *l4list_data)
{
    int (*free) (void *, void *), status;
    struct list64_type *list64_data;
    void *data;

    list64_data = l4list_data->link_a.list88.head64_data;

    data = l4list_data->link_m.data;
    free = l4list_data->link_m.free;

    while (1) {
	struct list64_type *free64_list;

	free64_list = list64_data->next_1;
	status = free(data, list64_data);
	if (status) {
	    status = FREE_ERROR;

	    break;
	} else {
	    if (!free64_list) {
		status = 0;

		break;
	    } else {
		list64_data = free64_list->next_1;
		status = free(data, free64_list);
		if (status) {
		    status = FREE_ERROR;

		    break;
		} else {
		    if (!list64_data) {
			status = 0;

			break;
		    }
		}
	    }
	}
    }

    return status;
}


int
x1f4_fini_l4list(void **l4list)
{
    int status;
    struct l4list_type *l4list_data;

    l4list_data = *l4list;

    if (l4list_data->link_a.list88.count) {
	status = fini_list(l4list_data);
    } else {
	status = 0;
    }
    if (1) {
	int excess;

	excess = l4list_data->link_m.free
	    (l4list_data->link_m.data, l4list_data);
	if (excess) {
	    if (status) {
	    } else {
		status = FREE_ERROR;
	    }
	}
    }

    return status;
}
