/*
 * l4xx.3.c
 * Copyright (C) 2008-2009, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <config.h>

#include <l4xx-defs.h>
#include <l4xx-inter.h>
#include <l4xx-types.h>

static int peek_list(struct l4list_type *, unsigned, void **);

static int
peek_list(struct l4list_type *l4list_data, unsigned index, void **peek)
{
    void *list64;

    _libx1f4l2_seek_l4list(l4list_data, index, &list64);

    *peek = ((struct list64_type *) list64) + 1;

    return 0;
}


int
x1f4_peek_l4list(void *l4list, unsigned index, void **peek)
{
    int status;

    if (index < ((struct l4list_type *) l4list)->link_a.list88.count) {
	status = peek_list(l4list, index, peek);
    } else {
	status = DECK_ERROR;
    }

    return status;
}
