/*
 * l4xx.9.c
 * Copyright (C) 2008-2009, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stddef.h>

#include <l4xx-inter.h>
#include <l4xx-types.h>

#define l4list(l4list)			((struct l4list_type *) (l4list))

static int deck_list(struct l4list_type *, unsigned);

static int
deck_list(struct l4list_type *l4list_data, unsigned index)
{
    unsigned deck;
    struct list64_type *land64_data, *post64_data;
    void *list64;

    land64_data = l4list_data->link_a.list88.tail64_data;
    post64_data = l4list_data->link_a.list88.head64_data;

    post64_data->last_1 = land64_data;
    land64_data->next_1 = post64_data;

    land64_data = land64_data->last_0->next_1;

    deck = l4list_data->link_a.list88.stride;
    for (; deck; deck--) {
	land64_data->next_7 = post64_data;
	post64_data->last_0 = land64_data;
	post64_data = post64_data->next_1;
	land64_data = land64_data->next_1;
    }

    _libx1f4l2_seek_l4list(l4list_data, index, &list64);

    l4list_data->link_c.class = 0;
    l4list_data->link_c.list64_data = list64;

    land64_data = list64;
    post64_data = land64_data->last_1;

    l4list_data->link_a.list88.head64_data = land64_data;
    l4list_data->link_a.list88.tail64_data = post64_data;

    land64_data->last_1 = NULL;
    post64_data->next_1 = NULL;

    deck = l4list_data->link_a.list88.stride;
    for (; deck; deck--) {
	land64_data->last_0 = NULL;
	land64_data = land64_data->next_1;
	post64_data->next_7 = NULL;
	post64_data = post64_data->last_1;
    }

    return 0;
}


int
x1f4_deck_l4list(void *l4list, int class)
{
    unsigned count;

    count = l4list(l4list)->link_a.list88.count;

    if (!count) {
    } else {
	class %= (int) count;
	if (class) {
	    if (class < 0) {
		class += count;
	    }

	    deck_list(l4list, class);
	}
    }

    return 0;
}
