/*
 * l4xx.c.c
 * Copyright (C) 2008-2009, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <l4xx-defs.h>
#include <l4xx-inter.h>
#include <l4xx-types.h>

int
x1f4_line_l4list(struct l4list_type *l4list_data,
		 struct l4list_type *l4list_text,
		 int (*size) (void *, unsigned *, const void *),
		 int (*copy) (void *, void *, const void *),
		 int (*free) (void *, void *), void *context)
{
    int status;

    if (l4list_data->link_a.list88.count) {
	status = SIZE_ERROR;
    } else {
	unsigned count;

	count = l4list_text->link_a.list88.count;
	if (!count) {
	    status = 0;
	} else {
	    status = _libx1f4l2_rail_l4list
		(l4list_data, l4list_text, count, size, copy, free, context);
	    if (status) {
	    } else {
		l4list_data->link_c.class = 0;
		l4list_data->link_c.list64_data =
		    l4list_data->link_a.list88.head64_data;
	    }
	}
    }

    return status;
}
