/*
 * lsaf.5.c
 * Copyright (C) 2011-2012, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <string.h>

#include <lsas-class.h>
#include <lsas-defs.h>
#include <lsas-names.h>
#include <lsas-inter.h>
#include <lsas-types.h>

#define lsnote(lsnote)			((struct lsnote_type *) (lsnote))

int
x1f4_find_lsbill(void *lsnote, const unsigned char *name, unsigned size,
		 void **find)
{
    int status = 0;
    unsigned bits, head = 0, hope = 0, *near, rate;
    void *node;

    bits = size << 3;

    node = lsnote(lsnote)->link_a.fplist.fpnode;

    rate = lsnote(lsnote)->link_a.fplist.rate;

    do {
	const byte *copy;
	int Monday = 0, delete;
	unsigned blue = 0, call, *fare, gray = 0, last, lead = 0, left, lock,
	    news, tier;

	delete = 0;

	lock = hope;

	last = hope;

	near = node;
	near = (void *) ((char *) node + *near);

	copy = name + (head >> 3);

	fare = near;

	left = 0;

	call = *near;
	news = (call & ~POINT_SEEK) ^ POINT_CAST;
	while (news < bits) {
	    unsigned down;

	    down = news - lock;
	    if (down) {
		unsigned fine, mind, spin;

		spin = news - head;
		if (spin & ~7) {
		    if (32 < down) {
			do {
			    /*
			     * maintaining _last_ seems to serve little
			     * purpose. it just needs not match _lock_.
			     */
			    if (call & POINT_SEEK) {
				near = X2ND(node, near);
				last = news;
			    } else {
				last = news + 1;
				near = (void *)
				    ((char *) node
				     + (near[1]
					>> (class_pick(name, news) << 4)
					& 65535));
			    }

			    call = *near;
			    news = (call & ~POINT_SEEK) ^ POINT_CAST;
			} while (news < bits);

			break;
		    } else {
			fine = news & ~7;
			do {
			    head += 8;
			    lead <<= 8;
			    lead |= *copy++;
			} while (head < fine);

			spin = news & 7;
		    }
		}

		mind = lead << spin;
		mind |= *copy >> (8 - spin);

		fine = near[2];
		if (mind ^ fine) {
		    tier = mind < fine ? 1 : 0;

		    delete = 1;

		    break;
		}

		lock = news;

		if (call & POINT_SEEK) {
		    left = near[1];
		    gray = lock;
		    near = (void *) ((char *) node + L2ND(left));
		    S1ST(left);
		} else {
		    if (*copy >> (7 - spin) & 1) {
			left = near[1];
			gray = lock;
			near = (void *) ((char *) node + L2ND(left));
			S1ST(left);
		    } else {
			blue = lock;
			near = X1ST(node, near);
		    }

		    lock++;
		}
	    } else {
		if (call & POINT_SEEK) {
		    left = near[1];
		    gray = news;
		    near = (void *) ((char *) node + L2ND(left));
		    S1ST(left);
		} else {
		    lock++;

		    if (class_pick(name, news)) {
			left = near[1];
			gray = news;
			near = (void *) ((char *) node + L2ND(left));
			S1ST(left);
		    } else {
			blue = news;
			near = X1ST(node, near);
		    }
		}
	    }

	    last = lock;

	    fare = near;

	    call = *near;
	    news = (call & ~POINT_SEEK) ^ POINT_CAST;
	}

	if (delete) {
	} else {
	    if (call & POINT_CAST) {
		if (lock + 32 < news) {
		    do {
			/*
			 * maintaining _last_ seems to serve little purpose.
			 * it just needs not match _lock_.
			 */
			news = point_rate(call);

			last = news;
			last += seek_bit(call) ^ 1;

			near = X1ST(node, near);

			call = *near;
		    } while (call & POINT_CAST);
		} else {
		    unsigned fine;

		    fine = news - bits;
		    if (fine == 32) {
			Monday = 1;
			delete = 1;

			tier = 1;
		    } else {
			unsigned dana, mind;

			while (head < bits) {
			    head += 8;
			    lead <<= 8;
			    lead |= *copy++;
			}

			mind = lead << (news - bits);

			dana = ~((1u << fine) - 1);

			fine = near[2];

			if ((mind ^ fine) & dana) {
			    tier = mind < fine ? 1 : 0;

			    delete = 1;
			} else {
			    Monday = 1;
			    delete = 1;

			    if (call & POINT_SEEK) {
				if (bits == news) {
				    status = 1;

				    near = X1ST(node, near);

				    delete = 1;
				} else {
				    tier = 1;
				}
			    } else {
				tier = 1;
			    }
			}
		    }
		}
	    }
	}

	if (delete) {
	    if (status) {
		break;
	    }
	} else {
	    if (lock ^ last) {
	    } else {
		if (lock < bits) {
		    unsigned edge, fine, mind, trap;

		    fine = near[1];

		    lock += fine >> 24;
		    if (bits < lock) {
			lock = bits;
		    }

#if 1
		    while (head < lock) {
			head += 8;
			lead <<= 8;
			lead |= *copy++;
		    }
#else
		    trap = lock - head;
		    if (trap < 17) {
			if (trap < 9) {
			    if (trap) {
				head += 8;
				lead <<= 8;
				lead |= *copy++;
			    }
			} else {
			    head += 16;
			    lead <<= 8;
			    lead |= *copy++;
			    lead <<= 8;
			    lead |= *copy++;
			}
		    } else {
			if (trap < 25) {
			    head += 24;
			    lead <<= 8;
			    lead |= *copy++;
			    lead <<= 8;
			    lead |= *copy++;
			    lead <<= 8;
			    lead |= *copy++;
			} else {
			    trap += 7;
			    trap &= ~7;
			    head += trap;
			    copy += (trap >> 3) - 4;
			    lead <<= 8;
			    lead |= *copy++;
			    lead <<= 8;
			    lead |= *copy++;
			    lead <<= 8;
			    lead |= *copy++;
			    lead <<= 8;
			    lead |= *copy++;
			}
		    }
#endif				/* 0 */

		    edge = last + 24;

		    mind = lead;
		    if (edge < head) {
			mind >>= head - edge;
		    } else {
			mind <<= edge - head;
		    }

		    trap = (1 << 24) - (1 << (edge - lock));

		    mind &= trap;

		    fine &= trap;

		    if (mind ^ fine) {
			tier = mind < fine ? 1 : 0;

			delete = 1;
		    } else {
			if (bits ^ lock) {
			    if ((call << 3) == lock) {
				Monday = 1;
				delete = 1;

				if (1) {
				    tier = 0;
				}
			    }
			} else {
			    if ((call << 3) == bits) {
				status = 1;

				delete = 1;

				break;
			    } else {
				Monday = 1;
				delete = 1;

				if (1) {
				    tier = 1;
				}
			    }
			}
		    }
		} else {
		    if ((call << 3) == bits) {
			status = 1;

			delete = 1;

			if (1) {
			    break;
			}
		    } else {
			Monday = 1;
			delete = 1;

			if (1) {
			    tier = 1;
			}
		    }
		}
	    }
	}

	if (delete) {
	    if (rate) {
	    } else {
		break;
	    }
	} else {
	    unsigned club;

	    class_miss(size, name, *near,
		       ((struct fpcase_type *) near)->data[0], lock >> 3, club,
		       tier, 1, class_line);

	    if (rate) {
	    } else {
		break;
	    }

#if 0
	    class_fill(*near, near[1], last,
		       ((struct fpcase_type *) near)->data[0]);
#endif				/* 0 */

	    near = fare;
	    for (;;) {
		call = *near;
		if (call & POINT_CAST) {
		    unsigned news;

		    news = point_rate(call);
		    if (club < news) {
			break;
		    } else {
			if (call & POINT_SEEK) {
			    left = F1ST(near);
			    gray = news;
			    near = X2ND(node, near);
			} else {
			    if (class_pick(name, news)) {
				left = F1ST(near);
				gray = news;
				near = X2ND(node, near);
			    } else {
				blue = news;
				near = X1ST(node, near);
			    }
			}
		    }
		} else {
		    break;
		}
	    }
	}

	if (tier) {
	    if (left) {
		near = (void *) ((char *) node + left);

		blue = gray;

		call = *near;
		while (call & POINT_CAST) {
		    near = X2ND(node, near);
		    call = *near;
		}

		node = ((struct fpcase_type *) near)->data[1];
	    } else {
		struct fpcase_type *fpcase_data;

		fpcase_data = (void *)
		    ((char *) node
		     + (lead_switch * lsnote(lsnote)->link_a.fplist.call));

		blue = 0;

		node = fpcase_data->data[1];
	    }
	} else {
	    if (call & POINT_CAST) {
		do {
		    near = X2ND(node, near);
		    call = *near;
		} while (call & POINT_CAST);
	    } else {
	    }

	    node = ((struct fpcase_type *) near)->data[1];
	}

	if (blue) {
	    hope = blue;
	}

	rate--;

	delete = hope - 32;
	head = delete & ~(delete >> 31);
	head &= ~7;
    } while (1);

    if (status) {
	*find = (char *) ((struct fpcase_type *) near)->data[0]
	    + vert_noir(*near);
    }

    return status;
}
