/*
 * lsaf.m.c
 * Copyright (C) 2011-2012, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stddef.h>

#include <lsas-class.h>
#include <lsas-defs.h>
#include <lsas-inter.h>
#include <lsas-names.h>
#include <lsas-types.h>

#define lsnote(lsnote)			((struct lsnote_type *) (lsnote))

static int join_bill(void *, void *, const byte *, unsigned);

static int
join_bill(void *node, void *pass, const byte *name, unsigned size)
{
    byte *text;
    int Monday = 0;
    unsigned call, club, last = 0, *near, rate, tier;

    text = (void *) name;

    near = node;
    near = (void *) ((char *) node + *near);

    size <<= 3;

    call = *near;
    while (call & POINT_CAST) {
	rate = point_rate(call);
	if (rate < size) {
	    if (call & POINT_SEEK) {
		near = (void *) ((char *) node + F2ND(near));
		last = rate;
	    } else {
		last = rate + 1;
		near = (void *)
		    ((char *) node
		     + (near[1]
			>> ((name[rate >> 3] >> (7 - (rate & 7)) & 1) << 4)
			& 65535));
	    }
	} else {
	    if (call & POINT_SEEK) {
		last = rate;
	    } else {
		last = rate + 1;
	    }

	    near = (void *) ((char *) node + F1ST(near));
	}

	call = *near;
    }

    size >>= 3;

    class_ware(size, name, call, ((struct fpcase_type *) near)->data[0],
	       club, tier);

    if (0) {
    } else {
	struct fpcase_type *fpcase_data;
	unsigned *dana, deck, *fail, mind, pick = 0, side, slip, wide;

	if (0) {
	} else {
	    class_fill(*near, near[1], last,
		       ((struct fpfast_type *) near)->data[0]);
	}

	near = node;

	deck = *(near + 1);

	dana = (void *) ((char *) node + deck);

	mind = *dana;

	fpcase_data = (void *) ((char *) node + mind);

	fail = (void *) fpcase_data;

	near[1] = *fail;

	fpcase_data->data[0] = text;

	fpcase_data->data[1] = pass;

	*fail = size;

	if (Monday) {
	    side = club;
	} else {
	    side = club + 1;
	}

	class_nine(name, size, side, fail);

	slip = frame_rate(club);

	class_find(name, club, dana);

	if (Monday) {
	    slip |= POINT_SEEK;
	}

	dana[0] = slip;

	fail = node;

	wide = *fail;

	near = (void *) ((char *) node + wide);
	for (;;) {
	    call = *near;

	    if (call & POINT_CAST) {
		rate = point_rate(call);
		if (club < rate) {
		    break;
		} else {
		    if (club == rate) {
			if (slip & POINT_SEEK) {
			    break;
			}
		    }

		    fail = near;
		    if (call & POINT_SEEK) {
			pick = 1;
			wide = F2ND(near);
			last = rate;
		    } else {
			pick = text[rate >> 3] >> (7 - (rate & 7)) & 1;
			wide = near[1] >> (pick << 4) & 65535;
			last = rate + 1;
		    }

		    near = (void *) ((char *) node + wide);
		}
	    } else {
		break;
	    }
	}

	if (fail == node) {
	    fail[0] = deck;
	} else {
	    if (pick) {
		fail[1] &= 65535;
		fail[1] |= deck << 16;
	    } else {
		fail[1] &= ~65535;
		fail[1] |= deck;
	    }
	}

	if (tier) {
	    dana[1] = mind | wide << 16;
	} else {
	    dana[1] = mind << 16 | wide;
	}

	class_rail(node, wide, side - last);
    }

    return 0;
}


int
_libx1f4l2_join_lsbill(void *lsnote, void *node, void *pass, const byte *name,
		   unsigned size, unsigned take)
{
    int status;

    if (take) {
	take--;
	if (take) {
	    status = _libx1f4l2_gray_lsbill
		(lsnote, lsnote(lsnote)->link_a.fplist.fvnode[take][0], node,
		 pass, name, size, take);
	} else {
	    if (lsnote(lsnote)->link_a.fplist.fvnode[0][0]) {
		status = _libx1f4l2_gray_lsbill
		    (lsnote, lsnote(lsnote)->link_a.fplist.fvnode[take][0],
		     node, pass, name, size, take);
	    } else {
		status = _libx1f4l2_blue_lsbill(lsnote, pass, name, size);
	    }
	}
    } else {
	status = join_bill(node, pass, name, size);
    }

    return status;
}
