/*
 * lsaf.r.c
 * Copyright (C) 2011-2012, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <lsas-class.h>
#include <lsas-defs.h>
#include <lsas-names.h>
#include <lsas-types.h>

#define beta_type			quarter_type

int
_libx1f4l2_else_lsbill(struct beta_type *beta_data, unsigned lock, void *node,
		       const byte *name, unsigned size, unsigned *scan,
		       void **post)
{
    int status = 0;

    do {
	const byte *copy;
	int Monday = 0, delete;
	unsigned call, club, head, last, late = 0, lead = 0, *near, rate, slip,
	    tier;
	void *sect;

	delete = lock - 32;
	head = delete & ~(delete >> 31);
	head &= ~31;

	delete = 0;

	last = lock;

	near = node;
	near = (void *) ((char *) node + *near);

	copy = name + (head >> 3);

	size <<= 3;

	beta_data->name = name;

	call = *near;
	while (call & POINT_CAST) {
	    rate = point_rate(call);
	    if (rate < size) {
		unsigned down;

		down = rate - lock;
		if (32 < down) {
		} else {
		    if (down) {
			unsigned fine, mind;

			fine = rate & ~7;

			while (head < fine) {
			    head += 8;
			    lead <<= 8;
			    lead |= *copy++;
			}

			fine = rate & 7;
			if (fine) {
			    mind = lead << fine;
			    mind |= *copy >> (8 - fine);
			} else {
			    mind = lead;
			}

			fine = near[2];

			if (mind ^ fine) {
			    tier = mind < fine ? 1 : 0;

			    mind ^= fine;

			    club = rate - down;

			    mind <<= 32 - down;

			    while (!(mind & (unsigned) 15 << 28)) {
				mind <<= 4;
				club += 4;
			    }
			    while (!(mind & (unsigned) 1 << 31)) {
				mind <<= 1;
				club++;
			    }

			    delete = 1;

			    break;
			}

			lock = rate;
		    }

		    lock += seek_bit(call) ^ 1;
		}

		if (call & POINT_SEEK) {
		    late = F2ND(near);

		    last = rate + 0;
		} else {
		    unsigned date;

		    date = name[rate >> 3] >> (7 - (rate & 7)) & 1;
		    late = near[1] >> (date << 4) & 65535;

		    last = rate + 1;
		}

		near = (void *) ((char *) node + late);
	    } else {
		if (lock + 32 < rate) {
		} else {
		    unsigned fine;

		    fine = rate - size;
		    if (fine == 32) {
			Monday = 1;
			delete = 1;

			club = size;

			tier = 1;

			break;
		    } else {
			unsigned dana, mind;

			while (head < size) {
			    head += 8;
			    lead <<= 8;
			    lead |= *copy++;
			}

			mind = lead << (rate - size);

			dana = ~((1u << fine) - 1);

			fine = near[2];

			if ((mind ^ fine) & dana) {
			    unsigned down;

			    down = last + 32 - rate;

			    tier = mind < fine ? 1 : 0;

			    mind ^= fine;

			    mind <<= down;

			    club = last;

			    while (!(mind & (unsigned) 15 << 28)) {
				mind <<= 4;
				club += 4;
			    }
			    while (!(mind & (unsigned) 1 << 31)) {
				mind <<= 1;
				club++;
			    }

			    delete = 1;

			    break;
			} else {
			    Monday = 1;
			    delete = 1;

			    if (call & POINT_SEEK) {
				if (size == rate) {
				    status = EVER_MATCH;

				    delete = 1;

				    near = X1ST(node, near);

				    if (1) {
					break;
				    }
				}
			    }

			    {
				club = size;

				tier = 1;
			    }

			    break;
			}
		    }
		}

		last = rate;
		last += seek_bit(call) ^ 1;

		near = X1ST(node, near);
	    }

	    call = *near;
	}

	if (delete) {
	} else {
	    if (lock ^ last) {
	    } else {
		if (last < size) {
		    unsigned fine, mind;

		    lock += near[1] >> 24;
		    if (size < lock) {
			lock = size;
		    }

		    while (head < lock) {
			head += 8;
			lead <<= 8;
			lead |= *copy++;
		    }

		    mind = lead;
		    if (last + 24 < head) {
			mind >>= head - 24 - last;
		    } else {
			mind <<= last + 24 - head;
		    }

		    mind &= (1 << 24) - 1;

		    fine = near[1] & ((1 << 24) - 1);

		    if ((mind ^ fine) & ~((1 << (last + 24 - lock)) - 1)) {
			tier = mind < fine ? 1 : 0;

			mind ^= fine;

			club = last;

			while (!(mind & (unsigned) 15 << 20)) {
			    mind <<= 4;
			    club += 4;
			}
			while (!(mind & (unsigned) 1 << 23)) {
			    mind <<= 1;
			    club++;
			}

			delete = 1;
		    } else {
			if (size ^ lock) {
			    if ((call << 3) == lock) {
				Monday = 1;
				delete = 1;

				if (1) {
				    club = lock;

				    tier = 0;
				}
			    }
			} else {
			    if ((call << 3) == size) {
				status = EVER_MATCH;

				delete = 1;
			    } else {
				Monday = 1;
				delete = 1;

				if (1) {
				    club = size;

				    tier = 1;
				}
			    }
			}
		    }
		} else {
		    if ((call << 3) == size) {
			status = EVER_MATCH;

			delete = 1;
		    } else {
			Monday = 1;
			delete = 1;

			if (1) {
			    club = last;

			    tier = 1;
			}
		    }
		}
	    }
	}

	if (delete) {
	    if (status) {
		*post = (char *) ((struct fpcase_type *) near)->data[0]
		    + vert_noir(*near);
		if (1) {
		    break;
		}
	    }

	    *scan = (char *) near - (char *) node;
	} else {
	    slip = *near;

	    size >>= 3;

	    sect = ((struct fpfast_type *) near)->data[0];

	    copy = sect;

	    club = size < slip ? size : slip;
	    if (SIZEOF_LONG & (SIZEOF_LONG - 1)) {
	    } else {
		if (((integral_q) copy | (integral_q) name)
		    & (SIZEOF_LONG - 1)) {
		} else {
		    call >>= 8;
		    if (club < call) {
			call = club;
		    }
		    scale(call);
		    if (call) {
			for (; call; call--) {
			    if (*(long *) copy ^ *(const long *) name) {
				break;
			    }

			    copy = (void *) ((long *) copy + 1);
			    name = (const void *) ((const long *) name + 1);
			}

			club -= copy - (byte *) sect;
		    }
		}
	    }
	    for (; club; club--) {
		rate = *copy ^ *name;
		if (rate) {
		    if (1) {
			break;
		    }
		}

		copy++;
		name++;
	    }

	    if (club) {
		if (size < slip) {
		    club = size - club;
		} else {
		    club = slip - club;
		}

		club <<= 3;
		if (rate & 240) {
		} else {
		    club += 4;
		    rate <<= 4;
		}
		if (rate & 192) {
		} else {
		    club += 2;
		    rate <<= 2;
		}
		if (rate & 128) {
		} else {
		    club++;
		}

		tier = *copy << (club & 7) >> 7 & 1;
	    } else {
		if (size ^ slip) {
		    Monday = 1;
		    if (size < slip) {
			club = size << 3;
			tier = 1;
		    } else {
			club = slip << 3;
			tier = 0;
		    }
		} else {
		    *post = (char *) sect + vert_noir(*near);

		    status = EVER_MATCH;

		    if (1) {
			break;
		    }
		}
	    }
	}

	slip = frame_rate(club);

	if (Monday) {
	    slip |= POINT_SEEK;
	}

	beta_data->pick = slip;
	beta_data->side = Monday ? club : club + 1;
	beta_data->tier = tier;
    } while (0);

    return status;
}
