/*
 * lsnote.h
 * Copyright (C) 2011-2012, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __LIBx1f4_LSNOTE_H__
#define __LIBx1f4_LSNOTE_H__

#include <errors.h>
#include <lsas-names.h>

/*
 * attribute bit definitions
 */
#define X1f4_LSNOTE_INNER_MASK		(1u << 0x00)
#define X1f4_LSNOTE_OUTER_MASK		(1u << 0x01)
#define X1f4_LSNOTE_TRANS_MASK		(1u << 0x02)

/*
 * error definitions
 */
#define X1f4_LSNOTE_FREE_ERROR		LIBx1f4L2_FREE_ERROR
#define X1f4_LSNOTE_LINK_ERROR		LIBx1f4L2_LINK_ERROR
#define X1f4_LSNOTE_MODE_ERROR		LIBx1f4L2_MODE_ERROR

/*
 * error definitions (continued)
 */
#define X1f4_LSNOTE_EVER_MATCH		LIBx1f4L2_EVER_MATCH

typedef struct x1f4_lsnote_type {
    unsigned inner, outer;
    void *trans;
} x1f4_lsnote_type;

#if !defined __x1f4_trans_type_defined__
typedef struct x1f4_trans_type {
    int (*free) (void *, void *), (*link) (void *, void **, unsigned),
	(*mode) (void *, void **, unsigned);
    void *context;
} x1f4_trans_type;
#endif				/* !__x1f4_trans_type_defined__ */

#if !defined __x1f4_trans_type_defined__
# define __x1f4_trans_type_defined__
#endif				/* !__x1f4_trans_type_defined__ */

extern int x1f4_fast_lsnote(void *, unsigned, struct x1f4_lsnote_type *);
extern int x1f4_find_lsbill(void *, const char *, unsigned, void **);
extern int x1f4_fini_lsnote(void **);
extern int x1f4_flat_lsnote(void *);
extern int x1f4_init_lsnote(void **, unsigned, struct x1f4_lsnote_type *);

#endif				/* __LIBx1f4_LSNOTE_H__ */
