/*
 * lvxx-inter.h
 * Copyright (C) 2008-2011, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <config.h>

#ifndef __LIBx1f4_lvxx_inter_H__
#define __LIBx1f4_lvxx_inter_H__

#include <lvxx-names.h>
#include <lvxx-types.h>

#define _libx1f4l2_fast_lvlist		x1f4_fast_lvlist
#define _libx1f4l2_fini_lvlist		x1f4_fini_lvlist
#define _libx1f4l2_flat_lvlist		x1f4_flat_lvlist
#define _libx1f4l2_init_lvlist		x1f4_init_lvlist
#define _libx1f4l2_move_lvlist		x1f4_move_lvlist
#define _libx1f4l2_spin_lvlist		x1f4_spin_lvlist

extern int _libx1f4l2_away_lvlist(void *, void *, int (*) (void *, void *));
extern int _libx1f4l2_beta_lvlist(void *, void *);
extern int _libx1f4l2_case_lvlist(void *, unsigned, void *, void **);
extern int _libx1f4l2_ceil_lvlist(void *);
extern int _libx1f4l2_dana_lvlist(void *, void *);
extern int _libx1f4l2_dawn_lvlist
    (void *, void *, void *, int (*) (void *, void *, void *), unsigned);
extern int _libx1f4l2_elif_lvlist
    (void *, void *, int (*) (void *, void *), unsigned, unsigned, void **,
     int (*) (void *, unsigned, void **));
extern int _libx1f4l2_else_lvlist(void *, unsigned, void **);
extern int _libx1f4l2_fair_lvlist(void *, unsigned, void *, unsigned);
extern int _libx1f4l2_fast_lvlist(void *, unsigned, struct screen_type *);
extern int _libx1f4l2_fini_lvlist(void **);
extern int _libx1f4l2_flat_lvlist(void *);
extern int _libx1f4l2_here_lvlist(void *, unsigned, void **);
extern int _libx1f4l2_init_lvlist(void **, unsigned, struct screen_type *);
extern int _libx1f4l2_lane_lvlist(void *, unsigned, unsigned);
extern int _libx1f4l2_long_lvlist(void *, void *, int (*) (void *, void *));
extern int _libx1f4l2_lose_lvlist(void *, unsigned, void **);
extern int _libx1f4l2_moon_lvlist(void *, unsigned, void *);
extern int _libx1f4l2_move_lvlist(void *, unsigned, unsigned);
extern int _libx1f4l2_nand_lvlist
    (void *, unsigned, void *, int (*) (void *, void *));
extern int _libx1f4l2_rail_lvlist
    (void *, void *, int (*) (void *, unsigned *, const void *),
     int (*) (void *, void *, const void *), int (*) (void *, void *), void *);
extern int _libx1f4l2_spin_lvlist(void *, unsigned, unsigned);
extern int _libx1f4l2_wave_lvlist
    (void *, void *, void *, int (*) (void *, void *));

#endif				/* __LIBx1f4_lvxx_inter_H__ */
