/*
 * ncxx-inter.h
 * Copyright (C) 2008-2010, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <config.h>

#ifndef __LIBx1f4_ncxx_inter_H__
#define __LIBx1f4_ncxx_inter_H__

#include <ncxx-names.h>
#include <ncxx-types.h>

#if !defined _libx1f4l2_fast_nclist
# define _libx1f4l2_fast_nclist		x1f4_fast_nclist
#endif				/* !_libx1f4l2_fast_nclist */
#if !defined _libx1f4l2_fini_nclist
# define _libx1f4l2_fini_nclist		x1f4_fini_nclist
#endif				/* !_libx1f4l2_fini_nclist */
#if !defined _libx1f4l2_flat_nclist
# define _libx1f4l2_flat_nclist		x1f4_flat_nclist
#endif				/* !_libx1f4l2_flat_nclist */
#if !defined _libx1f4l2_init_nclist
# define _libx1f4l2_init_nclist		x1f4_init_nclist
#endif				/* !_libx1f4l2_init_nclist */
#if !defined _libx1f4l2_move_nclist
# define _libx1f4l2_move_nclist		x1f4_move_nclist
#endif				/* !_libx1f4l2_move_nclist */
#if !defined _libx1f4l2_spin_nclist
# define _libx1f4l2_spin_nclist		x1f4_spin_nclist
#endif				/* !_libx1f4l2_spin_nclist */

extern int _libx1f4l2_away_nclist(void *, void *, int (*) (void *, void *));
extern int _libx1f4l2_beta_nclist(void *, void *);
extern int _libx1f4l2_blue_nclist(void *, void *, unsigned *);
extern int _libx1f4l2_case_nclist(void *, unsigned, void *, void **);
extern int _libx1f4l2_ceil_nclist(void *);
extern int _libx1f4l2_dana_nclist(void *, void *);
extern int _libx1f4l2_dawn_nclist
    (void *, void *, void *, int (*) (void *, void *, void *), unsigned);
extern int _libx1f4l2_elif_nclist
    (void *, void *, int (*) (void *, void *), unsigned, unsigned, void **,
     int (*) (void *, unsigned, void **));
extern int _libx1f4l2_else_nclist(void *, unsigned, void **);
extern int _libx1f4l2_fair_nclist(void *, unsigned, void *, unsigned);
extern int _libx1f4l2_fast_nclist(void *, unsigned, struct screen_type *);
extern int _libx1f4l2_fini_nclist(void **);
extern int _libx1f4l2_flat_nclist(void *);
extern int _libx1f4l2_half_nclist(void *, unsigned char **, unsigned *);
extern int _libx1f4l2_here_nclist(void *, unsigned, void **);
extern int _libx1f4l2_init_nclist(void **, unsigned, struct screen_type *);
extern int _libx1f4l2_lane_nclist(void *, unsigned, unsigned);
extern int _libx1f4l2_long_nclist(void *, void *, int (*) (void *, void *));
extern int _libx1f4l2_lose_nclist(void *, unsigned, void **);
extern int _libx1f4l2_moon_nclist(void *, unsigned, void *);
extern int _libx1f4l2_move_nclist(void *, unsigned, unsigned);
extern int _libx1f4l2_nand_nclist
    (void *, unsigned, void *, int (*) (void *, void *));
extern int _libx1f4l2_rail_nclist
    (void *, void *, int (*) (void *, unsigned *, const void *),
     int (*) (void *, void *, const void *), int (*) (void *, void *), void *);
extern int _libx1f4l2_spin_nclist(void *, unsigned, unsigned);

#endif				/* __LIBx1f4_ncxx_inter_H__ */
