/*
 * ncxx.3.c
 * Copyright (C) 2008-2011, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stddef.h>

#include <ncxx-names.h>
#include <ncxx-types.h>

#define nclist(nclist)			((struct nclist_type *) (nclist))

static int flow_list(struct fpnode_type *);
static int lock_list(struct fpnode_type *, unsigned *, unsigned *);

static int
flow_list(struct fpnode_type *fpnode_data)
{
    unsigned flow, mail;

    return lock_list(fpnode_data, &flow, &mail);
}


static int
lock_list(struct fpnode_type *fpnode_data, unsigned *fast, unsigned *mail)
{
    int status;

    do {
	struct fpnode_type *fqnode_data;
	unsigned last, next, size = 1;

	fqnode_data = fpnode_data->fpnode_data[0];
	if (fqnode_data) {
	    unsigned fast;

	    status = lock_list(fqnode_data, &fast, &last);
	    if (status) {
		break;
	    } else {
		size += fast;
		if (0) {
		} else {
		    if (fast == fpnode_data->fqnode.size) {
		    } else {
			status = 2;
			if (1) {
			    break;
			}
		    }
		}
	    }
	} else {
	    last = 0;
	    if (1) {
		if (0) {
		} else {
		    if (fpnode_data->fqnode.size) {
			status = 2;
			if (1) {
			    break;
			}
		    }
		}
	    }
	}

	fqnode_data = fpnode_data->fpnode_data[1];
	if (fqnode_data) {
	    unsigned fast;

	    status = lock_list(fqnode_data, &fast, &next);
	    if (status) {
		break;
	    } else {
		size += fast;
		if (0) {
		}
	    }
	} else {
	    next = 0;
	    if (1) {
		if (0) {
		}
	    }
	}

	status = 0;

	if (last ^ next) {
	    if (last < next) {
		if (fpnode_data->fqnode.tilt ^ 1) {
		    status = 5;
		    if (1) {
			break;
		    }
		}

		*mail = next + 1;
	    } else {
		if (fpnode_data->fqnode.tilt ^ -1) {
		    status = 4;
		    if (1) {
			break;
		    }
		}

		*mail = last + 1;
	    }
	} else {
	    if (fpnode_data->fqnode.tilt) {
		status = 3;
		if (1) {
		    break;
		}
	    }

	    *mail = next + 1;
	}

	*fast = size;
    } while (0);

    return status;
}


int
x1f4_flow_nclist(void *nclist)
{
    int status;
    struct fpnode_type *fpnode_data;

    fpnode_data = nclist(nclist)->link_a.fplist.fplink.fpnode_data[0];
    if (!fpnode_data) {
	if (nclist(nclist)->link_a.fplist.fplink.fqnode.size) {
	    status = 1;
	} else {
	    status = 0;
	}
    } else {
	status = flow_list(fpnode_data);
    }

    return status;
}
