/*
 * ncxx.e.c
 * Copyright (C) 2008-2010, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <ncxx-defs.h>
#include <ncxx-inter.h>
#include <ncxx-names.h>
#include <ncxx-types.h>

#define nclist(nclist)			((struct nclist_type *) (nclist))

static int wind_list(struct nclist_type *, unsigned, struct nclist_type *,
		     unsigned);

static int
wind_list(struct nclist_type *nclist_data, unsigned index,
	  struct nclist_type *nclist_text, unsigned class)
{
    int status;
    void *ncnode;

    status = _libx1f4l2_lose_nclist(nclist_data, index, &ncnode);
    if (status) {
    } else {
	nclist_data->link_a.fplist.fplink.fqnode.size--;

	status = _libx1f4l2_moon_nclist(nclist_text, class, ncnode);
	if (status) {
	    /*
	     * TODO/FEATURES
	     *
	     * some leakage here...
	     */
	} else {
	    nclist_text->link_a.fplist.fplink.fqnode.size++;
	}
    }

    return status;
}


int
x1f4_wind_nclist(void *tcdata, unsigned index, void *tctext, unsigned class)
{
    int status;

    if (tcdata == tctext) {
	status = _libx1f4l2_move_nclist(tcdata, index, class);
    } else {
	if (!(index < nclist(tcdata)->link_a.fplist.fplink.fqnode.size)) {
	    status = DECK_ERROR;
	} else {
	    if (nclist(tctext)->link_a.fplist.fplink.fqnode.size < class) {
		status = DECK_ERROR;
	    } else {
		status = wind_list(tcdata, index, tctext, class);
	    }
	}
    }

    return status;
}
