/*
 * ncxx.f.c
 * Copyright (C) 2008-2010, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <ncxx-defs.h>
#include <ncxx-inter.h>
#include <ncxx-names.h>
#include <ncxx-types.h>

#define nclist(nclist)			((struct nclist_type *) (nclist))

int
x1f4_deux_nclist(void *tcdata, unsigned index, void *tctext, unsigned class)
{
    int status;

    if (tcdata == tctext) {
	status = _libx1f4l2_spin_nclist(tcdata, index, class);
    } else {
	if (!(index < nclist(tcdata)->link_a.fplist.fplink.fqnode.size)) {
	    status = DECK_ERROR;
	} else {
	    if (!(class < nclist(tctext)->link_a.fplist.fplink.fqnode.size)) {
		status = DECK_ERROR;
	    } else {
		status = _libx1f4l2_fair_nclist(tcdata, index, tctext, class);
	    }
	}
    }

    return status;
}
