/*
 * ncxy.5.c
 * Copyright (C) 2008-2010, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <ncxx-config.h>

#include <stddef.h>

#include <mask.0.h>
#include <ncxx-defs.h>
#include <ncxx-names.h>
#include <ncxx-types.h>
#include <trans.h>

#if ____ELINK_TARGET__
# define __XLINK_TARGET__		1
#elif __QLINK_TARGET__
# define __XLINK_TARGET__		1
#else
# define __XLINK_TARGET__		0
#endif				/* ____ELINK_TARGET__ */

#define ____XLINK_TARGET__		__XLINK_TARGET__

#if ____XLINK_TARGET__
# define __ZLINK_TARGET__		0
#else
# define __ZLINK_TARGET__		1
#endif				/* ____XLINK_TARGET__ */

#define nclist(nclist)			((struct nclist_type *) (nclist))

#if __QLINK_TARGET__
static int free_ceil(struct nclist_type *);
#endif				/* __QLINK_TARGET__ */
#if __XLINK_TARGET__
static int init_list(struct nclist_type *);
#endif				/* __XLINK_TARGET__ */
#if __QLINK_TARGET__
static int link_ceil(struct nclist_type *);
#endif				/* __QLINK_TARGET__ */
#if __ELINK_TARGET__
static int link_lock(struct nclist_type *);
#endif				/* __ELINK_TARGET__ */

#if __QLINK_TARGET__
static int
free_ceil(struct nclist_type *nclist_data)
{
    int status;
    void *data;

    data = nclist_data->link_c.data;

    if (data) {
	status = nclist_data->link_m.free(nclist_data->link_m.data, data);
	if (status) {
	    status = FREE_ERROR;
	}
    } else {
	status = 0;
    }

    return status;
}
#endif				/* __QLINK_TARGET__ */


#if __XLINK_TARGET__
static int
init_list(struct nclist_type *nclist_data)
{
    int status;
#endif				/* __XLINK_TARGET__ */

#if __QLINK_TARGET__
    status = link_ceil(nclist_data);
    if (status) {
    } else {
#endif				/* __QLINK_TARGET__ */
#if __ELINK_TARGET__
	status = link_lock(nclist_data);
#endif				/* __ELINK_TARGET__ */

#if __QLINK_TARGET__
	if (status) {
	    free_ceil(nclist_data);
	}
    }
#endif				/* __QLINK_TARGET__ */

#if __XLINK_TARGET__
    return status;
}
#endif				/* __XLINK_TARGET__ */


#if __QLINK_TARGET__
static int
link_ceil(struct nclist_type *nclist_data)
{
    int status;
    void *data;

    status = nclist_data->link_m.link(nclist_data->link_m.data, &data, 32);
    if (status) {
	status = LINK_ERROR;
    } else {
	nclist_data->link_c.data = data;
	nclist_data->link_c.size = 0040;
    }

    return status;
}
#endif				/* __QLINK_TARGET__ */


#if __ELINK_TARGET__
static int
link_lock(struct nclist_type *nclist_data)
{
    int status;
    void *data;

    status = nclist_data->link_m.link
	(nclist_data->link_m.data, &data, sizeof(struct fpnode_type *) << 4);
    if (status) {
	status = LINK_ERROR;
    } else {
	nclist_data->link_e.fpmiss = data;
	nclist_data->link_e.seek = 000020;
    }

    return status;
}
#endif				/* __ELINK_TARGET__ */


int
x1f4_fast_nclist(void *nclist, unsigned flags,
		 struct screen_type *screen_data)
{
#if __XLINK_TARGET__
    int status;
#endif				/* __XLINK_TARGET__ */

    if (0) {
    } else {
	nclist(nclist)->link_a.fplist.fplink.fpnode_data[0] = NULL;
	nclist(nclist)->link_a.fplist.fplink.fqnode.size = 0;

#if __QLINK_TARGET__
	if (0) {
	    nclist(nclist)->link_c.data = NULL;
	}
#endif				/* __QLINK_TARGET__ */

#if __ELINK_TARGET__
	if (0) {
	    nclist(nclist)->link_e.fpmiss = NULL;
	}
#endif				/* __ELINK_TARGET__ */

	if (flags & TRANS_MASK) {
	    struct trans_type *trans_data;

	    trans_data = screen_data->trans_data;

	    nclist(nclist)->link_m.data = trans_data->data;
	    nclist(nclist)->link_m.free = trans_data->free;
	    nclist(nclist)->link_m.link = trans_data->link;
	    nclist(nclist)->link_m.mode = trans_data->mode;
	} else {
	    nclist(nclist)->link_m.free = _libx1f4l2_free_data;
	    nclist(nclist)->link_m.link = _libx1f4l2_link_data;
	    nclist(nclist)->link_m.mode = _libx1f4l2_mode_data;
	}

#if __XLINK_TARGET__
	status = init_list(nclist);
	if (status) {
	} else {
	}
#endif				/* __XLINK_TARGET__ */
    }

#if __ZLINK_TARGET__
    return 0;
#else
    return status;
#endif				/* __ZLINK_TARGET__ */
}
