/*
 * ncxy.f.c
 * Copyright (C) 2008-2011, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stddef.h>

#include <ncxx-inter.h>
#include <ncxx-names.h>
#include <ncxx-types.h>

#define nclist(nclist)			((struct nclist_type *) (nclist))

static int sort_list(struct nclist_type *, struct fpnode_type *, void *,
		     unsigned, int (*) (void *, void *, void *));

static int
sort_list(struct nclist_type *nclist_data, struct fpnode_type *fpnode_data,
	  void *text, unsigned slip, int (*land) (void *, void *, void *))
{
    struct fpnode_type *fqnode_data;

    fqnode_data = fpnode_data->fpnode_data[0];

    if (fqnode_data) {
	sort_list(nclist_data, fqnode_data, text, slip, land);
    }

    fqnode_data = fpnode_data->fpnode_data[1];

    _libx1f4l2_dawn_nclist(nclist_data, fpnode_data, text, land, slip);

    nclist_data->link_a.fplist.fplink.fqnode.size++;

    if (fqnode_data) {
	sort_list(nclist_data, fqnode_data, text, slip, land);
    }

    return 0;
}


int
x1f4_sort_nclist(void *nclist, void *text, unsigned slip,
		 int (*land) (void *, void *, void *))
{
    unsigned size;

    size = nclist(nclist)->link_a.fplist.fplink.fqnode.size;
    if (1 < size) {
	void *ncnode;

	ncnode = nclist(nclist)->link_a.fplist.fplink.fpnode_data[0];

	nclist(nclist)->link_a.fplist.fplink.fpnode_data[0] = NULL;
	nclist(nclist)->link_a.fplist.fplink.fqnode.size = 0;

	slip += sizeof(struct fpnode_type);

	sort_list(nclist, ncnode, text, slip, land);
    }

    return 0;
}
