/*
 * nvxx.e.c
 * Copyright (C) 2008-2010, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <nvxx-defs.h>
#include <nvxx-inter.h>
#include <nvxx-names.h>
#include <nvxx-types.h>

#define nvlist(nvlist)			((struct nvlist_type *) (nvlist))

static int wind_list(struct nvlist_type *, unsigned, struct nvlist_type *,
		     unsigned);

static int
wind_list(struct nvlist_type *nvlist_data, unsigned index,
	  struct nvlist_type *nvlist_text, unsigned class)
{
    int status;
    void *nvnode;

    status = _libx1f4l2_lose_nvlist(nvlist_data, index, &nvnode);
    if (status) {
    } else {
	nvlist_data->link_a.fplist.fplink.fqnode.size--;

	status = _libx1f4l2_moon_nvlist(nvlist_text, class, nvnode);
	if (status) {
	    /*
	     * TODO/FEATURES
	     *
	     * some leakage here...
	     */
	} else {
	    nvlist_text->link_a.fplist.fplink.fqnode.size++;
	}
    }

    return status;
}


int
x1f4_wind_nvlist(void *tcdata, unsigned index, void *tctext, unsigned class)
{
    int status;

    if (tcdata == tctext) {
	status = _libx1f4l2_move_nvlist(tcdata, index, class);
    } else {
	if (!(index < nvlist(tcdata)->link_a.fplist.fplink.fqnode.size)) {
	    status = DECK_ERROR;
	} else {
	    if (nvlist(tctext)->link_a.fplist.fplink.fqnode.size < class) {
		status = DECK_ERROR;
	    } else {
		status = wind_list(tcdata, index, tctext, class);
	    }
	}
    }

    return status;
}
