/*
 * nvxy.8.c
 * Copyright (C) 2008-2010, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stddef.h>
#include <stdlib.h>

#include <nvxx-inter.h>
#include <nvxx-names.h>
#include <nvxx-types.h>

#define nvlist(nvlist)			((struct nvlist_type *) (nvlist))

static int rand_list(struct nvlist_type *, struct fpnode_type *);

static int
rand_list(struct nvlist_type *nvlist_data, struct fpnode_type *fpnode_data)
{
    struct fpnode_type *fqnode_data;
    unsigned size;

    fqnode_data = fpnode_data->fpnode_data[0];

    if (fqnode_data) {
	rand_list(nvlist_data, fqnode_data);
    }

    fqnode_data = fpnode_data->fpnode_data[1];

    size = nvlist_data->link_a.fplist.fplink.fqnode.size;

    size++;

    _libx1f4l2_moon_nvlist(nvlist_data, rand() % size, fpnode_data);

    nvlist_data->link_a.fplist.fplink.fqnode.size = size;

    if (fqnode_data) {
	rand_list(nvlist_data, fqnode_data);
    }

    return 0;
}


int
x1f4_rand_nvlist(void *nvlist)
{
    unsigned size;

    size = nvlist(nvlist)->link_a.fplist.fplink.fqnode.size;
    if (1 < size) {
	void *nvnode;

	nvnode = nvlist(nvlist)->link_a.fplist.fplink.fpnode_data[0];

	nvlist(nvlist)->link_a.fplist.fplink.fpnode_data[0] = NULL;
	nvlist(nvlist)->link_a.fplist.fplink.fqnode.size = 0;

	rand_list(nvlist, nvnode);
    }

    return 0;
} 
