/*
 * nvxy.f.c
 * Copyright (C) 2008-2010, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stddef.h>

#include <nvxx-inter.h>
#include <nvxx-names.h>
#include <nvxx-types.h>

#define nvlist(nvlist)			((struct nvlist_type *) (nvlist))

static int sort_list(struct nvlist_type *, struct fpnode_type *, void *,
		     unsigned, int (*) (void *, void *, void *));

static int
sort_list(struct nvlist_type *nvlist_data, struct fpnode_type *fpnode_data,
	  void *text, unsigned slip, int (*land) (void *, void *, void *))
{
    struct fpnode_type *fqnode_data;

    fqnode_data = fpnode_data->fpnode_data[0];

    if (fqnode_data) {
	sort_list(nvlist_data, fqnode_data, text, slip, land);
    }

    fqnode_data = fpnode_data->fpnode_data[1];

    _libx1f4l2_dawn_nvlist(nvlist_data, fpnode_data, text, land, slip);

    nvlist_data->link_a.fplist.fplink.fqnode.size++;

    if (fqnode_data) {
	sort_list(nvlist_data, fqnode_data, text, slip, land);
    }

    return 0;
}


int
x1f4_sort_nvlist(void *nvlist, void *text, unsigned slip,
		 int (*land) (void *, void *, void *))
{
    unsigned size;

    size = nvlist(nvlist)->link_a.fplist.fplink.fqnode.size;
    if (1 < size) {
	void *nvnode;

	nvnode = nvlist(nvlist)->link_a.fplist.fplink.fpnode_data[0];

	nvlist(nvlist)->link_a.fplist.fplink.fpnode_data[0] = NULL;
	nvlist(nvlist)->link_a.fplist.fplink.fqnode.size = 0;

	slip += sizeof(struct fpnode_type);

	sort_list(nvlist, nvnode, text, slip, land);
    }

    return 0;
} 
