/*
 * nvxy.w.c
 * Copyright (C) 2008-2010, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <nvxx-names.h>
#include <nvxx-types.h>

#define nvlist(nvlist)			((struct nvlist_type *) (nvlist))

static int back_node(struct fpnode_type *, unsigned);

static int
back_node(struct fpnode_type *fpnode_data, unsigned size)
{
    struct fpnode_type *fqnode_data, *ftnode_data;

    fqnode_data = fpnode_data->fpnode_data[0];
    if (fqnode_data) {
	unsigned left;

	left = fpnode_data->fqnode.size;

	back_node(fqnode_data, left);

	size -= left;
    }

    size--;

    ftnode_data = fpnode_data->fpnode_data[1];
    if (ftnode_data) {
	back_node(ftnode_data, size);
    }

    fpnode_data->fpnode_data[0] = ftnode_data;

    fpnode_data->fpnode_data[1] = fqnode_data;

    fpnode_data->fqnode.size = size;

    fpnode_data->fqnode.tilt = -fpnode_data->fqnode.tilt;

    return 0;
}


int
x1f4_flip_nvlist(void *nvlist)
{
    struct fpnode_type *fpnode_data;

    fpnode_data = nvlist(nvlist)->link_a.fplist.fplink.fpnode_data[0];
    if (fpnode_data) {
	back_node
	    (fpnode_data, nvlist(nvlist)->link_a.fplist.fplink.fqnode.size);
    }

    return 0;
}
