/*
 * qccc.8.c
 * Copyright (C) 2008-2012, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stddef.h>

#include <qccc-bits.h>
#include <qccc-defs.h>
#include <qccc-inter.h>
#include <qccc-names.h>
#include <qccc-types.h>

#define M_TEXT(___v, ___t) \
    ((void *) ((char *) (___v) + (___t)))

#define qcrate(qcrate)			((struct qcrate_type *) (qcrate))

int
x1f4_high_qcrate(void *qcrate)
{
    int status;

    status = _libx1f4l2_ceil_qcrate(qcrate);
    if (status) {
    } else {
	qcrate(qcrate)->link_e.fplink_data = NULL;
	qcrate(qcrate)->link_e.fplink_text = NULL;

	if (qcrate(qcrate)->link_a.fplist.rate) {
	    unsigned lock, mall;
	    void *data;

	    data = qcrate(qcrate)->link_a.fplist.fpnode_data;

	    lock = qcrate(qcrate)->link_a.fplist.lock;
	    mall = qcrate(qcrate)->link_a.fplist.mall;

	    status = qcrate(qcrate)->link_m.mode
		(qcrate(qcrate)->link_m.data, &data,
		 ((sizeof(unsigned) << 1) + mall) << lock);
	    if (status) {
		status = MODE_ERROR;
	    } else {
		qcrate(qcrate)->link_a.fplist.rate = 0;

		_libx1f4l2_type_qcrate(data, 1 << lock, mall);

		S_NODE(M_TEXT(data, sizeof(unsigned)), 0);

		if (1) {
		    qcrate(qcrate)->link_a.fplist.fpnode_data = data;
		}
	    }
	}
    }

    return status;
}
