/*
 * qccc.h.c
 * Copyright (C) 2010-2011, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <qccc-bits.h>
#include <qccc-defs.h>
#include <qccc-inter.h>
#include <qccc-names.h>
#include <qccc-types.h>

#define M_TEXT(___v, ___t) \
    ((void *) ((char *) (___v) + (___t)))

#define qcrate(qcrate)			((struct qcrate_type *) (qcrate))

int
_libx1f4l2_fall_qcrate(void *qcrate)
{
    int (*link) (void *, void **, unsigned), status;
    unsigned lock, size;
    void *data, *fall;

    lock = qcrate(qcrate)->link_a.fplist.lock;

    data = qcrate(qcrate)->link_m.data;
    link = qcrate(qcrate)->link_m.link;

    size = ((sizeof(unsigned) << 1) + sizeof(void *)) << lock;

    status = link(data, &fall, size);
    if (status) {
	status = LINK_ERROR;
    } else {
	unsigned rate;
	void *mall;

	rate = qcrate(qcrate)->link_a.fplist.rate;

	if (rate) {
	} else {
	    size =
		((sizeof(unsigned) << 1) + qcrate(qcrate)->link_a.fplist.mall)
		<< lock;
	}

	status = link(data, &mall, size);
	if (status) {
	    status = LINK_ERROR;

	    qcrate(qcrate)->link_m.free(data, fall);
	} else {
	    void *node;

	    node = qcrate(qcrate)->link_a.fplist.fpnode_data;

	    if (rate) {
		struct fplink_type *fplink_data;
		unsigned land, size;
		void **lise, *pick;

		fplink_data = mall;
		fplink_data->fplink_data =
		    qcrate(qcrate)->link_e.fplink_data;
		qcrate(qcrate)->link_e.fplink_data = mall;

		_libx1f4l2_type_qcrate(fall, 1 << lock, sizeof(void *));
		size = Q_NODE(M_TEXT(node, sizeof(unsigned)));
		qcrate(qcrate)->link_a.fplist.fpnode_data = fall;
		qcrate(qcrate)->link_a.fplist.rate = rate + 1;
		_libx1f4l2_root_qcrate(fall, &pick);
		lise = pick;
		*lise = node;
		status = _libx1f4l2_gray_qcrate
		    (qcrate, rate, fall, ~0, &land, &pick);
		S_NODE(M_TEXT(fall, sizeof(unsigned)), size);
	    } else {
		unsigned land;
		void **lise, *pick;

		qcrate(qcrate)->link_e.fplink_text = mall;

		_libx1f4l2_type_qcrate(fall, 1 << lock, sizeof(void *));
		qcrate(qcrate)->link_a.fplist.fpnode_data = fall;
		qcrate(qcrate)->link_a.fplist.rate = 1;
		_libx1f4l2_root_qcrate(fall, &pick);
		lise = pick;
		*lise = node;
		status = _libx1f4l2_gray_qcrate
		    (qcrate, rate, fall, ~0, &land, &pick);
		S_NODE(M_TEXT(fall, sizeof(unsigned)), 1 << lock);
	    }
	}
    }

    return status;
}
