/*
 * qccc.j.c
 * Copyright (C) 2008-2011, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <qccc-bits.h>
#include <qccc-names.h>
#include <qccc-types.h>

#define M_TEXT(___v, ___t) \
    ((void *) ((char *) (___v) + (___t)))

int
_libx1f4l2_blue_qcrate(void *node, unsigned violet, unsigned index,
		       void **push)
{
    unsigned epnode, eqnode, eznode, scnode, sfnode;

    epnode = P_ROOT(Q_NODE(node));
    eqnode = 0;

    eznode = eqnode;

#if ____CLASS_INSERT__ == __SLICE_INSERT__
    /*
     * VALUE ASSUMED (for root being recorded as right)
     */
    S_NODE(node, E_SIGN(Q_NODE(node)));
#endif				/* ____CLASS_INSERT__ == __SLICE_INSERT__ */

    while (epnode < violet) {
	unsigned class, ennode, epslip;
	void *lpnode;

	lpnode = M_TEXT(node, epnode);

	if (1) {
	    epslip = Q_NODE(lpnode);

	    class = ((unsigned *) lpnode)[1];
	    if (index < class) {
		ennode = L_LAST(epslip);
		((unsigned *) lpnode)[1] = class + 1;
#if ____CLASS_INSERT__ == __SLICE_INSERT__
		S_NODE(lpnode, F_SIGN(epslip));
#endif				/* ____CLASS_INSERT__ == __SLICE_INSERT__ */
	    } else {
		ennode = L_NEXT(epslip);
		index -= class;
#if ____CLASS_INSERT__ == __SLICE_INSERT__
		S_NODE(lpnode, E_SIGN(epslip));
#endif				/* ____CLASS_INSERT__ == __SLICE_INSERT__ */
	    }

	    if (Q_tilt_odd(epslip)) {
		eznode = eqnode;
	    }

	    if (ennode < violet) {
		lpnode = M_TEXT(node, ennode);

		if (1) {
		    epslip = Q_NODE(lpnode);

		    if (Q_tilt_odd(epslip)) {
			eznode = epnode;
		    }

		    eqnode = ennode;

		    class = ((unsigned *) lpnode)[1];
		    if (index < class) {
			epnode = L_LAST(epslip);
			((unsigned *) lpnode)[1] = class + 1;
#if ____CLASS_INSERT__ == __SLICE_INSERT__
			S_NODE(lpnode, F_SIGN(epslip));
#endif				/* ____CLASS_INSERT__ == __SLICE_INSERT__ */
		    } else {
			epnode = L_NEXT(epslip);
			index -= class;
#if ____CLASS_INSERT__ == __SLICE_INSERT__
			S_NODE(lpnode, E_SIGN(epslip));
#endif				/* ____CLASS_INSERT__ == __SLICE_INSERT__ */
		    }
		}
	    } else {
		eqnode = epnode;
		epnode = ennode;
		if (1) {
		    break;
		}
	    }
	}
    }

    if (0) {
    } else {
	unsigned epslip, exnode;
	void *lcnode, *lsslip;

	epslip = Q_NODE(node);

	scnode = P_LIST(epslip);

	lcnode = M_TEXT(node, scnode);

	sfnode = Q_NODE(lcnode);

	lsslip = M_TEXT(node, sfnode);

	*push = lsslip;

#if ____CLASS_INSERT__ == __SLICE_INSERT__
	S_NODE(node, B_LIST(Q_NODE(lsslip)) | L_SIGN(epslip) | M_ROOT(epslip));
#endif				/* ____CLASS_INSERT__ == __SLICE_INSERT__ */

	S_NODE(M_TEXT(lcnode, sizeof(unsigned)), 1);

	lsslip = M_TEXT(node, eqnode);

	epslip = Q_NODE(lsslip);

	if (index) {
	    S_NODE(lcnode, B_LAST(epnode) | B_NEXT(sfnode) | B_TILT(0));
	} else {
	    S_NODE(lcnode, B_LAST(sfnode) | B_NEXT(epnode) | B_TILT(0));
	}

#if ____CLASS_INSERT__ == __SLICE_INSERT__
	if (L_SIGN(epslip)) {
	    S_NODE(lsslip, E_LAST(epslip) | B_LAST(scnode));
	} else {
	    S_NODE(lsslip, E_NEXT(epslip) | B_NEXT(scnode));
	}
#endif				/* ____CLASS_INSERT__ == __SLICE_INSERT__ */

	lsslip = M_TEXT(node, eznode);

	epslip = Q_NODE(lsslip);
	if (L_SIGN(epslip)) {
	    exnode = L_LAST(epslip);
	} else {
	    exnode = L_NEXT(epslip);
	}

	if (1) {
	    void *lxnode;

	    epnode = exnode;

#if ____CLASS_INSERT__ == __SLICE_INSERT__
	    while (epnode ^ scnode) {
		void *lpnode;

		lpnode = M_TEXT(node, epnode);

		epslip = Q_NODE(lpnode);

		if (L_SIGN(epslip)) {
		    S_NODE(lpnode, V_TILT(epslip));
		    epnode = L_LAST(epslip);
		} else {
		    S_NODE(lpnode, U_TILT(epslip));
		    epnode = L_NEXT(epslip);
		}
	    }
#endif				/* ____CLASS_INSERT__ == __SLICE_INSERT__ */

	    lxnode = M_TEXT(node, exnode);

	    epslip = Q_NODE(lxnode);

	    if (Q_tilt_2m(epslip)) {
		if (1) {
		    unsigned esslip, evnode, ewnode;
		    void *lvnode;

		    evnode = L_LAST(epslip);

		    lvnode = M_TEXT(node, evnode);

		    esslip = Q_NODE(lvnode);

		    if (Q_TILT(esslip, -1)) {
			unsigned emnode;

			ewnode = evnode;
			emnode = L_NEXT(esslip);
			S_NODE(lxnode,
			       B_LAST(emnode) | M_NEXT(epslip) | B_TILT(0));
			S_NODE(lvnode,
			       M_LAST(esslip) | B_NEXT(exnode) | B_TILT(0));
			if (1) {
			    lxnode = M_TEXT(lxnode, sizeof(unsigned));
			    S_NODE(lxnode,
				   Q_NODE(lxnode)
				   - Q_NODE(M_TEXT(lvnode, sizeof(unsigned))));
			}
		    } else {
			unsigned ebnode, ednode, emslip;
			void *lwnode;

			ewnode = L_NEXT(esslip);

			lwnode = M_TEXT(node, ewnode);

			emslip = Q_NODE(M_TEXT(node, ewnode));

			ebnode = L_LAST(emslip);
			ednode = L_NEXT(emslip);
			emslip = M_TILT(emslip);
			S_NODE(lwnode,
			       B_LAST(evnode) | B_NEXT(exnode) | B_TILT(0));
			if (H_TILT(emslip, -1)) {
			    S_NODE(lvnode,
				   M_LAST(esslip) | B_NEXT(ebnode)
				   | B_TILT(0));
			    S_NODE(lxnode,
				   B_LAST(ednode) | M_NEXT(epslip)
				   | B_TILT(1));
			} else {
			    if (H_TILT(emslip, 0)) {
				S_NODE(lvnode,
				       M_LAST(esslip) | B_NEXT(ebnode)
				       | B_TILT(0));
				S_NODE(lxnode,
				       B_LAST(ednode) | M_NEXT(epslip)
				       | B_TILT(0));
			    } else {
				S_NODE(lvnode,
				       M_LAST(esslip) | B_NEXT(ebnode)
				       | B_TILT(-1));
				S_NODE(lxnode,
				       B_LAST(ednode) | M_NEXT(epslip)
				       | B_TILT(0));
			    }
			}
			{
			    lwnode = M_TEXT(lwnode, sizeof(unsigned));
			    S_NODE(lwnode,
				   Q_NODE(lwnode)
				   + Q_NODE(M_TEXT(lvnode, sizeof(unsigned))));
			    lxnode = M_TEXT(lxnode, sizeof(unsigned));
			    S_NODE(lxnode,
				   Q_NODE(lxnode) - Q_NODE(lwnode));
			}
		    }

		    esslip = Q_NODE(M_TEXT(node, eznode));

		    if (exnode == L_LAST(esslip)) {
			S_NODE(lsslip, B_LAST(ewnode) | E_LAST(esslip));
		    } else {
			S_NODE(lsslip, E_NEXT(esslip) | B_NEXT(ewnode));
		    }
		}
	    } else {
		if (Q_tilt_2p(epslip)) {
		    unsigned esslip, evnode, ewnode;
		    void *lvnode;

		    evnode = L_NEXT(epslip);

		    lvnode = M_TEXT(node, evnode);

		    esslip = Q_NODE(lvnode);

		    if (Q_TILT(esslip, 1)) {
			unsigned emnode;

			ewnode = evnode;
			emnode = L_LAST(esslip);
			S_NODE(lxnode,
			       M_LAST(epslip) | B_NEXT(emnode) | B_TILT(0));
			S_NODE(lvnode,
			       B_LAST(exnode) | M_NEXT(esslip) | B_TILT(0));
			if (1) {
			    lvnode = M_TEXT(lvnode, sizeof(unsigned));
			    S_NODE(lvnode,
				   Q_NODE(lvnode)
				   + Q_NODE(M_TEXT(lxnode, sizeof(unsigned))));
			}
		    } else {
			unsigned ebnode, ednode, emslip;
			void *lwnode;

			ewnode = L_LAST(esslip);

			lwnode = M_TEXT(node, ewnode);

			emslip = Q_NODE(M_TEXT(node, ewnode));

			ebnode = L_NEXT(emslip);
			ednode = L_LAST(emslip);
			emslip = M_TILT(emslip);
			S_NODE(M_TEXT(node, ewnode),
			       B_LAST(exnode) | B_NEXT(evnode) | B_TILT(0));
			if (H_TILT(emslip, 1)) {
			    S_NODE(lvnode,
				   B_LAST(ebnode) | M_NEXT(esslip)
				   | B_TILT(0));
			    S_NODE(lxnode,
				   M_LAST(epslip) | B_NEXT(ednode)
				   | B_TILT(-1));
			} else {
			    if (H_TILT(emslip, 0)) {
				S_NODE(lvnode,
				       B_LAST(ebnode) | M_NEXT(esslip)
				       | B_TILT(0));
				S_NODE(lxnode,
				       M_LAST(epslip) | B_NEXT(ednode)
				       | B_TILT(0));
			    } else {
				/*
				 *      x+2                      w.0
				 *     /   \                    /   \
				 *    /     \                  /     \
				 *   /       \                /       \
				 * C.0       v-1            x+0       v+1
				 *          /   \          /   \     /   \
				 *         /     \        /     \   /     \
				 *       w-1     A.0    C.0    NEW *      A.0
				 *      /   \   /   \
				 *    NEW    * *     *
				 *
				 */
				S_NODE(lvnode,
				       B_LAST(ebnode) | M_NEXT(esslip)
				       | B_TILT(1));
				S_NODE(lxnode,
				       M_LAST(epslip) | B_NEXT(ednode)
				       | B_TILT(0));
			    }
			}
			{
			    lvnode = M_TEXT(lvnode, sizeof(unsigned));
			    lwnode = M_TEXT(lwnode, sizeof(unsigned));
			    S_NODE(lvnode,
				   Q_NODE(lvnode) - Q_NODE(lwnode));
			    S_NODE(lwnode,
				   Q_NODE(lwnode)
				   + Q_NODE(M_TEXT(lxnode, sizeof(unsigned))));
			}
		    }

		    esslip = Q_NODE(M_TEXT(node, eznode));

		    if (exnode == L_LAST(esslip)) {
			S_NODE(lsslip, B_LAST(ewnode) | E_LAST(esslip));
		    } else {
			S_NODE(lsslip, E_NEXT(esslip) | B_NEXT(ewnode));
		    }
		} else {
		}
	    }
	}
    }

    return 0;
}
