/*
 * qlcc-bits.h
 * Copyright (C) 2010-2011, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __LIBx1f4_qlcc_bits_H__
#define __LIBx1f4_qlcc_bits_H__

#include <bcount.h>
#include <qlcc-types.h>
#include <reverse.h>
#include <xfs.h>

#if !defined __QLSIZE
# define __QLSIZE			QLSIZE
#endif				/* !__QLSIZE */

#if __QLSIZE == 8
# define ql_bitcount(l4f1_bitcount, l4f1_mode) \
    l2_2_bitcount((l4f1_bitcount), (l4f1_mode))
#elif QLSIZE == 4
# define ql_bitcount(l4f1_bitcount, l4f1_mode) \
    l2_1_bitcount((l4f1_bitcount), (l4f1_mode))
#endif				/* __QLSIZE == 8 */

#if __QLSIZE == 8
# define ql_reverse(l4f1_c) \
    l2_2_reverse((l4f1_c))
#elif QLSIZE == 4
# define ql_reverse(l4f1_c) \
    l2_1_reverse((l4f1_c))
#endif				/* __QLSIZE == 8 */

#if __QLSIZE == 8
# define ql_xfs(l4f1_xxfs, l4f1_mode) \
    l2_2_xfs((l4f1_xxfs), (l4f1_mode))
#elif QLSIZE == 4
# define ql_xfs(l4f1_xxfs, l4f1_mode) \
    l2_1_xfs((l4f1_xxfs), (l4f1_mode))
#endif				/* __QLSIZE == 8 */

#endif				/* __LIBx1f4_qlcc_bits_H__ */
