/*
 * qlcc.k.c
 * Copyright (C) 2008-2012, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <string.h>

#include <qlcc-inter.h>
#include <qlcc-names.h>
#include <qlcc-types.h>

#define qlrate(qlrate)			((struct qlrate_type *) (qlrate))

static void rate_node(struct fpnode_type *, unsigned, unsigned, QLNODE);

static void
rate_node(struct fpnode_type *fpnode_data, unsigned line, unsigned mail,
	  QLNODE slip)
{
    unsigned i;

    fpnode_data += line << 1;

    if (0) {
    } else {
	unsigned call, j, news, s = 1;

	call = mail;
	news = call;
	j = ~line;
	while (j & 1) {
	    s <<= 1;
	    news -= (fpnode_data - s)->call;
	    j >>= 1;
	}

	fpnode_data--;

	fpnode_data->call = news;
	fpnode_data->node = slip;
    }
    for (i = line - 1; i; i--) {
	unsigned call, j, news, s = 1;

	fpnode_data--;

	call = fpnode_data->call;
	news = call;
	j = ~i;
	while (j & 1) {
	    s <<= 1;
	    news -= (fpnode_data - s)->call;
	    j >>= 1;
	}

	fpnode_data--;

	fpnode_data->call = news;
	fpnode_data->node = slip;
    }
}


int
_libx1f4l2_gray_qlrate(void *qlrate)
{
    int status;
    unsigned lock;
    void *side;

    lock = qlrate(qlrate)->link_a.fplist.lock;

    status = qlrate(qlrate)->link_m.link
	(qlrate(qlrate)->link_m.data, &side,
	 sizeof(struct fpnode_type) << lock);
    if (status) {
	status = _libx1f4l2_rack_qlrate(qlrate, 1, &side);
    }

    if (0) {
    } else {
	QLNODE news;
	struct fpnode_type *fpnode_data, *fpnode_link, *fpnode_text;
	unsigned half, i, miss, slip, tile;
	void *sale;

	fpnode_data = qlrate(qlrate)->link_a.fplist.fpnode;

	news = qlrate(qlrate)->link_a.fplist.rate == 2 ? ~(QLNODE) 0 : 0;

	sale = fpnode_data->star;

	fpnode_link = side;

	fpnode_text = sale;

	half = 1 << lock >> 1;

	fpnode_text += half;

	miss = fpnode_text->call;

	slip = half;

	fpnode_data += slip;

	while (slip) {
	    fpnode_data->call = miss;
	    slip >>= 1;
	    fpnode_data -= slip;
	}

	fpnode_data--;

	fpnode_data->node = half;

	i = half;
	for (; i; i--) {
	    *fpnode_link = *fpnode_text++;
	    fpnode_link += 2;
	}

	tile = qlrate(qlrate)->link_a.fplist.size - miss;

	rate_node(side, half, tile, news);

	fpnode_link = sale;

	fpnode_link += half;

	i = half;
	for (; i; i--) {
	    fpnode_text -= 2;
	    *fpnode_text = *--fpnode_link;
	}

	rate_node(sale, half, miss, news);

	slip = half;

	fpnode_data += slip;

	slip >>= 1;

	fpnode_data += slip;

	while (slip) {
	    fpnode_data->call = tile;
	    slip >>= 1;
	    fpnode_data -= slip;
	}

	fpnode_data--;

	fpnode_data->node = half;
	fpnode_data->star = side;

	qlrate(qlrate)->link_a.fplist.node = 2;
    }

    return status;
}
