/*
 * qlcc.p.c
 * Copyright (C) 2010-2012, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stddef.h>
#include <string.h>

#include <qlcc-defs.h>
#include <qlcc-inter.h>
#include <qlcc-lines.h>
#include <qlcc-names.h>
#include <qlcc-types.h>

#define qlrate(qlrate)			((struct qlrate_type *) (qlrate))

static void push_last(struct fpnode_type *, unsigned, unsigned);
static void push_post(struct fpnode_type *, unsigned, unsigned);

static void
push_last(struct fpnode_type *fpnode_data, unsigned cell, unsigned last)
{
    QLNODE node;
    unsigned e, q, w, x;
    void *star = NULL;

    fpnode_data += cell;

    x = cell;

    node = Lx55555555;

    w = QLBITS >> 1;

    fpnode_data->node = Lx55555555;

    if (1) {
	q = fpnode_data->call;
    } else {
    }

    {
	if (x & 1) {
	} else {
	    e = x;
	    e--;
	    e &= x;
	    e ^= x;
	    e >>= 1;

	    do {
		(fpnode_data + e)->call -= w;
		e >>= 1;
	    } while (e);
	}

	{
	    fpnode_data->call += w;
	}
    }

    last++;
    last = x - last;
    if (last) {
	unsigned b, i;

	if (x & 1) {
	    QLNODE Node;
	    void *Star;

	    fpnode_data--;

	    x--;

	    w = q;

	    q = fpnode_data->call;

	    e = x;
	    e--;
	    e &= x;
	    e ^= x;
	    e >>= 1;

	    b = e;

	    do {
		(fpnode_data + e)->call -= w;
		e >>= 1;
	    } while (e);

	    fpnode_data->call += w;

	    Node = fpnode_data->node;
	    Star = fpnode_data->star;
	    fpnode_data->node = node;
	    fpnode_data->star = star;
	    node = Node;
	    star = Star;

	    last--;
	} else {
	    e = x;
	    e--;
	    e &= x;
	    e ^= x;
	    e >>= 1;

	    b = e;
	}

	i = last >> 1;
	for (; i; i--) {
	    QLNODE Node;
	    void *Star;

	    fpnode_data--;

	    x--;

	    w = q;

	    q = fpnode_data->call;

	    fpnode_data++;

	    e = b;

	    do {
		w -= (fpnode_data - e)->call;
		e >>= 1;
	    } while (e);

	    fpnode_data--;

	    fpnode_data->call += w;

	    Node = fpnode_data->node;
	    Star = fpnode_data->star;
	    fpnode_data->node = node;
	    fpnode_data->star = star;

	    fpnode_data--;

	    x--;

	    w = q;

	    q = fpnode_data->call;

	    e = x;
	    e--;
	    e &= x;
	    e ^= x;
	    e >>= 1;

	    b = e;

	    do {
		(fpnode_data + e)->call -= w;
		e >>= 1;
	    } while (e);

	    fpnode_data->call += w;

	    node = fpnode_data->node;
	    star = fpnode_data->star;
	    fpnode_data->node = Node;
	    fpnode_data->star = Star;
	}

	if (last & 1) {
	    QLNODE Node;
	    void *Star;

	    fpnode_data--;

	    x--;

	    w = q;

	    q = fpnode_data->call;

	    fpnode_data++;

	    e = b;

	    do {
		w -= (fpnode_data - e)->call;
		e >>= 1;
	    } while (e);

	    fpnode_data--;

	    fpnode_data->call += w;

	    Node = fpnode_data->node;
	    Star = fpnode_data->star;
	    fpnode_data->node = node;
	    fpnode_data->star = star;
	    node = Node;
	    star = Star;
	}
    }

    {
	fpnode_data--;

	{
	    fpnode_data->node = node;
	    fpnode_data->star = star;
	}
    }
}


static void
push_post(struct fpnode_type *fpnode_data, unsigned cell, unsigned post)
{
    QLNODE node;
    unsigned e, w, x;
    void *star = NULL;

    fpnode_data += cell;

    x = cell;

    node = Lx55555555;

    w = QLBITS >> 1;

    fpnode_data->node = Lx55555555;

    {
	fpnode_data++;

	if (x & 1) {
	    e = ~x;
	    e = e ^ (e & (e - 1));
	    e >>= 1;

	    do {
		(fpnode_data + e)->call += w;
		e >>= 1;
	    } while (e);
	}
    }

    post--;
    post -= x;
    if (post) {
	unsigned i;

	if (x & 1) {
	    QLNODE Node;
	    unsigned v;
	    void *Star;

	    x++;

	    Node = fpnode_data->node;
	    Star = fpnode_data->star;
	    fpnode_data->node = node;
	    fpnode_data->star = star;
	    node = Node;
	    star = Star;

	    fpnode_data->call -= w;

	    fpnode_data++;

	    v = fpnode_data->call;

	    v -= w;

	    w = v;

	    post--;
	}

	i = post >> 1;
	for (; i; i--) {
	    QLNODE Node;
	    unsigned b, v;
	    void *Star;

	    x++;

	    Node = fpnode_data->node;
	    Star = fpnode_data->star;
	    fpnode_data->node = node;
	    fpnode_data->star = star;

	    fpnode_data->call -= w;

	    fpnode_data++;

	    v = fpnode_data->call;

	    e = x;

	    x++;

	    e &= x;
	    e ^= x;
	    e >>= 1;

	    b = e;

	    do {
		v -= (fpnode_data - e)->call;
		e >>= 1;
	    } while (e);

	    v -= w;

	    e = b;

	    do {
		(fpnode_data + e)->call += v;
		e >>= 1;
	    } while (e);

	    node = fpnode_data->node;
	    star = fpnode_data->star;
	    fpnode_data->node = Node;
	    fpnode_data->star = Star;

	    fpnode_data->call -= v;

	    fpnode_data++;

	    w = fpnode_data->call;

	    w -= v;
	}

	/*
	 * not getting into the next too often
	 */
	if (post & 1) {
	    QLNODE Node;
	    unsigned b, v;
	    void *Star;

	    x++;

	    Node = fpnode_data->node;
	    Star = fpnode_data->star;
	    fpnode_data->node = node;
	    fpnode_data->star = star;
	    node = Node;
	    star = Star;

	    fpnode_data->call -= w;

	    fpnode_data++;

	    v = fpnode_data->call;

	    e = x + 1;
	    e = e ^ (e & x);
	    e >>= 1;

	    b = e;

	    do {
		v -= (fpnode_data - e)->call;
		e >>= 1;
	    } while (e);

	    v -= w;

	    e = b;

	    do {
		(fpnode_data + e)->call += v;
		e >>= 1;
	    } while (e);

	    w = v;
	}
    }

    {
	fpnode_data->call -= w;

	{
	    fpnode_data->node = node;
	    fpnode_data->star = star;
	}
    }
}


int
_libx1f4l2_mold_qlrate(void *qlrate, struct fpnode_type *fpnode_call,
		       struct fpnode_type *fpnode_data, unsigned index,
		       void **push)
{
    int status;
    struct fpnode_type *fpnode_line;
    unsigned mall, seek;
    void *side;

    mall = qlrate(qlrate)->link_a.fplist.mall;

    status = qlrate(qlrate)->link_m.link
	(qlrate(qlrate)->link_m.data, &side, QLBITS * mall);
    if (status) {
	status = _libx1f4l2_rack_qlrate(qlrate, 0, &side);
    }

    do {
	unsigned cell, last = ~0, post = ~0;

	if (fpnode_call) {
	    struct fpnode_type *fpnode_last, *fpnode_post;
	    unsigned line, mind, slip, text;

	    seek = 1;
	    fpnode_call->node++;
	    fpnode_line = fpnode_call->star;

	    cell = fpnode_data - fpnode_line;

	    line = 1 << qlrate(qlrate)->link_a.fplist.lock;

	    fpnode_last = fpnode_line + cell;
	    fpnode_post = fpnode_last;

	    mind = cell >> 1;
	    slip = (line - cell) >> 1;

	    if (cell & 1) {
		fpnode_last -= 2;
		fpnode_post += 2;
	    } else {
		fpnode_last -= 1;
		fpnode_post += 1;
	    }

	    text = mind < slip ? mind : slip;
	    while (text) {
		if (~fpnode_post->node) {
		    fpnode_post += 2;
		} else {
		    post = fpnode_post - fpnode_line;
		    if (1) {
			break;
		    }
		}
		if (~fpnode_last->node) {
		    fpnode_last -= 2;
		} else {
		    last = fpnode_last - fpnode_line;
		    if (1) {
			break;
		    }
		}

		text--;
	    }

	    if (text) {
	    } else {
		if (mind < slip) {
		    slip -= mind;
		    for (; slip; slip--) {
			if (~fpnode_post->node) {
			    fpnode_post += 2;
			} else {
			    post = fpnode_post - fpnode_line;
			    if (1) {
				break;
			    }
			}
		    }
		} else {
		    mind -= slip;
		    for (; mind; mind--) {
			if (~fpnode_last->node) {
			    fpnode_last -= 2;
			} else {
			    last = fpnode_last - fpnode_line;
			    if (1) {
				break;
			    }
			}
		    }
		}
	    }
	} else {
	    struct fpnode_type *fpnode_last, *fpnode_post;
	    unsigned line, mind, slip, text;

	    seek = 0;
	    qlrate(qlrate)->link_a.fplist.node++;
	    fpnode_line = qlrate(qlrate)->link_a.fplist.fpnode;

	    cell = fpnode_data - fpnode_line;

	    if (cell & 3) {
	    } else {
		if (_libx1f4l2_true_qlrate
		    (qlrate, fpnode_line, side, fpnode_data, index, push)) {
		    break;
		}
	    }

	    line = 1 << qlrate(qlrate)->link_a.fplist.lock;

	    fpnode_last = fpnode_line + cell;
	    fpnode_post = fpnode_last;

	    mind = cell;
	    slip = line - cell - 1;

	    if (0) {
	    } else {
		fpnode_last -= 1;
		fpnode_post += 1;
	    }

	    text = mind < slip ? mind : slip;
	    while (text) {
		if (~fpnode_post->node) {
		    fpnode_post++;
		} else {
		    post = fpnode_post - fpnode_line;
		    if (1) {
			break;
		    }
		}
		if (~fpnode_last->node) {
		    fpnode_last--;
		} else {
		    last = fpnode_last - fpnode_line;
		    if (1) {
			break;
		    }
		}

		text--;
	    }

	    if (text) {
	    } else {
		if (mind < slip) {
		    slip -= mind;
		    for (; slip; slip--) {
			if (~fpnode_post->node) {
			    fpnode_post++;
			} else {
			    post = fpnode_post - fpnode_line;
			    if (1) {
				break;
			    }
			}
		    }
		} else {
		    mind -= slip;
		    for (; mind; mind--) {
			if (~fpnode_last->node) {
			    fpnode_last--;
			} else {
			    last = fpnode_last - fpnode_line;
			    if (1) {
				break;
			    }
			}
		    }
		}
	    }
	}

	if (~last) {
	    void *sale;

	    push_last(fpnode_line, cell, last);

	    sale = fpnode_data->star;
	    fpnode_data->star = side;

	    fpnode_data--;

	    fpnode_data->star = sale;

	    qlrate(qlrate)->link_v.last
		(qlrate, index, sale, side, &(fpnode_data + 1)->node, push);
	} else {
	    if (post - cell == seek) {
		fpnode_data->node = Lx55555555;

		fpnode_data++;

		fpnode_data->call -= QLBITS >> 1;
		fpnode_data->node = Lx55555555;
	    } else {
		push_post(fpnode_line, cell, post);

		fpnode_data++;
	    }

	    fpnode_data->star = side;

	    fpnode_data--;

	    qlrate(qlrate)->link_v.post
		(qlrate, index, fpnode_data->star, side, &fpnode_data->node,
		 push);
	}
    } while (0);

    return status;
}
