/*
 * qlcc.t.c
 * Copyright (C) 2010, 2011, 2013, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stddef.h>

#include <qlcc-defs.h>
#include <qlcc-inter.h>
#include <qlcc-names.h>
#include <qlcc-types.h>

#define qlrate(qlrate)			((struct qlrate_type *) (qlrate))

int
_libx1f4l2_else_qlrate(void *qlrate, QLNODE *near,
		       struct fpnode_type *fpnode_line,
		       struct fpnode_type *fpnode_data, unsigned call,
		       struct fpnode_type *fpnode_last, unsigned last,
		       unsigned text, unsigned *index, QLNODE **fail,
		       void **fine)
{
    int status;

    status = qlrate(qlrate)->link_m.free
	(qlrate(qlrate)->link_m.data, fpnode_data->star);
    if (status) {
	status = FREE_ERROR;
    }

    if (1) {
	if (*near == 2) {
	    int excess;
	    void *node;

	    node = qlrate(qlrate)->link_a.fplist.fpnode;

	    qlrate(qlrate)->link_a.fplist.fpnode = fpnode_last->star;
	    qlrate(qlrate)->link_a.fplist.node =
		1 << qlrate(qlrate)->link_a.fplist.lock;

	    *fail = &qlrate(qlrate)->link_a.fplist.node;
	    *fine = fpnode_last->star;

	    excess = qlrate(qlrate)->link_m.free
		(qlrate(qlrate)->link_m.data, node);
	    if (excess) {
		if (status) {
		} else {
		    status = FREE_ERROR;
		}
	    }

	    *index += text;

	    node = qlrate(qlrate)->link_e.fplink_data;

	    qlrate(qlrate)->link_a.fplist.rate--;

	    qlrate(qlrate)->link_e.fplink_data =
		((struct fplink_type *) node)->fplink_data;

	    excess = qlrate(qlrate)->link_m.free
		(qlrate(qlrate)->link_m.data, node);
	    if (excess) {
		if (status) {
		} else {
		    status = FREE_ERROR;
		}
	    }
	} else {
	    unsigned line;

	    line = 1 << qlrate(qlrate)->link_a.fplist.lock;

	    fpnode_data->node = line;
	    fpnode_data->star = fpnode_last->star;

	    fpnode_last->node = 0;

	    *index += text;

	    (*near)--;

	    *fail = &fpnode_data->node;
	    *fine = fpnode_data->star;

	    last++;
	    do {
		(fpnode_line + last)->call -= text;
		last += last & ~(last - 1);
	    } while (last < line);

	    call++;
	    while (call < line) {
		(fpnode_line + call)->call += text;
		call += call & ~(call - 1);
	    }
	}
    }

    return status;
}
