/*
 * qlce.v.c
 * Copyright (C) 2010-2012, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stddef.h>

#include <qlcc-bits.h>
#include <qlcc-defs.h>
#include <qlcc-names.h>
#include <qlcc-types.h>

#define M_TEXT(___v, ___t) \
    ((void *) ((char *) (___v) + (___t)))

#define qlrate(qlrate)			((struct qlrate_type *) (qlrate))

int
x1f4_ever_qlrate(void *qlrate, void **peek)
{
    int status;
    unsigned count;

    count = qlrate(qlrate)->link_a.fplist.size;

    if (!count) {
	status = DECK_ERROR;
    } else {
	unsigned rate;
	void *node;

	node = qlrate(qlrate)->link_a.fplist.fpnode;

	status = 0;

	rate = qlrate(qlrate)->link_a.fplist.rate;

	if (rate) {
	    struct fpnode_type *fpnode_data;
	    unsigned *cell, lock, trans;

	    lock = qlrate(qlrate)->link_a.fplist.lock;

	    if (1) {
		unsigned half;

		fpnode_data = node;

		half = lock;

		cell = &fpnode_data->call;

		while (3 < half) {
		    unsigned *call, news, sail;

		    sail = sizeof(struct fpnode_type) << half;

		    sail >>= 1;
		    call = (void *) ((char *) cell + sail);

		    news = *call;
		    if (count ^ news) {
			count -= news;
			cell = call;
		    }

		    sail >>= 1;
		    call = (void *) ((char *) cell + sail);

		    news = *call;
		    if (count ^ news) {
			count -= news;
			cell = call;
		    }

		    sail >>= 1;
		    call = (void *) ((char *) cell + sail);

		    news = *call;
		    if (count ^ news) {
			count -= news;
			cell = call;
		    }

		    sail >>= 1;
		    call = (void *) ((char *) cell + sail);

		    news = *call;
		    if (count ^ news) {
			count -= news;
			cell = call;
		    }

		    half -= 4;
		}
		while (half) {
		    unsigned *call, news;

		    half--;

		    call = (void *)
			((char *) cell
			 + (sizeof(struct fpnode_type) << half));

		    news = *call;
		    if (count ^ news) {
			count -= news;
			cell = call;
		    }
		}

		fpnode_data = (void *)
		    ((char *) cell - offsetof(struct fpnode_type, call));

		rate--;
	    }

	    if (rate) {
		rate--;

		while (rate) {
		    fpnode_data = fpnode_data->star;

		    fpnode_data += 1 << lock;
		    fpnode_data--;
		    if (fpnode_data->node) {
		    } else {
			fpnode_data--;
		    }

		    rate--;
		}

		{
		    fpnode_data = fpnode_data->star;

		    fpnode_data += 1 << lock;
		    fpnode_data--;
		    if (~fpnode_data->node) {
		    } else {
			fpnode_data--;
		    }

		    rate--;
		}

		ql_bitcount(trans, fpnode_data->node);

		count = QLBITS - trans;
	    }

	    node = fpnode_data->star;

	    count--;

	    ql_bitcount(trans,
			fpnode_data->node & (((QLNODE) 1 << count) - 1));

	    count += trans;
	} else {
	    count--;
	}

	*peek = M_TEXT(node, count * qlrate(qlrate)->link_a.fplist.mall);
    }

    return status;
}
