/*
 * qlcj.7.c
 * Copyright (C) 2010-2011, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <config.h>

#include <qlcc-lines.h>
#include <qlcc-names.h>
#include <qlcc-types.h>

#define qlrate(qlrate)			((struct qlrate_type *) (qlrate))

int
_libx1f4l2_ms13_qlrate(void *qlrate, unsigned index, unsigned post,
		       struct fpnode_type *fpnode_data,
		       struct fpnode_type *fpnode_post, unsigned *lock)
{
#if SIZEOF_UNSIGNED & (SIZEOF_UNSIGNED - 1)
#else
    QLNODE ever;
    unsigned *deck, i, *near, seek;

    seek = (QLBITS >> 1) - post;

    ever = fpnode_post->node;

    deck = fpnode_data->star;

    deck += 6 * index;

    i = HALF_QLBITS - 1 - index;
    for (; i; i--) {
	near = deck + 6;

	*deck++ = *near++;
	*deck++ = *near++;
	*deck++ = *near++;

	deck += 3;
    }

    if (2 < seek) {
	QLNODE clip;

	seek++;
	seek >>= 1;

	*lock = seek;

	if (3 < seek) {
	    near = deck - ((seek - 3) << 1) * 3;
	    deck = near - 3;

	    i = seek - 3;
	    for (; i; i--) {
		*deck++ = *near++;
		*deck++ = *near++;
		*deck++ = *near++;

		near += 3;
	    }
	} else {
	    if (seek ^ 2) {
		deck -= 3;
	    }
	}

	clip = 1;

	near = fpnode_post->star;

	i = seek;
	while (1) {
	    *deck++ = *near++;
	    *deck++ = *near++;
	    *deck++ = *near++;
	    if (ever & clip) {
		near += 3;
		i--;
		clip <<= 1;
		if (i) {
		} else {
		    deck = fpnode_post->star;

		    break;
		}
	    } else {
		clip <<= 2;
		if (i & ~1) {
		    i -= 2;
		    *deck++ = *near++;
		    *deck++ = *near++;
		    *deck++ = *near++;
		    if (i) {
		    } else {
			deck = fpnode_post->star;

			break;
		    }
		} else {
		    if (0) {
		    } else {
			deck = fpnode_post->star;

			*deck++ = *near++;
			*deck++ = *near++;
			*deck++ = *near++;

			deck += 3;

			break;
		    }
		}
	    }
	}

	i = (near - deck) >> 1;
	while (i) {
	    if (ever & clip) {
		*deck++ = *near++;
		*deck++ = *near++;
		*deck++ = *near++;

		deck += 3;
		near += 3;

		clip <<= 1;
	    } else {
		clip <<= 2;
		i -= 3;

		*deck++ = *near++;
		*deck++ = *near++;
		*deck++ = *near++;

		deck += 3;

		*deck++ = *near++;
		*deck++ = *near++;
		*deck++ = *near++;

		deck += 3;
	    }
	}

	clip--;

	fpnode_post->node = (ever & ~clip) >> seek | clip >> seek;

	fpnode_data->node =
	    Lx55555555 & (((QLNODE) 1 << (HALF_QLBITS + 1 - seek)) - 1);
    } else {
	QLNODE clip, fail;

	clip = 1;

	near = fpnode_post->star;

	*deck++ = *near++;
	*deck++ = *near++;
	*deck++ = *near++;

	near -= 3;

	while (ever & clip) {
	    deck = near + 6;

	    *near++ = *deck++;
	    *near++ = *deck++;
	    *near++ = *deck++;

	    near += 3;

	    clip <<= 1;
	}

	deck = near + 3;

	*near++ = *deck++;
	*near++ = *deck++;
	*near++ = *deck++;

	*lock = 1;

	fail = clip - 1;

	fpnode_post->node = (ever & fail) | clip | (ever & ~fail) >> 1;

	fpnode_data->node = Lx55555555;
    }
#endif				/* SIZEOF_UNSIGNED & (SIZEOF_UNSIGNED - 1) */

    return 0;
}
