/*
 * qlck.0.c
 * Copyright (C) 2010-2011, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <string.h>

#include <qlcc-lines.h>
#include <qlcc-names.h>
#include <qlcc-types.h>

#define beta(___s, ___n) \
    (___s) = (char *) (___s) - ((___n) << 1)

#define life(___s, ___n) \
    ((char *) (___s) - (___n))

#define lola(___s, ___n) \
    ((char *) (___s) - ((___n) << 1))

#define posh(___s, ___n) \
    (___s) = (char *) (___s) - (___n)

#define rule(___s, ___n, ___t) \
    ((char *) (___s) + (___n) * (___t))

#define sans(___s, ___n) \
    ((char *) (___s) + (___n))

#define skip(___s, ___n) \
    (___s) = (char *) (___s) + (___n)

#define qlrate(qlrate)			((struct qlrate_type *) (qlrate))

int
_libx1f4l2_mv00_qlrate(void *qlrate, unsigned index, unsigned last,
		       struct fpnode_type *fpnode_data,
		       struct fpnode_type *fpnode_last, unsigned *lock)
{
    QLNODE lead;
    unsigned mall, seek;
    void *fpnode, *fqnode;

    seek = (QLBITS >> 1) - last;

    lead = fpnode_last->node;

    mall = qlrate(qlrate)->link_a.fplist.mall;

    fpnode = fpnode_data->star;

    if (2 < seek) {
	QLNODE clip;
	unsigned i;

	seek++;
	seek >>= 1;

	*lock = seek;

	fpnode = rule(fpnode, mall, index << 1);

	i = index;
	if (i & 1) {
	    fqnode = fpnode;
	    beta(fpnode, mall);
	    memcpy(fqnode, fpnode, mall);
	}
	i >>= 1;
	for (; i; i--) {
	    fqnode = lola(fpnode, mall);
	    memcpy(fpnode, fqnode, mall);
	    fpnode = lola(fqnode, mall);
	    memcpy(fqnode, fpnode, mall);
	}
	if (2 < seek) {
	    fqnode = rule(fpnode, mall, 2 + ((seek - 2 - 1) << 1));
	    fpnode = sans(fqnode, mall);

	    i = seek - 2;
	    for (; i; i--) {
		memcpy(fpnode, fqnode, mall);
		posh(fpnode, mall);
		beta(fqnode, mall);
	    }
	} else {
	    skip(fpnode, mall);
	}

	clip = (QLNODE) 1 << (QLBITS - last - 1);

	fqnode = fpnode_last->star;

	fqnode = rule(fqnode, mall, QLBITS);

	i = seek;
	while (1) {
	    if (lead & clip) {
		beta(fqnode, mall);
		memcpy(fpnode, fqnode, mall);
		posh(fpnode, mall);
		i--;
		clip >>= 1;
		if (i) {
		} else {
		    fpnode = fpnode_last->star;

		    fpnode = rule(fpnode, mall, QLBITS);

		    break;
		}
	    } else {
		clip >>= 2;
		if (i & ~1) {
		    i -= 2;
		    posh(fqnode, mall);
		    memcpy(fpnode, fqnode, mall);
		    posh(fpnode, mall);
		    posh(fqnode, mall);
		    memcpy(fpnode, fqnode, mall);
		    posh(fpnode, mall);
		    if (i) {
		    } else {
			fpnode = fpnode_last->star;

			fpnode = rule(fpnode, mall, QLBITS);

			break;
		    }
		} else {
		    posh(fqnode, mall);
		    memcpy(fpnode, fqnode, mall);
		    if (0) {
		    } else {
			fpnode = fpnode_last->star;

			fpnode = rule(fpnode, mall, QLBITS - 2);

			posh(fqnode, mall);
			memcpy(fpnode, fqnode, mall);

			break;
		    }
		}
	    }
	}

	i = (fpnode - fqnode) >> 1;
	while (i) {
	    if (lead & clip) {
		beta(fqnode, mall);
		beta(fpnode, mall);
		memcpy(fpnode, fqnode, mall);
		clip >>= 1;
	    } else {
		clip >>= 2;
		i -= mall;
		posh(fqnode, mall);
		beta(fpnode, mall);
		memcpy(fpnode, fqnode, mall);
		posh(fqnode, mall);
		beta(fpnode, mall);
		memcpy(fpnode, fqnode, mall);
	    }
	}

	clip <<= 1;
	clip--;

	last += seek;

	fpnode_last->node =
	    (lead & clip) | (~clip & (((QLNODE) 1 << (QLBITS - last)) - 1));

	seek--;

	fpnode_data->node = (Lx55555555 & ~(((QLNODE) 1 << seek) - 1)) << seek;
    } else {
	QLNODE clip;
	unsigned i;

	clip = (QLNODE) 1 << (QLBITS - last - 1);

	fpnode = rule(fpnode, mall, index << 1);

	i = index;
	if (i & 1) {
	    fqnode = fpnode;
	    beta(fpnode, mall);
	    memcpy(fqnode, fpnode, mall);
	}
	i >>= 1;
	for (; i; i--) {
	    fqnode = lola(fpnode, mall);
	    memcpy(fpnode, fqnode, mall);
	    fpnode = lola(fqnode, mall);
	    memcpy(fqnode, fpnode, mall);
	}

	fqnode = fpnode_last->star;

	if (lead & clip) {
	    QLNODE fail;

	    fqnode = rule(fqnode, mall, QLBITS - 2);
	    memcpy(fpnode, fqnode, mall);
	    clip >>= 1;
	    while (1) {
		if (lead & clip) {
		    fpnode = lola(fqnode, mall);
		    memcpy(fqnode, fpnode, mall);
		    clip >>= 1;
		    if (lead & clip) {
			fqnode = lola(fpnode, mall);
			memcpy(fpnode, fqnode, mall);
			clip >>= 1;
		    } else {
			fqnode = life(fpnode, mall);
			memcpy(fpnode, fqnode, mall);

			break;
		    }
		} else {
		    fpnode = life(fqnode, mall);
		    memcpy(fqnode, fpnode, mall);

		    break;
		}
	    }

	    fail = clip - 1;

	    fpnode_last->node =
		(lead & fail) | clip >> 1 | (lead & ~fail) >> 1;
	} else {
	    memcpy(fpnode, rule(fqnode, mall, QLBITS - 1), mall);

	    fpnode_last->node = lead | clip >> 1;
	}

	*lock = 1;

	fpnode_data->node = Lx55555555;
    }

    return 0;
}
