/*
 * qlck.5.c
 * Copyright (C) 2010-2011, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <config.h>

#include <qlcc-lines.h>
#include <qlcc-names.h>
#include <qlcc-types.h>

#define qlrate(qlrate)			((struct qlrate_type *) (qlrate))

int
_libx1f4l2_mv11_qlrate(void *qlrate, unsigned index, unsigned last,
		       struct fpnode_type *fpnode_data,
		       struct fpnode_type *fpnode_last, unsigned *lock)
{
#if SIZEOF_UNSIGNED & (SIZEOF_UNSIGNED - 1)
#else
    QLNODE lead;
    unsigned *deck, i, *near, seek;

    seek = (QLBITS >> 1) - last;

    lead = fpnode_last->node;

    deck = fpnode_data->star;

    deck += index << 1;

    i = index;
    if (i & 1) {
	near = deck;
	deck -= 2;
	*near = *deck;
    }
    i >>= 1;
    for (; i; i--) {
	near = deck - 2;
	*deck = *near;
	deck = near - 2;
	*near = *deck;
    }

    if (2 < seek) {
	QLNODE clip;

	seek++;
	seek >>= 1;

	*lock = seek;

	if (2 < seek) {
	    near = deck + 2 + ((seek - 2 - 1) << 1);
	    deck = near + 1;

	    i = seek - 2;
	    for (; i; i--) {
		*deck-- = *near;
		near -= 2;
	    }
	} else {
	    deck++;
	}

	clip = (QLNODE) 1 << (QLBITS - last - 1);

	near = fpnode_last->star;

	near += QLBITS;

	i = seek;
	while (1) {
	    if (lead & clip) {
		near -= 2;
		*deck = *near;
		deck--;
		i--;
		clip >>= 1;
		if (i) {
		} else {
		    deck = fpnode_last->star;

		    deck += QLBITS;

		    break;
		}
	    } else {
		clip >>= 2;
		if (i & ~1) {
		    i -= 2;
		    near--;
		    *deck = *near;
		    deck--;
		    near--;
		    *deck = *near;
		    deck--;
		    if (i) {
		    } else {
			deck = fpnode_last->star;

			deck += QLBITS;

			break;
		    }
		} else {
		    near--;
		    *deck = *near;
		    if (0) {
		    } else {
			deck = fpnode_last->star;

			deck += QLBITS - 2;

			near--;
			*deck = *near;

			break;
		    }
		}
	    }
	}

	i = (deck - near) >> 1;
	while (i) {
	    if (lead & clip) {
		near -= 2;
		deck -= 2;
		*deck = *near;
		clip >>= 1;
	    } else {
		clip >>= 2;
		i--;
		near--;
		deck -= 2;
		*deck = *near;
		near--;
		deck -= 2;
		*deck = *near;
	    }
	}

	clip <<= 1;
	clip--;

	last += seek;

	fpnode_last->node =
	    (lead & clip) | (~clip & (((QLNODE) 1 << (QLBITS - last)) - 1));

	seek--;

	fpnode_data->node = (Lx55555555 & ~(((QLNODE) 1 << seek) - 1)) << seek;
    } else {
	QLNODE clip;

	clip = (QLNODE) 1 << (QLBITS - last - 1);

	near = fpnode_last->star;

	if (lead & clip) {
	    QLNODE fail;

	    near += QLBITS - 2;
	    *deck = *near;
	    clip >>= 1;
	    while (1) {
		if (lead & clip) {
		    deck = near - 2;
		    *near = *deck;
		    clip >>= 1;
		    if (lead & clip) {
			near = deck - 2;
			*deck = *near;
			clip >>= 1;
		    } else {
			*deck = *(deck - 1);

			break;
		    }
		} else {
		    *near = *(near - 1);

		    break;
		}
	    }

	    fail = clip - 1;

	    fpnode_last->node =
		(lead & fail) | clip >> 1 | (lead & ~fail) >> 1;
	} else {
	    *deck = *(near + QLBITS - 1);

	    fpnode_last->node = lead | clip >> 1;
	}

	*lock = 1;

	fpnode_data->node = Lx55555555;
    }
#endif				/* SIZEOF_UNSIGNED & (SIZEOF_UNSIGNED - 1) */

    return 0;
}
