/*
 * qlcq.5.c
 * Copyright (C) 2010-2011, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <config.h>

#include <qlcc-lines.h>
#include <qlcc-names.h>
#include <qlcc-types.h>

#define qlrate(qlrate)			((struct qlrate_type *) (qlrate))

int
_libx1f4l2_cv11_qlrate(void *qlrate, unsigned index, void *sale, void *side,
		       QLNODE *news, void **push)
{
#if SIZEOF_UNSIGNED & (SIZEOF_UNSIGNED - 1)
#else
    unsigned *deck, half, i, *near;

    half = QLBITS * SIZEOF_UNSIGNED >> 1;

    deck = side;
    near = (unsigned *) ((char *) sale + half);

    if (index < (QLBITS >> 1) + 1) {
	i = QLBITS >> 1;
	for (; i; i--) {
	    *deck = *near++;
	    deck += 2;
	}

	deck = (unsigned *) ((char *) sale + (half << 1));
	near = (unsigned *) ((char *) sale + half);

	i = (QLBITS >> 1) - 1;
	for (; i; i--) {
	    deck -= 2;
	    *deck = *--near;
	}

	if (index) {
	    *news = (Lx55555555 & (((QLNODE) 1 << (index - 1)) - 1))
		| (Lx55555555 & ~(QLNODE) 0 << (index - 1 + 1)) << 1;
	    *push = (char *) sale + ((index << 1) - 1) * SIZEOF_UNSIGNED;
	} else {
	    deck -= 1;
	    near = sale;
	    *deck = *near;
	    *news = (Lx55555555 & ~(QLNODE) 1) << 1;
	    *push = sale;
	}
    } else {
	index -= (QLBITS >> 1) + 1;

	near += 1;

	i = index;
	for (; i; i--) {
	    *deck = *near++;
	    deck += 2;
	}

	{
	    *push = deck;
	}

	deck += 2;

	i = (QLBITS >> 1) - index - 1;
	for (; i; i--) {
	    *deck = *near++;
	    deck += 2;
	}

	deck = (unsigned *) ((char *) sale + (half << 1));
	near = (unsigned *) ((char *) sale + half);

	{
	    near += 1;
	    *--deck = *--near;
	}

	deck--;

	i = (QLBITS >> 1) - 1;
	for (; i; i--) {
	    *deck = *--near;
	    deck -= 2;
	}

	{
	    *news = Lx55555555 >> 1;
	}
    }
#endif				/* SIZEOF_UNSIGNED & (SIZEOF_UNSIGNED - 1) */

    return 0;
}
