/*
 * qlcr.5.c
 * Copyright (C) 2010-2011, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <config.h>

#include <qlcc-lines.h>
#include <qlcc-names.h>
#include <qlcc-types.h>

#if SIZEOF_UNSIGNED == 4
# define RANGE_SHIFT			2
#endif				/* SIZEOF_UNSIGNED == 4 */

#if SIZEOF_UNSIGNED == 8
# define RANGE_SHIFT			3
#endif				/* SIZEOF_UNSIGNED == 8 */

#define qlrate(qlrate)			((struct qlrate_type *) (qlrate))

int
_libx1f4l2_mx11_qlrate(void *qlrate, unsigned index, unsigned post,
		       struct fpnode_type *fpnode_data,
		       struct fpnode_type *fpnode_post, unsigned *lock)
{
#if SIZEOF_UNSIGNED & (SIZEOF_UNSIGNED - 1)
#else
    QLNODE ever;
    unsigned *deck, i, j, *near, mall, race, seek;

    mall = qlrate(qlrate)->link_a.fplist.mall;

    seek = (QLBITS >> 1) - post;

    race = mall >> RANGE_SHIFT;

    ever = fpnode_post->node;

    deck = fpnode_data->star;

    mall = race >> 2;

    deck += race * index << 1;

    i = HALF_QLBITS - 1 - index;
    for (; i; i--) {
	near = deck + (race << 1);

	for (j = mall; j; j--) {
	    *deck++ = *near++;
	    *deck++ = *near++;
	    *deck++ = *near++;
	    *deck++ = *near++;
	}
	{
	    *deck++ = *near++;
	}

	deck += race;
    }

    if (2 < seek) {
	QLNODE clip;

	seek++;
	seek >>= 1;

	*lock = seek;

	if (3 < seek) {
	    near = deck - ((seek - 3) << 1) * race;
	    deck = near - race;

	    i = seek - 3;
	    for (; i; i--) {
		for (j = mall; j; j--) {
		    *deck++ = *near++;
		    *deck++ = *near++;
		    *deck++ = *near++;
		    *deck++ = *near++;
		}
		{
		    *deck++ = *near++;
		}

		near += race;
	    }
	} else {
	    if (seek ^ 2) {
		deck -= race;
	    }
	}

	clip = 1;

	near = fpnode_post->star;

	i = seek;
	while (1) {
	    for (j = mall; j; j--) {
		*deck++ = *near++;
		*deck++ = *near++;
		*deck++ = *near++;
		*deck++ = *near++;
	    }
	    {
		*deck++ = *near++;
	    }
	    if (ever & clip) {
		near += race;
		i--;
		clip <<= 1;
		if (i) {
		} else {
		    deck = fpnode_post->star;

		    break;
		}
	    } else {
		clip <<= 2;
		if (i & ~1) {
		    i -= 2;
		    for (j = mall; j; j--) {
			*deck++ = *near++;
			*deck++ = *near++;
			*deck++ = *near++;
			*deck++ = *near++;
		    }
		    {
			*deck++ = *near++;
		    }
		    if (i) {
		    } else {
			deck = fpnode_post->star;

			break;
		    }
		} else {
		    if (0) {
		    } else {
			deck = fpnode_post->star;

			for (j = mall; j; j--) {
			    *deck++ = *near++;
			    *deck++ = *near++;
			    *deck++ = *near++;
			    *deck++ = *near++;
			}
			{
			    *deck++ = *near++;
			}

			deck += race;

			break;
		    }
		}
	    }
	}

	i = (near - deck) >> 1;
	while (i) {
	    if (ever & clip) {
		for (j = mall; j; j--) {
		    *deck++ = *near++;
		    *deck++ = *near++;
		    *deck++ = *near++;
		    *deck++ = *near++;
		}
		{
		    *deck++ = *near++;
		}

		deck += race;
		near += race;

		clip <<= 1;
	    } else {
		clip <<= 2;
		i -= race;

		for (j = mall; j; j--) {
		    *deck++ = *near++;
		    *deck++ = *near++;
		    *deck++ = *near++;
		    *deck++ = *near++;
		}
		{
		    *deck++ = *near++;
		}

		deck += race;

		for (j = mall; j; j--) {
		    *deck++ = *near++;
		    *deck++ = *near++;
		    *deck++ = *near++;
		    *deck++ = *near++;
		}
		{
		    *deck++ = *near++;
		}

		deck += race;
	    }
	}

	clip--;

	fpnode_post->node = (ever & ~clip) >> seek | clip >> seek;

	fpnode_data->node =
	    Lx55555555 & (((QLNODE) 1 << (HALF_QLBITS + 1 - seek)) - 1);
    } else {
	QLNODE clip, fail;

	clip = 1;

	near = fpnode_post->star;

	for (j = mall; j; j--) {
	    *deck++ = *near++;
	    *deck++ = *near++;
	    *deck++ = *near++;
	    *deck++ = *near++;
	}
	{
	    *deck++ = *near++;
	}

	near -= race;

	while (ever & clip) {
	    deck = near + (race << 1);

	    for (j = mall; j; j--) {
		*near++ = *deck++;
		*near++ = *deck++;
		*near++ = *deck++;
		*near++ = *deck++;
	    }
	    {
		*near++ = *deck++;
	    }

	    near += race;

	    clip <<= 1;
	}

	deck = near + race;

	for (j = mall; j; j--) {
	    *near++ = *deck++;
	    *near++ = *deck++;
	    *near++ = *deck++;
	    *near++ = *deck++;
	}
	{
	    *near++ = *deck++;
	}

	*lock = 1;

	fail = clip - 1;

	fpnode_post->node = (ever & fail) | clip | (ever & ~fail) >> 1;

	fpnode_data->node = Lx55555555;
    }
#endif				/* SIZEOF_UNSIGNED & (SIZEOF_UNSIGNED - 1) */

    return 0;
}
