/*
 * qlcu.4.c
 * Copyright (C) 2010-2011, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <config.h>

#include <qlcc-lines.h>
#include <qlcc-names.h>
#include <qlcc-types.h>

#if SIZEOF_UNSIGNED == 4
# define RANGE_SHIFT			2
#endif				/* SIZEOF_UNSIGNED == 4 */

#if SIZEOF_UNSIGNED == 8
# define RANGE_SHIFT			3
#endif				/* SIZEOF_UNSIGNED == 8 */

#define qlrate(qlrate)			((struct qlrate_type *) (qlrate))

int
_libx1f4l2_cx10_qlrate(void *qlrate, unsigned index, void *sale, void *side,
		       QLNODE *news, void **push)
{
#if SIZEOF_UNSIGNED & (SIZEOF_UNSIGNED - 1)
#else
    unsigned *deck, half, i, j, mall, *near;

    mall = qlrate(qlrate)->link_a.fplist.mall;

    half = QLBITS * mall >> 1;

    mall >>= RANGE_SHIFT + 2;

    deck = side;
    near = (unsigned *) ((char *) sale + half);

    if (index < QLBITS >> 1) {
	{
	    near -= mall << 2;
	    for (j = mall; j; j--) {
		*deck++ = *near++;
		*deck++ = *near++;
		*deck++ = *near++;
		*deck++ = *near++;
	    }
	    for (j = mall; j; j--) {
		*deck++ = *near++;
		*deck++ = *near++;
		*deck++ = *near++;
		*deck++ = *near++;
	    }
	}
	i = (QLBITS >> 1) - 1;
	for (; i; i--) {
	    for (j = mall; j; j--) {
		*deck++ = *near++;
		*deck++ = *near++;
		*deck++ = *near++;
		*deck++ = *near++;
	    }
	    deck += mall << 2;
	}

	deck = (unsigned *) ((char *) sale + (half << 1));
	near = (unsigned *) ((char *) sale + half);

	near -= mall << 2;

	i = (QLBITS >> 1) - 1 - index;
	for (; i; i--) {
	    deck -= mall << 2;
	    for (j = mall; j; j--) {
		*--deck = *--near;
		*--deck = *--near;
		*--deck = *--near;
		*--deck = *--near;
	    }
	}

	{
	    deck -= mall << 3;
	    *push = deck;
	}

	i = index;
	if (i) {
	    i--;
	    for (; i; i--) {
		deck -= mall << 2;
		for (j = mall; j; j--) {
		    *--deck = *--near;
		    *--deck = *--near;
		    *--deck = *--near;
		    *--deck = *--near;
		}
	    }
	}

	{
	    *news = (Lx55555555 & ~(QLNODE) 1) << 1;
	}
    } else {
	index -= QLBITS >> 1;

	if (index) {
	    for (j = mall; j; j--) {
		*deck++ = *near++;
		*deck++ = *near++;
		*deck++ = *near++;
		*deck++ = *near++;
	    }
	    deck += mall << 2;
	} else {
	    deck += mall << 2;
	    for (j = mall; j; j--) {
		*deck++ = *near++;
		*deck++ = *near++;
		*deck++ = *near++;
		*deck++ = *near++;
	    }
	}
	i = (QLBITS >> 1) - 1;
	for (; i; i--) {
	    for (j = mall; j; j--) {
		*deck++ = *near++;
		*deck++ = *near++;
		*deck++ = *near++;
		*deck++ = *near++;
	    }
	    deck += mall << 2;
	}

	deck = (unsigned *) ((char *) sale + (half << 1));
	near = (unsigned *) ((char *) sale + half);

	i = (QLBITS >> 1) - 1;
	for (; i; i--) {
	    deck -= mall << 2;
	    for (j = mall; j; j--) {
		*--deck = *--near;
		*--deck = *--near;
		*--deck = *--near;
		*--deck = *--near;
	    }
	}

	if (index) {
	    *news = (Lx55555555 & (((QLNODE) 1 << (index - 1)) - 1))
		| (Lx55555555 & ~(QLNODE) 0 << (index - 1 + 1)) << 1;
	    mall <<= RANGE_SHIFT + 2;
	    *push = (char *) side + ((index << 1) - 1) * mall;
	} else {
	    *news = (Lx55555555 & ~(QLNODE) 1) << 1;
	    *push = side;
	}
    }
#endif				/* SIZEOF_UNSIGNED & (SIZEOF_UNSIGNED - 1) */

    return 0;
}
