/*
 * qxcb.g.c
 * Copyright (C) 2009-2011, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <qxcc-config.h>

#include <qxcc-names.h>

int
_libx1f4l2_true_qxrate(unsigned *mini, unsigned rate)
{
    int pick = 1;
#if ____REFORM_MEMORY_LAYOUT__ == __BREADTH_FIRST_DOUBLE_LAYERED__
    unsigned nine;
#elif __REFORM_MEMORY_LAYOUT__ == __BREADTH_FIRST_TRIPLE_LAYERED__
    unsigned nine;
#endif				/* ____REFORM_MEMORY_LAYOUT__ == __BREADT... */

#if ____REFORM_MEMORY_LAYOUT__ == __BREADTH_FIRST_DOUBLE_LAYERED__
    nine = rate;
#elif __REFORM_MEMORY_LAYOUT__ == __BREADTH_FIRST_TRIPLE_LAYERED__
    nine = rate;
#endif				/* ____REFORM_MEMORY_LAYOUT__ == __BREADT... */

    while (rate) {
	unsigned *call, i, *slip;

	if (pick) {
	    call = mini + (1 << rate) - 2;
	    mini += 2 << rate;
	    slip = mini;
	    i = 1 << rate >> 1;
	    for (; i; i--) {
		*call = mini[-1] + mini[-3];
		slip[-1] = mini[-3];
		call -= 2;
		slip -= 2;
		mini -= 4;
	    }
	} else {
	    call = mini + (1 << rate) - 2;
	    i = 1 << rate;
	    for (; i; i--) {
		mini[1] = *mini;
		mini += 2;
	    }

	    slip = mini;
	    i = 1 << rate >> 1;
	    for (; i; i--) {
		*call = mini[-1] + mini[-3];
		slip[-1] = mini[-3];
		call -= 2;
		slip -= 2;
		mini -= 4;
	    }
	}

	rate--;

	pick = 0;
    }

#if ____REFORM_MEMORY_LAYOUT__ == __BREADTH_FIRST_DOUBLE_LAYERED__
    nine &= ~1;
    while (2 < nine) {
	unsigned *call, i, *slip, *type;

	call = mini + (1 << nine >> 1);
	i = 1 << nine >> 2;
	for (; i; i--) {
	    *call = call[1];
	    call += 2;
	}

	call = mini + (1 << nine >> 1);
	slip = mini + (1 << nine) + 1;
	type = call + 1;
	i = 1 << nine >> 2;
	for (; i; i--) {
	    *type = *call;
	    type += 2;
	    call += 2;
	    *type = *slip;
	    type += 2;
	    slip += 2;
	    *type = *slip;
	    type += 2;
	    slip += 2;
	}

	nine -= 2;
    }
#elif __REFORM_MEMORY_LAYOUT__ == __BREADTH_FIRST_TRIPLE_LAYERED__
    rate = nine % 3;
    if (rate == 2) {
	unsigned *call, i, *slip, *type;

	call = mini + (1 << nine >> 1);
	i = 1 << nine >> 2;
	for (; i; i--) {
	    *call = call[1];
	    call += 2;
	}

	call = mini + (1 << nine >> 1);
	slip = mini + (1 << nine) + 1;
	type = call + 1;
	i = 1 << nine >> 2;
	for (; i; i--) {
	    *type = *call;
	    type += 2;
	    call += 2;
	    *type = *slip;
	    type += 2;
	    slip += 2;
	    *type = *slip;
	    type += 2;
	    slip += 2;
	}

	nine -= 2;
    } else {
	nine -= rate;
    }
    while (3 < nine) {
	unsigned *call, *half, i, *slip, *type;

	call = mini + (1 << nine >> 2);
	i = 1 << nine >> 3;
	for (; i; i--) {
	    *call = call[1];
	    call += 2;
	}
	half = mini + (1 << nine >> 1);
	i = 1 << nine >> 2;
	for (; i; i--) {
	    *half = half[1];
	    half += 2;
	}

	call = mini + (1 << nine >> 2);
	half = mini + (1 << nine >> 1);
	slip = mini + (1 << nine) + 1;
	type = call + 1;
	i = 1 << nine >> 3;
	for (; i; i--) {
	    *type = *call;
	    type += 2;
	    call += 2;
	    *type = *half;
	    type += 2;
	    half += 2;
	    *type = *half;
	    type += 2;
	    half += 2;
	    *type = *slip;
	    type += 2;
	    slip += 2;
	    *type = *slip;
	    type += 2;
	    slip += 2;
	    *type = *slip;
	    type += 2;
	    slip += 2;
	    *type = *slip;
	    type += 2;
	    slip += 2;
	}

	nine -= 3;
    }
#endif				/* ____REFORM_MEMORY_LAYOUT__ == __BREADT... */

    return 0;
}
