/*
 * qxcc.o.c
 * Copyright (C) 2010, 2011, 2013, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stddef.h>
#include <string.h>

#include <qxcc-bits.h>
#include <qxcc-defs.h>
#include <qxcc-types.h>

#define M_TEXT(___v, ___t) \
    ((void *) ((char *) (___v) + (___t)))

#define qxrate(qxrate)			((struct qxrate_type *) (qxrate))

int
_libx1f4l2_trap_qxrate(void *qxrate, unsigned index)
{
    int excess, status;
    unsigned epslip, line, mall, slip;
    void *call, *node, *text, *trap;

    line = qxrate(qxrate)->link_a.fplist.line >> 1;
    mall = qxrate(qxrate)->link_a.fplist.mall;

    text = qxrate(qxrate)->link_e.fplink_text;

    trap = text;

    node = qxrate(qxrate)->link_a.fplist.fpnode_data;

    epslip = Q_NODE(M_TEXT(node, P_ROOT(Q_NODE(node))));

    call = *(void **) M_TEXT(node, L_LAST(epslip));

    if (index < line) {
	slip = mall * index;
	memcpy(trap, call, slip);
	trap = M_TEXT(trap, slip);
	slip = mall * (line - index - 1);
	memcpy(trap, M_TEXT(call, mall * (index + 1)), slip);
	trap = M_TEXT(trap, slip);
	index = line;
    } else {
	index -= line;
	slip = mall * line;
	memcpy(trap, call, slip);
	trap = M_TEXT(trap, slip);
    }

    status = qxrate(qxrate)->link_m.free(qxrate(qxrate)->link_m.data, call);
    if (status) {
	status = FREE_ERROR;
    }

    call = *(void **) M_TEXT(node, L_NEXT(epslip));

    if (index < line) {
	slip = mall * index;
	memcpy(trap, call, slip);
	trap = M_TEXT(trap, slip);
	slip = mall * (line - index - 1);
	memcpy(trap, M_TEXT(call, mall * (index + 1)), slip);
    } else {
	slip = mall * line;
	memcpy(trap, call, slip);
    }

    excess = qxrate(qxrate)->link_m.free(qxrate(qxrate)->link_m.data, call);
    if (excess) {
	if (status) {
	} else {
	    status = FREE_ERROR;
	}
    }

    excess = qxrate(qxrate)->link_m.free(qxrate(qxrate)->link_m.data, node);
    if (excess) {
	if (status) {
	} else {
	    status = excess;
	}
    }

    qxrate(qxrate)->link_a.fplist.rate = 0;

    qxrate(qxrate)->link_e.fplink_text = NULL;

    qxrate(qxrate)->link_a.fplist.fpnode_data = text;

    return status;
}
