/*
 * s3xi.j.c
 * Copyright (C) 2009-2012, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stddef.h>

#include <s3xx-defs.h>
#include <s3xx-names.h>
#include <s3xx-types.h>

#define s3deck(s3deck)			((struct s3deck_type *) (s3deck))

int
_libx1f4l2_fail_s3deck(void *s3deck, struct fpnode_type *fpnode_data)
{
    int status;

    do {
	byte *base;

	base = fpnode_data->base;
	if (base) {
	    status = s3deck(s3deck)->link_m.free
		(s3deck(s3deck)->link_m.data, base);
	    if (status) {
		status = FREE_ERROR;

		break;
	    }
	}

	status = s3deck(s3deck)->link_m.free
	    (s3deck(s3deck)->link_m.data, fpnode_data);
	if (status) {
	    status = FREE_ERROR;
	} else {
	    s3deck(s3deck)->link_a.fpdeck.fpnode_data = NULL;
	}
    } while (0);

    return status;
}
