/*
 * s3xv.6.c
 * Copyright (C) 2009-2011, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stddef.h>
#include <string.h>

#include <s3xx-defs.h>
#include <s3xx-inter.h>
#include <s3xx-names.h>
#include <s3xx-patch.h>
#include <s3xx-types.h>

#define fast(miss)			((const byte *) (miss))

#define s3deck(s3deck)			((struct s3deck_type *) (s3deck))

int
x1f4_pass_s3path(void *s3deck, const char *name, unsigned size)
{
    int status;
    struct fpnode_type *fpnode_data, *fpnode_slip = NULL;

    fpnode_data = s3deck(s3deck)->link_a.fpdeck.fpnode_data;
    if (fpnode_data) {
	byte *slip;
	int e;

	slip = fpnode_data->base;
	e = prefix(fpnode_data);
	if (e) {
	    slip--;
	}

	while (size) {
	    int c;

	    c = *fast(name);
	    name++;
	    if (1) {
		if (e) {
		    if (c == e) {
			slip++;
			if (slip) {
			    e = *slip;
			} else {
			    e = 0;
			}
		    } else {
			status = 0;
			if (1) {
			    break;
			}
		    }
		} else {
		    unsigned bits;

		    bits = fpnode_data->bits;
		    if (Extant(bits)) {
			fpnode_slip = fpnode_data;
			dispatch_slip(fpnode_data, bits, c);
		    } else {
			status = 0;
			if (1) {
			    break;
			}
		    }
		}
	    }

	    --size;
	}
	if (size) {
	} else {
	    if (1) {
		if (extant(fpnode_data)) {
		    if (e) {
			status = 0;
		    } else {
			fpnode_slip = fpnode_data;
			fpnode_data = (struct fpnode_type *) fpnode_data->data;
			if (prefix(fpnode_data)) {
			    if (1) {
				status = 0;
			    }
			} else {
			    status = _libx1f4l2_blue_s3deck
				(s3deck, fpnode_slip, fpnode_data);
			}
		    }
		} else {
		    if (e) {
			status = 0;
		    } else {
			if (fpnode_slip) {
			    status = _libx1f4l2_blue_s3deck
				(s3deck, fpnode_slip, fpnode_data);
			} else {
			    status = _libx1f4l2_fail_s3deck
				(s3deck, fpnode_data);
			}
		    }
		}
	    }
	}
    } else {
	status = 0;
    }

    return status;
}
