/*
 * scxu.3.c
 * Copyright (C) 2008-2012, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stddef.h>

#include <scxx-names.h>
#include <scxx-types.h>

#define Null(___n) \
    ((___n) == null)

#define scdeck(scdeck)			((struct scdeck_type *) (scdeck))

static int bank_list(struct fpnode_type *, byte *, void *,
		     int (*) (void *, const char *, unsigned));
static int bank_node(struct fpnode_type *, byte *, void *,
		     int (*) (void *, const char *, unsigned));

static int
bank_list(struct fpnode_type *fpnode_data, byte *null, void *back,
	  int (*call) (void *, const char *, unsigned))
{
    int delete;

    if (extant(fpnode_data)) {
	struct fpnode_type *fpnode_slip;
	unsigned size;

	size = spread(fpnode_data);

	fpnode_slip = (struct fpnode_type *) fpnode_data->data;

	fpnode_data = fpnode_slip;

	while (1) {
	    delete = bank_node(fpnode_data, null, back, call);
	    if (delete) {
		break;
	    } else {
		size--;
		if (size) {
		    fpnode_data++;
		} else {
		    break;
		}
	    }
	}
    } else {
	delete = 0;
    }

    return delete;
}


static int
bank_node(struct fpnode_type *fpnode_data, byte *null, void *back,
	  int (*call) (void *, const char *, unsigned))
{
    int delete;

    if (1) {
	byte *base;

	base = fpnode_data->base;
	if (Null(base)) {
	    if (0) {
	    } else {
		delete = bank_list(fpnode_data, null, back, call);
	    }
	} else {
	    delete = call(back, (char *) base, length(fpnode_data));
	    if (delete) {
	    } else {
		delete = bank_list(fpnode_data, null, back, call);
	    }
	}
    }

    return delete;
}


int
x1f4_bank_scdeck(void *scdeck, void *back,
		 int (*call) (void *, const char *, unsigned))
{
    int delete;
    struct fpnode_type *fpnode_data;

    fpnode_data = scdeck(scdeck)->link_a.fpdeck.fpnode_data;
    if (fpnode_data) {
	delete = bank_node
	    (fpnode_data, &scdeck(scdeck)->link_i.zero, back, call);
    } else {
	delete = 0;
    }

    return delete;
}
