/*
 * scxx-inter.h
 * Copyright (C) 2008-2011, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __LIBx1f4_scxx_inter_H__
#define __LIBx1f4_scxx_inter_H__

#include <scxx-names.h>
#include <scxx-types.h>

#if !defined _libx1f4l2_fast_scdeck
# define _libx1f4l2_fast_scdeck		x1f4_fast_scdeck
#endif				/* !_libx1f4l2_fast_scdeck */
#if !defined _libx1f4l2_fini_scdeck
# define _libx1f4l2_fini_scdeck		x1f4_fini_scdeck
#endif				/* !_libx1f4l2_fini_scdeck */
#if !defined _libx1f4l2_flat_scdeck
# define _libx1f4l2_flat_scdeck		x1f4_flat_scdeck
#endif				/* !_libx1f4l2_flat_scdeck */
#if !defined _libx1f4l2_init_scdeck
# define _libx1f4l2_init_scdeck		x1f4_init_scdeck
#endif				/* !_libx1f4l2_init_scdeck */

extern int _libx1f4l2_blue_scdeck
    (void *, struct fpnode_type *, struct fpnode_type *);
extern int _libx1f4l2_fail_scdeck(void *, struct fpnode_type *);
extern int _libx1f4l2_fast_scdeck(void *, unsigned, struct screen_type *);
extern int _libx1f4l2_fini_scdeck(void **);
extern int _libx1f4l2_flat_scdeck(void *);
extern int _libx1f4l2_init_scdeck(void **, unsigned, struct screen_type *);
extern int _libx1f4l2_rail_scdeck
    (void *, void *, int (*) (void *, const void **, const void *),
     int (*) (void *, const void *), void *);

#endif				/* __LIBx1f4_scxx_inter_H__ */
