/*
 * scxx.9.c
 * Copyright (C) 2009-2011, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <scxx-names.h>
#include <scxx-patch.h>
#include <scxx-types.h>

#define fast(miss)			((const byte *) (miss))

#define scdeck(scdeck)			((struct scdeck_type *) (scdeck))

int
x1f4_pick_scdeck(void *scdeck, const char *name, const void ***data)
{
    int delete;
    struct fpnode_type *fpnode_data;

    fpnode_data = scdeck(scdeck)->link_a.fpdeck.fpnode_data;
    if (fpnode_data) {
	byte *slip;
	int e;

	slip = fpnode_data->base;
	e = prefix(fpnode_data);
	if (e) {
	    slip--;
	}

	while (1) {
	    int c;

	    c = *fast(name);
	    name++;
	    if (c) {
		if (e) {
		    if (c == e) {
			slip++;
			if (1) {
			    e = *slip;
			}
		    } else {
			delete = 0;
			if (1) {
			    break;
			}
		    }
		} else {
		    unsigned bits;

		    bits = fpnode_data->bits;
		    if (Extant(bits)) {
			dispatch_node(fpnode_data, bits, c);
		    } else {
			delete = 0;
			if (1) {
			    break;
			}
		    }
		}
	    } else {
		if (extant(fpnode_data)) {
		    if (e) {
			delete = 0;
		    } else {
			fpnode_data = (struct fpnode_type *) fpnode_data->data;
			if (prefix(fpnode_data)) {
			    delete = 0;
			} else {
			    *data = &fpnode_data->data;
			    if (1) {
				delete = 1;
			    }
			}
		    }
		} else {
		    if (e) {
			delete = 0;
		    } else {
			delete = 1;
			if (1) {
			    *data = &fpnode_data->data;
			}
		    }
		}

		break;
	    }
	}
    } else {
	delete = 0;
    }

    return delete;
}
