/*
 * scxx.m.c
 * Copyright (C) 2009-2011, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <scxx-defs.h>
#include <scxx-inter.h>
#include <scxx-names.h>
#include <scxx-types.h>

#define scdeck(scdeck)			((struct scdeck_type *) (scdeck))

static int fini_deck(void **);
static int init_deck(void **, struct scdeck_type *);

static int
fini_deck(void **text)
{
    return _libx1f4l2_fini_scdeck(text);
}


static int
init_deck(void **text, struct scdeck_type *scdeck_data)
{
    int status;
    struct screen_type screen;
    struct trans_type trans;

    screen.trans_data = &trans;

    trans.data = scdeck_data->link_m.data;
    trans.free = scdeck_data->link_m.free;
    trans.link = scdeck_data->link_m.link;
    trans.mode = scdeck_data->link_m.mode;

    status = _libx1f4l2_init_scdeck(text, TRANS_MASK, &screen);

    return status;
}


int
x1f4_text_scdeck(void **scdeck, void *sctext,
		 int (*copy) (void *, const void **, const void *),
		 int (*free) (void *, const void *), void *context)
{
    int status;
    void *text;

    status = init_deck(&text, sctext);
    if (status) {
    } else {
	status = _libx1f4l2_rail_scdeck(text, sctext, copy, free, context);
	if (status) {
	    fini_deck(&text);
	} else {
	    *scdeck = text;
	}
    }

    return status;
}
