/*
 * scxx.n.c
 * Copyright (C) 2009-2011, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <scxx-defs.h>
#include <scxx-inter.h>
#include <scxx-names.h>
#include <scxx-types.h>

#define scdeck(scdeck)			((struct scdeck_type *) (scdeck))

int
x1f4_line_scdeck(void *scdata, void *sctext,
		 int (*copy) (void *, const void **, const void *),
		 int (*free) (void *, const void *), void *context)
{
    int status;

    if (scdeck(scdata)->link_a.fpdeck.fpnode_data) {
	status = SIZE_ERROR;
    } else {
	status = _libx1f4l2_rail_scdeck(scdata, sctext, copy, free, context);
    }

    return status;
}
