/*
 * scxx.v.c
 * Copyright (C) 2009-2012, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stddef.h>

#include <scxx-inter.h>
#include <scxx-names.h>
#include <scxx-types.h>

#define scdeck(scdeck)			((struct scdeck_type *) (scdeck))

int
x1f4_slip_scdeck(void *scdeck)
{
    int status;
    struct fpnode_type *fpnode_data;

    fpnode_data = scdeck(scdeck)->link_a.fpdeck.fpnode_data;
    if (fpnode_data) {
	struct fpnode_type *fpnode_slip = NULL;

	while (1) {
	    unsigned bits;

	    bits = fpnode_data->bits;
	    if (Extant(bits)) {
		fpnode_slip = fpnode_data;
		fpnode_data = (void *) fpnode_data->data;
		fpnode_data += Effect(bits);
	    } else {
		if (fpnode_slip) {
		    status = _libx1f4l2_blue_scdeck
			(scdeck, fpnode_slip, fpnode_data);
		} else {
		    status = _libx1f4l2_fail_scdeck(scdeck, fpnode_data);
		}

		break;
	    }
	}
    } else {
	status = 0;
    }

    return status;
}
