/*
 * sfxi.j.c
 * Copyright (C) 2009-2012, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stddef.h>

#include <sfxx-defs.h>
#include <sfxx-names.h>
#include <sfxx-types.h>

#define sfdeck(sfdeck)			((struct sfdeck_type *) (sfdeck))

int
_libx1f4l2_fail_sfdeck(void *sfdeck, struct fpnode_type *fpnode_data)
{
    int status;

    do {
	if (sizeof(byte *) < length(fpnode_data)) {
	    status = sfdeck(sfdeck)->link_m.free
		(sfdeck(sfdeck)->link_m.data, fpnode_data->base);
	    if (status) {
		status = FREE_ERROR;

		break;
	    }
	}

	status = sfdeck(sfdeck)->link_m.free
	    (sfdeck(sfdeck)->link_m.data, fpnode_data);
	if (status) {
	    status = FREE_ERROR;
	} else {
	    sfdeck(sfdeck)->link_a.fpdeck.fpnode_data = NULL;
	}
    } while (0);

    return status;
}
