/*
 * sfxs.m.c
 * Copyright (C) 2009-2012, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stddef.h>
#include <string.h>

#include <sfxx-names.h>
#include <sfxx-patch.h>
#include <sfxx-types.h>

#define back(miss)			((const char *) (miss))
#define fast(miss)			((const byte *) (miss))

#define sfdeck(sfdeck)			((struct sfdeck_type *) (sfdeck))

int
x1f4_llxd_sfdeck(void *sfdeck, const char *name, const void ***data)
{
    int delete;
    const struct fpnode_type *fpnode_data;

    fpnode_data = sfdeck(sfdeck)->link_a.fpdeck.fpnode_data;
    if (fpnode_data) {
	const struct fpnode_type *fpnode_pick = NULL;

	do {
	    byte *slip;
	    int e;
	    unsigned length;

	    e = prefix(fpnode_data);
	    if (e) {
		int c;

		c = *fast(name);
		if (c < e) {
		    break;
		} else {
		    if (c ^ e) {
			fpnode_pick = fpnode_data;
			if (1) {
			    break;
			}
		    } else {
			name++;
			length = length(fpnode_data);
			if (sizeof(byte *) < length) {
			    slip = fpnode_data->base;
			    if (length < Record) {
			    } else {
				length += strlen(back(slip) + Record);
			    }
			} else {
			    slip = (byte *) &fpnode_data->base;
			}
		    }
		}
	    } else {
		length = 0;
		slip = NULL;
	    }

	    while (1) {
		int c;

		c = *fast(name);
		if (c) {
		    name++;
		    if (length) {
			e = *slip;
			if (c == e) {
			    length--;
			    slip++;
			} else {
			    if (e < c) {
				fpnode_pick = fpnode_data;
			    }

			    break;
			}
		    } else {
			unsigned bits;

			bits = fpnode_data->bits;
			if (Extant(bits)) {
			    const struct fpnode_type *fpnode_slip;
			    unsigned effect;

			    effect = Effect(bits);

			    fpnode_slip = fpnode_data->data;
			    fpnode_data = fpnode_slip;

			    Progress_node(fpnode_data, effect);

			    e = prefix(fpnode_data);
			    if (e ^ c) {
				if (c < e) {
				    if (fpnode_data != fpnode_slip) {
					fpnode_pick = fpnode_data - 1;
				    }
				} else {
				    fpnode_pick = fpnode_data;
				}

				break;
			    } else {
				length = length(fpnode_data);
				if (sizeof(byte *) < length) {
				    slip = fpnode_data->base;
				    if (length < Record) {
				    } else {
					length += strlen(back(slip) + Record);
				    }
				} else {
				    slip = (byte *) &fpnode_data->base;
				}

				if (1) {
				    if (fpnode_data != fpnode_slip) {
					fpnode_pick = fpnode_data - 1;
				    }
				}
			    }
			} else {
			    if (1) {
				fpnode_pick = fpnode_data;
			    }

			    break;
			}
		    }
		} else {
		    break;
		}
	    }
	} while (0);

	if (fpnode_pick) {
	    delete = 1;

	    while (1) {
		unsigned bits;

		bits = fpnode_pick->bits;
		if (Extant(bits)) {
		    fpnode_pick = fpnode_pick->data;
		    fpnode_pick += Effect(bits);
		} else {
		    *data = (const void **) &fpnode_pick->data;
		    if (1) {
			break;
		    }
		}
	    }
	} else {
	    delete = 0;
	}
    } else {
	delete = 0;
    }

    return delete;
}
