/*
 * sfxx.c.c
 * Copyright (C) 2009-2011, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <string.h>

#include <sfxx-names.h>
#include <sfxx-types.h>

#define back(miss)			((const char *) (miss))

#define sfdeck(sfdeck)			((struct sfdeck_type *) (sfdeck))

static int back_node(const struct fpnode_type *, void *,
		     int (*) (void *, const char *, unsigned), char *,
		     unsigned);

static int
back_node(const struct fpnode_type *fpnode_data, void *back,
	  int (*call) (void *, const char *, unsigned), char *anna,
	  unsigned miss)
{
    int delete;

    if (1) {
	int c;

	c = prefix(fpnode_data);
	anna[miss] = c;
	if (c) {
	    unsigned copy;

	    miss++;

	    copy = length(fpnode_data);
	    if (sizeof(byte *) < copy) {
		byte *base;

		base = fpnode_data->base;

		if (copy < Record) {
		} else {
		    copy += strlen(back(base) + Record);
		}

		memcpy(anna + miss, base, copy);
	    } else {
		memcpy(anna + miss, &fpnode_data->base, copy);
	    }

	    miss += copy;
	}
    }

    if (extant(fpnode_data)) {
	unsigned size;

	size = spread(fpnode_data);

	fpnode_data = fpnode_data->data;

	while (1) {
	    delete = back_node(fpnode_data, back, call, anna, miss);
	    if (delete) {
		break;
	    } else {
		size--;
		if (size) {
		    fpnode_data++;
		} else {
		    break;
		}
	    }
	}
    } else {
	anna[miss] = 0;
	if (1) {
	    delete = call(back, anna, miss);
	}
    }

    return delete;
}


int
x1f4_list_sfdeck(void *sfdeck, void *back,
		 int (*call) (void *, const char *, unsigned), char *anna)
{
    int delete;
    struct fpnode_type *fpnode_data;

    fpnode_data = sfdeck(sfdeck)->link_a.fpdeck.fpnode_data;
    if (fpnode_data) {
	delete = back_node(fpnode_data, back, call, anna, 0);
    } else {
	delete = 0;
    }

    return delete;
}
