/*
 * slxi.e.c
 * Copyright (C) 2013, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <slxx-defs.h>
#include <slxx-names.h>
#include <slxx-types.h>

#define sldeck(sldeck)			((struct sldeck_type *) (sldeck))

int
_libx1f4l2_else_sldeck(void *sldeck, struct fpnode_type *fpnode_call,
		       unsigned fast)
{
    int status, zero;
    unsigned bits;
    void *node;

    bits = fpnode_call->bits;

    if (Target(bits)) {
	zero = 1;
	fast++;
    } else {
	zero = 0;
    }

    status = sldeck(sldeck)->link_m.link
	(sldeck(sldeck)->link_m.data, &node,
	 ((fast + 3) & ~3) * sizeof(struct fpnode_type));
    if (status) {
	status = LINK_ERROR;
    } else {
	struct fpnode_type *fpnode_data, *fpnode_slip;
	unsigned extent, i, offset;

	fpnode_slip = node;

	extent = Extent(bits);
	offset = Offset(bits);

	fpnode_data = (void *) fpnode_call->data;

	fpnode_call->data = node;

	fpnode_call->bits = kset(bits, fast);

	offset += extent;

	if (zero) {
	    *fpnode_slip = *fpnode_data++;
	    fpnode_slip->bits = sset(0, fpnode_slip->bits);
	    fpnode_slip++;
	}

	i = extent;
	for (; i; i--) {
	    if (vacant(fpnode_data)) {
	    } else {
		*fpnode_slip = *fpnode_data;
		fpnode_slip->bits = sset(offset - i, fpnode_slip->bits);
		fpnode_slip++;
	    }

	    fpnode_data++;
	}

	status = sldeck(sldeck)->link_m.free
	    (sldeck(sldeck)->link_m.data, fpnode_data - zero - extent);
	if (status) {
	    status = FREE_ERROR;
	}
    }

    return status;
}
