/*
 * slxx.c.c
 * Copyright (C) 2009, 2010, 2011, 2013, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <string.h>

#include <slxx-names.h>
#include <slxx-types.h>

#define back(miss)			((const char *) (miss))

#define sldeck(sldeck)			((struct sldeck_type *) (sldeck))

static int back_node(const struct fpnode_type *, void *,
		     int (*) (void *, const char *, unsigned), char *,
		     unsigned, int);

static int
back_node(const struct fpnode_type *fpnode_data, void *back,
	  int (*call) (void *, const char *, unsigned), char *anna,
	  unsigned miss, int prefix)
{
    int delete;
    unsigned bits;

    bits = fpnode_data->bits;

    if (1) {
	anna[miss] = prefix;
	if (prefix) {
	    unsigned copy;

	    miss++;

	    copy = Length(bits);
	    if (sizeof(byte *) < copy) {
		byte *base;

		base = fpnode_data->base;

		if (copy < Record) {
		} else {
		    copy += strlen(back(base) + Record);
		}

		memcpy(anna + miss, base, copy);
	    } else {
		memcpy(anna + miss, &fpnode_data->base, copy);
	    }

	    miss += copy;
	}
    }

    if (Extant(bits)) {
	fpnode_data = fpnode_data->data;

	if (Linear(bits)) {
	    unsigned offset, size;

	    size = Shadow(bits);

	    delete = 0;

	    offset = size & ~15;

	    size &= 15;
	    size++;
	    size <<= 4;

	    offset += size;

	    do {
		if (Target(bits)) {
		    delete = back_node
			(fpnode_data, back, call, anna, miss, 0);
		    if (delete) {
			break;
		    } else {
			fpnode_data++;
		    }
		}

		for (; size; size--) {
		    if (vacant(fpnode_data)) {
		    } else {
			delete = back_node
			    (fpnode_data, back, call, anna, miss,
			     offset - size);
			if (delete) {
			    break;
			}
		    }

		    fpnode_data++;
		}
	    } while (0);
	} else {
	    unsigned size;

	    size = Spread(bits);

	    while (1) {
		delete = back_node
		    (fpnode_data, back, call, anna, miss, prefix(fpnode_data));
		if (delete) {
		    break;
		} else {
		    size--;
		    if (size) {
			fpnode_data++;
		    } else {
			break;
		    }
		}
	    }
	}
    } else {
	anna[miss] = 0;
	if (1) {
	    delete = call(back, anna, miss);
	}
    }

    return delete;
}


int
x1f4_list_sldeck(void *sldeck, void *back,
		 int (*call) (void *, const char *, unsigned), char *anna)
{
    int delete;
    struct fpnode_type *fpnode_data;

    fpnode_data = &sldeck(sldeck)->link_a.fpdeck.fpnode;
    if (vacant(fpnode_data)) {
	delete = 0;
    } else {
	delete = back_node
	    (fpnode_data, back, call, anna, 0, prefix(fpnode_data));
    }

    return delete;
}
