/*
 * tcmini.h
 * Copyright (C) 2008-2011, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __LIBx1f4_TCMINI_H__
#define __LIBx1f4_TCMINI_H__

#include <errors.h>
#include <tcmn-names.h>

#define __x1f4_here_case_tcmini__	1
#define __x1f4_here_suit_tcmini__	1

/*
 * error definitions
 */
#define X1f4_TCMINI_DECK_ERROR		LIBx1f4L2_DECK_ERROR
#define X1f4_TCMINI_FREE_ERROR		LIBx1f4L2_FREE_ERROR
#define X1f4_TCMINI_LINK_ERROR		LIBx1f4L2_LINK_ERROR
#define X1f4_TCMINI_MODE_ERROR		LIBx1f4L2_MODE_ERROR

/*
 * error definitions (continued)
 */
#define X1f4_TCMINI_EVER_MATCH		LIBx1f4L2_EVER_MATCH
#define X1f4_TCMINI_MISS_CLASS		LIBx1f4L2_MISS_CLASS

/*
 * size definitions
 */
#define X1f4_TCMINI_SIZE_BOUND		(1 << 14)

#if 1
# define __x1f4_pick_tcmini(___m) \
    (*(unsigned *) (___m))
#endif				/* 1 */

#if __x1f4_here_case_tcmini__
# define x1f4_case_tcmini(___m) \
    (__x1f4_pick_tcmini((___m)) & (((1 << 14) - 1) << 18))
#endif				/* __x1f4_here_case_tcmini__ */

#if __x1f4_here_suit_tcmini__
# define x1f4_suit_tcmini(___m) \
    (__x1f4_pick_tcmini((___m)) & ((1 << 14) - 1))
#endif				/* __x1f4_here_suit_tcmini__ */

#if __x1f4_here_case_tcmini__
#else
extern int x1f4_case_tcmini(void *);
#endif				/* __x1f4_here_case_tcmini__ */
extern int x1f4_find_tcfare
    (void *, unsigned, unsigned, void **);
extern int x1f4_find_tcmini
    (void *, void *, unsigned, int (*) (void *, void *), void **);
extern int x1f4_find_tcnear
    (void *, unsigned long, unsigned, void **);
extern int x1f4_lime_tcmini(void *, void *, int (*) (void *, void *));
extern int x1f4_llxd_tcfare
    (void *, unsigned, unsigned, void **);
extern int x1f4_llxd_tcmini
    (void *, void *, unsigned, int (*) (void *, void *), void **);
extern int x1f4_look_tcfare
    (void *, unsigned, unsigned, void **);
extern int x1f4_look_tcmini
    (void *, void *, unsigned, int (*) (void *, void *), void **);
extern int x1f4_lxxd_tcfare
    (void *, unsigned, unsigned, void **);
extern int x1f4_lxxd_tcmini
    (void *, void *, unsigned, int (*) (void *, void *), void **);
extern int x1f4_part_tcmini(void *, void *, unsigned, unsigned, void **);
extern int x1f4_port_tcmini
    (void *, void *, int (*) (void *, void *), unsigned, void **);
#if __x1f4_here_suit_tcmini__
#else
extern int x1f4_suit_tcmini(void *);
#endif				/* __x1f4_here_suit_tcmini__ */
extern int x1f4_type_tcmini(void *, unsigned, unsigned);

#endif				/* __LIBx1f4_TCMINI_H__ */
