/*
 * tcqb.8.c
 * Copyright (C) 2008-2010, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <sign.x.h>
#include <tcqp-names.h>
#include <tcqp-types.h>

#define tcline(tcline)			((struct tcline_type *) (tcline))

static int find_word(struct fpnode_type *, const unsigned char *, unsigned,
		     void **);

static int
find_word(struct fpnode_type *fpnode_data, const unsigned char *text,
	  unsigned offset, void **find)
{
    int delete;
    unsigned left, plus;
    unsigned char c;

    offset += sizeof(struct fpnode_type);

    left = offset;
    plus = offset;

    c = *text;

    while (1) {
	unsigned char e, *v;

	v = (unsigned char *) fpnode_data + offset;

	e = *v;

	if (c ^ e) {
#if 0
	    fpnode_data = fpnode_data->fpnode_data
		[class_integer((int) c - (int) e)];
	    if (fpnode_data) {
	    } else {
		delete = 0;
		if (1) {
		    break;
		}
	    }
#else
	    if ((int) c < (int) e) {
		fpnode_data = fpnode_data->fpnode_data[0];
		if (fpnode_data) {
		} else {
		    delete = 0;
		    if (1) {
			break;
		    }
		}
	    } else {
		fpnode_data = fpnode_data->fpnode_data[1];
		if (fpnode_data) {
		} else {
		    delete = 0;
		    if (1) {
			break;
		    }
		}
	    }
#endif				/* 1 */
	} else {
	    if (c) {
		unsigned char d;
		const unsigned char *s;

		s = text;

		do {
		    s++;
		    v++;

		    d = *s;
		    e = *v;
		    if (d ^ e) {
			if ((int) d < (int) e) {
			    unsigned slip;

			    left = v - (unsigned char *) fpnode_data;
			    slip = left < plus ? left : plus;
			    s -= left - slip;
			    c = *s;
			    text = s;
			    offset = slip;

			    fpnode_data = fpnode_data->fpnode_data[0];
			    if (fpnode_data) {
			    } else {
				delete = 0;
				if (1) {
				    goto fine;
				}
			    }
			} else {
			    unsigned slip;

			    plus = v - (unsigned char *) fpnode_data;
			    slip = left < plus ? left : plus;
			    s -= plus - slip;
			    c = *s;
			    text = s;
			    offset = slip;

			    fpnode_data = fpnode_data->fpnode_data[1];
			    if (fpnode_data) {
			    } else {
				delete = 0;
				if (1) {
				    goto fine;
				}
			    }
			}

			break;
		    } else {
			if (d) {
			} else {
			    delete = 1;

			    *find = fpnode_data + 1;

			    goto fine;
			}
		    }
		} while (1);
	    } else {
		delete = 1;

		*find = fpnode_data + 1;

		break;
	    }
	}
    }

  fine:
    return delete;
}


int
x1f4_find_tcword(void *tcline, const unsigned char *text, unsigned slip,
		 void **find)
{
    int delete;
    void *miss;

    miss = tcline(tcline)->link_a.fpline.fplink.fpnode_data[0];
    if (miss) {
	delete = find_word(miss, text, slip, find);
    } else {
	delete = 0;
    }

    return delete;
}
