/*
 * tcqb.g.c
 * Copyright (C) 2008-2010, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stddef.h>

#include <tcqp-names.h>
#include <tcqp-types.h>

#define __BINARY_MODE__			1

#define tcline(tcline)			((struct tcline_type *) (tcline))

static int find_list(struct fpnode_type *, void *, unsigned,
		     int (*) (void *, void *), void **);

static int
find_list(struct fpnode_type *fpnode_data, void *text, unsigned offset,
	  int (*land) (void *, void *), void **find)
{
    int delete = 1;
    struct fpnode_type *fpnode_slip = NULL;

    offset += sizeof(struct fpnode_type);

    while (1) {
	int slip;

	slip = land(text, (char *) fpnode_data + offset);
#if __BINARY_MODE__
	if (0) {
	} else {
	    if (slip < 0) {
		fpnode_data = fpnode_data->fpnode_data[0];
		if (fpnode_data) {
		} else {
		    break;
		}
	    } else {
		delete = slip;
		fpnode_slip = fpnode_data;

		fpnode_data = fpnode_data->fpnode_data[1];
		if (fpnode_data) {
		} else {
		    break;
		}
	    }
	}
#else
	if (!slip) {
	    fpnode_slip = fpnode_data;

	    if (1) {
		fpnode_data = fpnode_data->fpnode_data[1];
		if (fpnode_data) {
		} else {
		    break;
		}
	    }
	} else {
	    if (slip < 0) {
		fpnode_data = fpnode_data->fpnode_data[0];
		if (fpnode_data) {
		} else {
		    break;
		}
	    } else {
		fpnode_data = fpnode_data->fpnode_data[1];
		if (fpnode_data) {
		} else {
		    break;
		}
	    }
	}
#endif				/* __BINARY_MODE__ */
    }

#if __BINARY_MODE__
    if (delete) {
	delete = 0;
    } else {
	delete = 1;
	if (1) {
	    *find = fpnode_slip + 1;
	}
    }
#else
    if (fpnode_slip) {
	delete = 1;
	if (1) {
	    *find = fpnode_slip + 1;
	}
    } else {
	delete = 0;
    }
#endif				/* __BINARY_MODE__ */

    return delete;
}


int
x1f4_lmxd_tcline(void *tcline, void *text, unsigned slip,
		 int (*land) (void *, void *), void **find)
{
    int delete;
    void *miss;

    miss = tcline(tcline)->link_a.fpline.fplink.fpnode_data[0];
    if (miss) {
	delete = find_list(miss, text, slip, land, find);
    } else {
	delete = 0;
    }

    return delete;
}
