/*
 * tcxv.i.c
 * Copyright (C) 2008-2009, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <tcxx-config.h>

#include <stddef.h>

#include <tcxx-inter.h>
#include <tcxx-names.h>
#include <tcxx-types.h>

#define __SLICE_UPLINK__		1
#define __TRACE_UPLINK__		2

#define ________UPLINK__		0

#if ____CLASS_DELETE__ == __SLICE_DELETE__
# define __CLASS_UPLINK__		__SLICE_UPLINK__
#elif __CLASS_DELETE__ == __TRACE_DELETE__
# define __CLASS_UPLINK__		__TRACE_UPLINK__
#else
# define __CLASS_UPLINK__		________UPLINK__
#endif				/* ____CLASS_DELETE__ == __SLICE_DELETE__ */

#define ____CLASS_UPLINK__		__CLASS_UPLINK__

#if ____CLASS_DELETE__ == __SLICE_DELETE__
# undef __CLASS_DELETE__
# define __CLASS_DELETE__		__TRACE_DELETE__
#endif				/* ____CLASS_DELETE__ == __SLICE_DELETE__ */

/*
 * __SCOPE_UPLINK__ method is buggy, for if processing stops the tree is left
 * messed up
 */
#define __SCOPE_UPLINK__		1
#define __SHORT_UPLINK__		2

#define __________LINK__		0

#if ____CLASS_DELETE__ == __TRACE_DELETE__
# define __BREAK_UPLINK__		__SHORT_UPLINK__
#else
# define __BREAK_UPLINK__		__________LINK__
#endif				/* ____CLASS_DELETE__ == __TRACE_DELETE__ */

#define ____BREAK_UPLINK__		__BREAK_UPLINK__

#if ____BREAK_UPLINK__ == __SHORT_UPLINK__
# define shift_break(fsnode_data, fxnode_data, fznode_data) \
    {									      \
	(fznode_data) = (fxnode_data)->fpnode_data[1];			      \
	(fxnode_data)->fpnode_data[1] = (fsnode_data);			      \
    }
#endif				/* ____BREAK_UPLINK__ == __SHORT_UPLINK__ */

#define tclist(tclist)			((struct tclist_type *) (tclist))

int
_libx1f4l2_away_tclist(void *tclist, void *back, int (*call) (void *, void *))
{
    int delete;
#if ____CLASS_DELETE__ == __STACK_DELETE__
    int status = 0;
#endif				/* ____CLASS_DELETE__ == __STACK_DELETE__ */
#if ____BREAK_UPLINK__ == __SHORT_UPLINK__
    struct fpnode_type *ffnode_data;
#endif				/* ____BREAK_UPLINK__ == __SHORT_UPLINK__ */
#if ____CLASS_DELETE__ == __TRACE_DELETE__
    struct fpnode_type *fhnode_data;
#endif				/* ____CLASS_DELETE__ == __TRACE_DELETE__ */
#if ____CLASS_DELETE__ == __STACK_DELETE__
    struct fpnode_type **fpmiss;
#endif				/* ____CLASS_DELETE__ == __STACK_DELETE__ */
    struct fpnode_type fpnode, *fpnode_data;
#if ____CLASS_DELETE__ == __STACK_DELETE__
    unsigned miss = 1, seek;
#endif				/* ____CLASS_DELETE__ == __STACK_DELETE__ */

#if ____CLASS_DELETE__ == __STACK_DELETE__
    seek = tclist(tclist)->link_e.seek;
#endif				/* ____CLASS_DELETE__ == __STACK_DELETE__ */

#if ____CLASS_DELETE__ == __STACK_DELETE__
    fpmiss = tclist(tclist)->link_e.fpmiss;
#endif				/* ____CLASS_DELETE__ == __STACK_DELETE__ */

#if ____CLASS_DELETE__ == __STACK_DELETE__
    fpmiss[0] = &tclist(tclist)->link_a.fplist.fplink;
#endif				/* ____CLASS_DELETE__ == __STACK_DELETE__ */

#if ____CLASS_DELETE__ == __TRACE_DELETE__
    fhnode_data = &tclist(tclist)->link_a.fplist.fplink;
#endif				/* ____CLASS_DELETE__ == __TRACE_DELETE__ */

#if ____BREAK_UPLINK__ == __SHORT_UPLINK__
    ffnode_data = fhnode_data;
#endif				/* ____BREAK_UPLINK__ == __SHORT_UPLINK__ */

    fpnode_data = tclist(tclist)->link_a.fplist.fplink.fpnode_data[0];

    while (1) {
	struct fpnode_type *fpnode_miss;

	fpnode_miss = fpnode_data->fpnode_data[1];
	if (fpnode_miss) {
	} else {
	    break;
	}

#if ____BREAK_UPLINK__ == __SHORT_UPLINK__
	if (fpnode_data->fqnode.tilt) {
	} else {
	    ffnode_data = fhnode_data;
	}
#endif				/* ____BREAK_UPLINK__ == __SHORT_UPLINK__ */

#if ____CLASS_DELETE__ == __STACK_DELETE__
	if (fpnode_data->fqnode.tilt) {
	} else {
	    miss--;

	    fpmiss[0] = fpmiss[miss];

	    miss = 1;
	}
#endif				/* ____CLASS_DELETE__ == __STACK_DELETE__ */

#if ____CLASS_DELETE__ == __STACK_DELETE__
	if (miss == seek) {
	    status = _libx1f4l2_blue_tclist(tclist, &fpmiss, &seek);
	    if (status) {
		/*
		 * TODO
		 *
		 * list is in an inconsistent state - only operation that
		 * should work fine is destroying it.
		 */
		break;
	    }
	}
#endif				/* ____CLASS_DELETE__ == __STACK_DELETE__ */

#if ____CLASS_DELETE__ == __STACK_DELETE__
	fpmiss[miss] = fpnode_data;
#endif				/* ____CLASS_DELETE__ == __STACK_DELETE__ */

#if ____CLASS_DELETE__ == __STACK_DELETE__
	miss++;
#endif				/* ____CLASS_DELETE__ == __STACK_DELETE__ */

	fpnode_data->fqnode.size--;

#if ____CLASS_DELETE__ == __STACK_DELETE__
	fpnode_data = fpnode_data->fpnode_data[1];
#elif __BREAK_UPLINK__ == __SHORT_UPLINK__
	fhnode_data = fpnode_data;
	fpnode_data = fpnode_data->fpnode_data[1];
#elif __CLASS_DELETE__ == __TRACE_DELETE__
	if (1) {
	    struct fpnode_type *fsnode_data;

	    fsnode_data = fpnode_data->fpnode_data[1];
	    fpnode_data->fpnode_data[1] = fhnode_data;
#endif				/* ____CLASS_DELETE__ == __STACK_DELETE__ */
#if ____BREAK_UPLINK__ == __SHORT_UPLINK__
#elif __CLASS_UPLINK__ == __SLICE_UPLINK__
	    SET_T(fpnode_data, slip);
#endif				/* ____BREAK_UPLINK__ == __SHORT_UPLINK__ */
#if ____BREAK_UPLINK__ == __SHORT_UPLINK__
#elif __CLASS_DELETE__ == __TRACE_DELETE__
	    fhnode_data = fpnode_data;

	    fpnode_data = fsnode_data;
	}
#endif				/* ____BREAK_UPLINK__ == __SHORT_UPLINK__ */
    }

#if ____CLASS_DELETE__ == __STACK_DELETE__
    if (status) {
	delete = status;
#elif 0
    }
#elif __CLASS_DELETE__ == __TRACE_DELETE__
    if (0) {
#endif				/* ____CLASS_DELETE__ == __STACK_DELETE__ */
    } else {
	fpnode = *fpnode_data;

	delete = call(back, fpnode_data);
    }

#if ____CLASS_DELETE__ == __STACK_DELETE__
    if (status) {
#elif 0
    }
#elif __CLASS_DELETE__ == __TRACE_DELETE__
    if (0) {
#endif				/* ____CLASS_DELETE__ == __STACK_DELETE__ */
    } else if (delete) {
	struct fpnode_type *fvnode_data;

	fvnode_data = tclist(tclist)->link_a.fplist.fplink.fpnode_data[0];

#if ____CLASS_DELETE__ == __STACK_DELETE__
	status = delete;
#endif				/* ____CLASS_DELETE__ == __STACK_DELETE__ */

	while (fvnode_data != fpnode_data) {
	    fvnode_data->fqnode.size++;
	    fvnode_data = fvnode_data->fpnode_data[1];
	}
    } else {
#if ____CLASS_DELETE__ == __TRACE_DELETE__
	struct fpnode_type *fvnode_data;
#endif				/* ____CLASS_DELETE__ == __TRACE_DELETE__ */

	tclist(tclist)->link_a.fplist.fplink.fpnode_data[1] =
	    tclist(tclist)->link_a.fplist.fplink.fpnode_data[0];

#if ____BREAK_UPLINK__ == __SHORT_UPLINK__
	if (ffnode_data == &tclist(tclist)->link_a.fplist.fplink) {
	    fvnode_data = tclist(tclist)->link_a.fplist.fplink.fpnode_data[1];
	} else {
	    fvnode_data = ffnode_data->fpnode_data[1];
	}
	fhnode_data = ffnode_data;
	if (fvnode_data == fpnode_data) {
	} else {
	    while (1) {
		struct fpnode_type *fqnode_data;

		shift_break(fhnode_data, fvnode_data, fqnode_data);
		if (fqnode_data == fpnode_data) {
		    if (1) {
			fhnode_data = fvnode_data;
		    }

		    break;
		} else {
		    shift_break(fvnode_data, fqnode_data, fhnode_data);
		    if (fhnode_data == fpnode_data) {
			if (1) {
			    fhnode_data = fqnode_data;
			}

			break;
		    } else {
			shift_break(fqnode_data, fhnode_data, fvnode_data);
			if (fvnode_data == fpnode_data) {
			    if (0) {
				fhnode_data = fhnode_data;
			    }

			    break;
			}
		    }
		}
	    }
	}
#endif				/* ____BREAK_UPLINK__ == __SHORT_UPLINK__ */

	fpnode_data = &fpnode;

	do {
#if ____CLASS_DELETE__ == __TRACE_DELETE__
	    unsigned slip = 0;
#endif				/* ____CLASS_DELETE__ == __TRACE_DELETE__ */

	    if (1) {
#if ____CLASS_DELETE__ == __STACK_DELETE__
		fpmiss[miss - 1]->fpnode_data[1] = fpnode_data->fpnode_data[0];
#elif __CLASS_DELETE__ == __TRACE_DELETE__
		fvnode_data = fpnode_data->fpnode_data[0];
#endif				/* ____CLASS_DELETE__ == __STACK_DELETE__ */
	    }

	    while (1) {
		struct fpnode_type *fqnode_data;

#if ____CLASS_DELETE__ == __STACK_DELETE__
		miss--;
		if (miss) {
		} else {
		    break;
		}
#endif				/* ____CLASS_DELETE__ == __STACK_DELETE__ */

#if ____CLASS_DELETE__ == __STACK_DELETE__
		fqnode_data = fpmiss[miss];
#endif				/* ____CLASS_DELETE__ == __STACK_DELETE__ */

#if ____BREAK_UPLINK__ == __SHORT_UPLINK__
		if (fhnode_data == ffnode_data) {
		    fhnode_data->fpnode_data[1] = fvnode_data;
#elif 0
		}
#elif __CLASS_DELETE__ == __TRACE_DELETE__
		if (fhnode_data == &tclist(tclist)->link_a.fplist.fplink) {
		    fhnode_data->fpnode_data[1] = fvnode_data;
#endif				/* ____BREAK_UPLINK__ == __SHORT_UPLINK__ */
#if ____CLASS_DELETE__ == __TRACE_DELETE__

		    break;
		} else {
		    fqnode_data = fhnode_data;
		    fhnode_data = fqnode_data->fpnode_data[1];
		    fqnode_data->fpnode_data[1] = fvnode_data;
		    fvnode_data = fqnode_data;
#endif				/* ____CLASS_DELETE__ == __TRACE_DELETE__ */
#if ____CLASS_DELETE__ == __TRACE_DELETE__

		    if (slip) {
			continue;
		    }
		}
#endif				/* ____CLASS_DELETE__ == __TRACE_DELETE__ */

#if ____CLASS_DELETE__ == __STACK_DELETE__
		if (1) {
#elif 0
		}
#elif __CLASS_DELETE__ == __TRACE_DELETE__
		if (1) {
#endif				/* ____CLASS_DELETE__ == __STACK_DELETE__ */
		    int tilt;

		    tilt = fqnode_data->fqnode.tilt;

		    tilt--;

		    fqnode_data->fqnode.tilt = tilt;

		    if (tilt == -1) {
#if ____CLASS_DELETE__ == __TRACE_DELETE__
			slip |= 4096;
#elif __CLASS_DELETE__ == __STACK_DELETE__
			break;
#endif				/* ____CLASS_DELETE__ == __TRACE_DELETE__ */
		    } else {
			if (tilt == -2) {
			    struct fpnode_type *fxnode_data;

			    fxnode_data = fqnode_data->fpnode_data[0];
			    if (fxnode_data->fqnode.tilt == 1) {
				int slip;
				struct fpnode_type *fbnode_data, *fdnode_data,
				    *fwnode_data;
				unsigned sx_b, sx_d;

				fwnode_data = fxnode_data->fpnode_data[1];
				fbnode_data = fwnode_data->fpnode_data[0];
				fxnode_data->fpnode_data[1] = fbnode_data;
				fwnode_data->fpnode_data[0] = fxnode_data;
				fdnode_data = fwnode_data->fpnode_data[1];
				fqnode_data->fpnode_data[0] = fdnode_data;
				fwnode_data->fpnode_data[1] = fqnode_data;
				slip = fwnode_data->fqnode.tilt;
				fwnode_data->fqnode.tilt = 0;
				if (slip == -1) {
				    fxnode_data->fqnode.tilt = 0;
				    fqnode_data->fqnode.tilt = 1;
				} else {
				    if (!slip) {
					fxnode_data->fqnode.tilt = 0;
					fqnode_data->fqnode.tilt = 0;
				    } else {
					fxnode_data->fqnode.tilt = -1;
					fqnode_data->fqnode.tilt = 0;
				    }
				}
#if ____CLASS_DELETE__ == __STACK_DELETE__
				fpmiss[miss - 1]->fpnode_data[1] = fwnode_data;
#elif __CLASS_DELETE__ == __TRACE_DELETE__
				fvnode_data = fwnode_data;
#endif				/* ____CLASS_DELETE__ == __STACK_DELETE__ */
				if (fbnode_data) {
				    sx_b = fbnode_data->fqnode.size;
				} else {
				    sx_b = 0;
				}
				if (fdnode_data) {
				    sx_d = fdnode_data->fqnode.size;
				} else {
				    sx_d = 0;
				}
				if (1) {
				    unsigned sx_w, sx_v, sx_x;

				    sx_v = fxnode_data->fqnode.size;
				    sx_w = fwnode_data->fqnode.size;
				    sx_x = fqnode_data->fqnode.size;
				    fxnode_data->fqnode.size =
					sx_v + sx_b - sx_w;
				    fwnode_data->fqnode.size = sx_x;
				    fqnode_data->fqnode.size =
					sx_x + sx_d - sx_v;
				}
			    } else {
				struct fpnode_type *fmnode_data;
				unsigned sx_m;

				fmnode_data = fxnode_data->fpnode_data[1];
				fqnode_data->fpnode_data[0] = fmnode_data;
				fxnode_data->fpnode_data[1] = fqnode_data;
#if ____CLASS_DELETE__ == __STACK_DELETE__
				fpmiss[miss - 1]->fpnode_data[1] = fxnode_data;
#elif __CLASS_DELETE__ == __TRACE_DELETE__
				fvnode_data = fxnode_data;
#endif				/* ____CLASS_DELETE__ == __STACK_DELETE__ */
				if (fmnode_data) {
				    sx_m = fmnode_data->fqnode.size;
				} else {
				    sx_m = 0;
				}
				if (1) {
				    unsigned sx_q, sx_x;

				    sx_x = fxnode_data->fqnode.size;
				    sx_q = fqnode_data->fqnode.size;
				    fxnode_data->fqnode.size = sx_q;
				    fqnode_data->fqnode.size =
					sx_q + sx_m - sx_x;
				}
				if (fxnode_data->fqnode.tilt) {
				    fqnode_data->fqnode.tilt = 0;
				    fxnode_data->fqnode.tilt = 0;
				} else {
				    fqnode_data->fqnode.tilt = -1;
				    fxnode_data->fqnode.tilt = 1;
#if ____CLASS_DELETE__ == __TRACE_DELETE__
				    slip |= 4096;
#elif __CLASS_DELETE__ == __STACK_DELETE__
				    break;
#endif				/* ____CLASS_DELETE__ == __TRACE_DELETE__ */
				}
			    }
			}
		    }
		}
	    }
	} while (0);

	tclist(tclist)->link_a.fplist.fplink.fpnode_data[0] =
	    tclist(tclist)->link_a.fplist.fplink.fpnode_data[1];
    }

#if ____CLASS_DELETE__ == __TRACE_DELETE__
    return delete;
#elif __CLASS_DELETE__ == __STACK_DELETE__
    return status;
#endif				/* ____CLASS_DELETE__ == __TRACE_DELETE__ */
}
