/*
 * tcxx-inter.h
 * Copyright (C) 2008-2010, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <config.h>

#ifndef __LIBx1f4_tcxx_inter_H__
#define __LIBx1f4_tcxx_inter_H__

#include <tcxx-names.h>
#include <tcxx-types.h>

#if !defined _libx1f4l2_fast_tclist
# define _libx1f4l2_fast_tclist		x1f4_fast_tclist
#endif				/* !_libx1f4l2_fast_tclist */
#if !defined _libx1f4l2_fini_tclist
# define _libx1f4l2_fini_tclist		x1f4_fini_tclist
#endif				/* !_libx1f4l2_fini_tclist */
#if !defined _libx1f4l2_flat_tclist
# define _libx1f4l2_flat_tclist		x1f4_flat_tclist
#endif				/* !_libx1f4l2_flat_tclist */
#if !defined _libx1f4l2_init_tclist
# define _libx1f4l2_init_tclist		x1f4_init_tclist
#endif				/* !_libx1f4l2_init_tclist */
#if !defined _libx1f4l2_move_tclist
# define _libx1f4l2_move_tclist		x1f4_move_tclist
#endif				/* !_libx1f4l2_move_tclist */
#if !defined _libx1f4l2_spin_tclist
# define _libx1f4l2_spin_tclist		x1f4_spin_tclist
#endif				/* !_libx1f4l2_spin_tclist */

extern int _libx1f4l2_away_tclist(void *, void *, int (*) (void *, void *));
extern int _libx1f4l2_beta_tclist(void *, void *);
extern int _libx1f4l2_blue_tclist(void *, void *, unsigned *);
extern int _libx1f4l2_case_tclist(void *, unsigned, void *, void **);
extern int _libx1f4l2_ceil_tclist(void *);
extern int _libx1f4l2_dana_tclist(void *, void *);
extern int _libx1f4l2_dawn_tclist
    (void *, void *, void *, int (*) (void *, void *, void *), unsigned);
extern int _libx1f4l2_elif_tclist
    (void *, void *, int (*) (void *, void *), unsigned, unsigned, void **,
     int (*) (void *, unsigned, void **));
extern int _libx1f4l2_else_tclist(void *, unsigned, void **);
extern int _libx1f4l2_fair_tclist(void *, unsigned, void *, unsigned);
extern int _libx1f4l2_fast_tclist(void *, unsigned, struct screen_type *);
extern int _libx1f4l2_fini_tclist(void **);
extern int _libx1f4l2_flat_tclist(void *);
extern int _libx1f4l2_half_tclist(void *, unsigned char **, unsigned *);
extern int _libx1f4l2_here_tclist(void *, unsigned, void **);
extern int _libx1f4l2_init_tclist(void **, unsigned, struct screen_type *);
extern int _libx1f4l2_lane_tclist(void *, unsigned, unsigned);
extern int _libx1f4l2_long_tclist(void *, void *, int (*) (void *, void *));
extern int _libx1f4l2_lose_tclist(void *, unsigned, void **);
extern int _libx1f4l2_moon_tclist(void *, unsigned, void *);
extern int _libx1f4l2_move_tclist(void *, unsigned, unsigned);
extern int _libx1f4l2_nand_tclist
    (void *, unsigned, void *, int (*) (void *, void *));
extern int _libx1f4l2_rail_tclist
    (void *, void *, int (*) (void *, unsigned *, const void *),
     int (*) (void *, void *, const void *), int (*) (void *, void *), void *);
extern int _libx1f4l2_spin_tclist(void *, unsigned, unsigned);

#endif				/* __LIBx1f4_tcxx_inter_H__ */
