/*
 * tcxx.d.c
 * Copyright (C) 2008-2009, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <tcxx-defs.h>
#include <tcxx-inter.h>
#include <tcxx-names.h>
#include <tcxx-types.h>

#define tclist(tclist)			((struct tclist_type *) (tclist))

int
x1f4_line_tclist(void *tcdata, void *tctext,
		 int (*size) (void *, unsigned *, const void *),
		 int (*copy) (void *, void *, const void *),
		 int (*free) (void *, void *), void *context)
{
    int status;

    if (tclist(tcdata)->link_a.fplist.fplink.fqnode.size) {
	status = SIZE_ERROR;
    } else {
	if (tclist(tctext)->link_a.fplist.fplink.fqnode.size) {
	    status = _libx1f4l2_rail_tclist
		(tcdata, tctext, size, copy, free, context);
	} else {
	    status = 0;
	}
    }

    return status;
}
