/*
 * tcxx.k.c
 * Copyright (C) 2008-2009, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <tcxx-config.h>

#include <tcxx-defs.h>
#include <tcxx-names.h>
#include <tcxx-types.h>

#define tclist(tclist)			((struct tclist_type *) (tclist))

int
_libx1f4l2_blue_tclist(void *tclist, void *fpclip, unsigned *size)
{
#if !__ELINK_TARGET__
# define status				0
#endif				/* !__ELINK_TARGET__ */

#if __ELINK_TARGET__
    int status;
    struct fpnode_type ***fpmiss;
    unsigned delete;
    void *miss;
#endif				/* __ELINK_TARGET__ */

#if __ELINK_TARGET__
    delete = *size << 1;

    fpmiss = fpclip;

    miss = *fpmiss;

    status = tclist(tclist)->link_m.mode
	(tclist(tclist)->link_m.data, &miss,
	 delete * sizeof(struct fpnode_type *));
    if (status) {
	status = MODE_ERROR;
    } else {
	*fpmiss = miss;
	*size = delete;

	tclist(tclist)->link_e.fpmiss = miss;
	tclist(tclist)->link_e.seek = delete;
    }
#endif				/* __ELINK_TARGET__ */

    return status;

#if !__ELINK_TARGET__
# undef status
#endif				/* !__ELINK_TARGET__ */
}
