/*
 * tcxy.c.c
 * Copyright (C) 2008-2009, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <tcxx-names.h>
#include <tcxx-types.h>

#define tclist(tclist)			((struct tclist_type *) (tclist))

static int find_list(void *, void *, unsigned, int (*) (void *, void *),
		     void **);

static int
find_list(void *tclist, void *text, unsigned offset,
	  int (*land) (void *, void *), void **find)
{
    int delete;
    struct fpnode_type *fpnode_data;

    offset += sizeof(struct fpnode_type);

    fpnode_data = tclist(tclist)->link_a.fplist.fplink.fpnode_data[0];
    while (1) {
	int slip;

	slip = land(text, (char *) fpnode_data + offset);
	if (!slip) {
	    delete = 1;

	    *find = fpnode_data + 1;

	    break;
	} else {
	    if (slip < 0) {
		fpnode_data = fpnode_data->fpnode_data[0];
		if (fpnode_data) {
		} else {
		    delete = 0;
		    if (1) {
			break;
		    }
		}
	    } else {
		fpnode_data = fpnode_data->fpnode_data[1];
		if (fpnode_data) {
		} else {
		    delete = 0;
		    if (1) {
			break;
		    }
		}
	    }
	}
    }

    return delete;
}


int
x1f4_find_tclist(void *tclist, void *text, unsigned slip,
		 int (*land) (void *, void *), void **find)
{
    int delete;

    if (tclist(tclist)->link_a.fplist.fplink.fqnode.size) {
	delete = find_list(tclist, text, slip, land, find);
    } else {
	delete = 0;
    }

    return delete;
}
