/*
 * tfqp.n.c
 * Copyright (C) 2008-2009, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stddef.h>
#include <stdlib.h>

#include <tfqp-names.h>
#include <tfqp-types.h>

#define sLEFT(___size, ___node) \
    {									      \
	unsigned ___fine;						      \
									      \
	___fine = ___node->fqnode.fine;					      \
	if (___fine & 1) {						      \
	    unsigned ___swap;						      \
									      \
	    ___fine >>= 1;						      \
									      \
	    ___swap = ___size - 1 - ___fine;				      \
	    ___size = ___fine;						      \
									      \
	    ___node->fqnode.fine = ___swap << 1;			      \
	} else {							      \
	    ___size = ___size - 1 - (___fine >> 1);			      \
	}								      \
    }

#define sLESS(___size, ___node) \
    {									      \
	unsigned ___fine;						      \
									      \
	___fine = ___node->fqnode.fine;					      \
	if (___fine & 1) {						      \
	    ___size = ___size - 1 - (___fine >> 1);			      \
	} else {							      \
	    unsigned ___swap;						      \
									      \
	    ___fine >>= 1;						      \
									      \
	    ___swap = ___size - 1 - ___fine;				      \
	    ___size = ___fine;						      \
									      \
	    ___node->fqnode.fine = ___swap << 1 | 1;			      \
	}								      \
    }

static int size_tree(unsigned *, struct fpnode_type *);

static int
size_tree(unsigned *size, struct fpnode_type *fpnode_data)
{
    if (fpnode_data) {
	(*size)++;
	size_tree(size, fpnode_data->fpnode_data[0]);
	size_tree(size, fpnode_data->fpnode_data[1]);
    }

    return 0;
}


int
_libx1f4l2_join_tfline(void *fpnode, void *fbnode, void *fdnode)
{
    unsigned fine = 0, none = 0, size;

    size_tree(&fine, fbnode);
    size_tree(&none, fdnode);

    size = fine + none;

    if (size) {
	struct fpnode_type *fbnode_data, *fdnode_data, **fpmiss;

	fpmiss = fpnode;

	fbnode_data = fbnode;
	fdnode_data = fdnode;

	do {
	    if (rand() % size < fine) {
		*fpmiss = fbnode_data;
		fpmiss = fbnode_data->fpnode_data + 1;

		sLEFT(fine, fbnode_data);

		fbnode_data = fpmiss[0];
	    } else {
		*fpmiss = fdnode_data;
		fpmiss = fdnode_data->fpnode_data + 0;

		sLESS(none, fdnode_data);

		fdnode_data = fpmiss[0];
	    }

	    size = fine + none;
	} while (size);
    } else {
	struct fpnode_type **fpmiss;

	fpmiss = fpnode;

	*fpmiss = NULL;
    }

    return 0;
}
