/*
 * tnqp.m.c
 * Copyright (C) 2008-2009, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <tnqp-config.h>

#include <tnqp-defs.h>
#include <tnqp-types.h>

#define tnline(tnline)			((struct tnline_type *) (tnline))

int
_libx1f4l2_half_tnline(void *tnline, unsigned char **data, unsigned *size)
{
#if !__QLINK_TARGET__
# define status				0
#endif				/* !__QLINK_TARGET__ */

#if __QLINK_TARGET__
    int status;
    unsigned half;
    void *miss;
#endif				/* __QLINK_TARGET__ */

#if __QLINK_TARGET__
    half = *size << 1;

    miss = *data;

    status = tnline(tnline)->link_m.mode
	(tnline(tnline)->link_m.data, &miss, half);
    if (status) {
	status = MODE_ERROR;
    } else {
	*data = miss;
	*size = half;

	tnline(tnline)->link_c.data = miss;
	tnline(tnline)->link_c.size = half;
    }
#endif				/* __QLINK_TARGET__ */

    return status;

#if !__QLINK_TARGET__
# undef status
#endif				/* !__QLINK_TARGET__ */
}
