/*
 * tnqp.v.c
 * Copyright (C) 2008-2010, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <tnqp-config.h>

#include <stddef.h>

#include <tnqp-defs.h>
#include <tnqp-inter.h>
#include <tnqp-types.h>

#define eBLACK(fpnode) \
    ((fpnode)->fqnode.bits & cBLACK)

#define fBLACK(fpnode) \
    ((fpnode)->fqnode.bits &= ~cBLACK)

#define sBLACK(fpnode) \
    ((fpnode)->fqnode.bits |= cBLACK)

#define tnline(tnline)			((struct tnline_type *) (tnline))

int
_libx1f4l2_even_tnline(void *tnline, void *text, int (*land) (void *, void *),
		       unsigned offset, unsigned flat, void **push,
		       int (*line) (void *, unsigned, void **))
{
    int status = 0;
#if ____CLASS_INSERT__ == __STACK_INSERT__
    struct fpnode_type **fpmiss;
#endif				/* ____CLASS_INSERT__ == __STACK_INSERT__ */
    struct fpnode_type *fpnode_data;
#if ____CLASS_INSERT__ == __STACK_INSERT__
    unsigned miss = 1, seek, size;
#endif				/* ____CLASS_INSERT__ == __STACK_INSERT__ */
#if ____CLASS_INSERT__ == __STACK_INSERT__
    unsigned char *data;
#endif				/* ____CLASS_INSERT__ == __STACK_INSERT__ */
    void *tznode;

    fpnode_data = tnline(tnline)->link_a.fpline.fplink.fpnode_data[0];

#if ____CLASS_INSERT__ == __STACK_INSERT__
    data = tnline(tnline)->link_c.data;
    size = tnline(tnline)->link_c.size;
#endif				/* ____CLASS_INSERT__ == __STACK_INSERT__ */

#if ____CLASS_INSERT__ == __STACK_INSERT__
    seek = tnline(tnline)->link_e.seek;
#endif				/* ____CLASS_INSERT__ == __STACK_INSERT__ */

#if ____CLASS_INSERT__ == __STACK_INSERT__
    fpmiss = tnline(tnline)->link_e.fpmiss;
#endif				/* ____CLASS_INSERT__ == __STACK_INSERT__ */

#if ____CLASS_INSERT__ == __STACK_INSERT__
    fpmiss[0] = &tnline(tnline)->link_a.fpline.fplink;
#endif				/* ____CLASS_INSERT__ == __STACK_INSERT__ */

#if ____CLASS_INSERT__ == __STACK_INSERT__
    data[0] = 0;
#endif				/* ____CLASS_INSERT__ == __STACK_INSERT__ */

    if (fpnode_data) {
	while (1) {
	    int slip;

	    slip = land(text, (char *) fpnode_data + offset);

	    if (1) {
#if ____CLASS_INSERT__ == __STACK_INSERT__
		if (miss == size) {
		    status = _libx1f4l2_half_tnline(tnline, &data, &size);
		    if (status) {
			break;
		    }
		}
#endif				/* ____CLASS_INSERT__ == __STACK_INSERT__ */

#if ____CLASS_INSERT__ == __STACK_INSERT__
		if (miss == seek) {
		    status = _libx1f4l2_blue_tnline(tnline, &fpmiss, &seek);
		    if (status) {
			break;
		    }
		}
#endif				/* ____CLASS_INSERT__ == __STACK_INSERT__ */

#if ____CLASS_INSERT__ == __STACK_INSERT__
		fpmiss[miss] = fpnode_data;
#endif				/* ____CLASS_INSERT__ == __STACK_INSERT__ */

		if (slip < 0) {
#if ____CLASS_INSERT__ == __STACK_INSERT__
		    data[miss] = 0;
#endif				/* ____CLASS_INSERT__ == __STACK_INSERT__ */

#if ____CLASS_INSERT__ == __STACK_INSERT__
		    miss++;
#endif				/* ____CLASS_INSERT__ == __STACK_INSERT__ */

		    fpnode_data = fpnode_data->fpnode_data[0];
		    if (fpnode_data) {
		    } else {
			if (1) {
			    break;
			}
		    }
		} else {
#if ____CLASS_INSERT__ == __STACK_INSERT__
		    data[miss] = 1;
#endif				/* ____CLASS_INSERT__ == __STACK_INSERT__ */

#if ____CLASS_INSERT__ == __STACK_INSERT__
		    miss++;
#endif				/* ____CLASS_INSERT__ == __STACK_INSERT__ */

		    fpnode_data = fpnode_data->fpnode_data[1];
		    if (fpnode_data) {
		    } else {
			if (1) {
			    break;
			}
		    }
		}
	    }
	}
    }

    if (status) {
    } else {
	status = line(tnline, flat, &tznode);
    }

    if (status) {
    } else {
	struct fpnode_type *fnnode_data;

	fnnode_data = tznode;

	*push = fnnode_data + 1;

	fnnode_data->fpnode_data[0] = NULL;
	fnnode_data->fpnode_data[1] = NULL;

	fnnode_data->fqnode.bits = 0;

	fpmiss[miss - 1]->fpnode_data[data[miss - 1]] = fnnode_data;

	if (0) {
	} else {
	    for (;;) {
		struct fpnode_type *ffnode_data, *fgnode_data;

		if (miss < 3) {
		    break;
		}

		ffnode_data = fpmiss[miss - 1];
		if (1) {
		    if (eBLACK(ffnode_data)) {
			break;
		    }
		}

		fgnode_data = fpmiss[miss - 2];

		if (data[miss - 2]) {
		    int fast;
		    struct fpnode_type *fynode_data;

		    fynode_data = fgnode_data->fpnode_data[0];
		    if (fynode_data) {
			fast = eBLACK(fynode_data);
		    } else {
			fast = 1;
		    }

		    if (fast) {
			if (data[miss - 1]) {
			} else {
			    fynode_data = ffnode_data->fpnode_data[0];
			    ffnode_data->fpnode_data[0] =
				fynode_data->fpnode_data[1];
			    fynode_data->fpnode_data[1] = ffnode_data;
			    fgnode_data->fpnode_data[1] = fynode_data;

			    ffnode_data = fynode_data;
			}

			fBLACK(fgnode_data);
			sBLACK(ffnode_data);

			if (1) {
			    struct fpnode_type *fdnode_data;

			    fdnode_data = ffnode_data->fpnode_data[0];
			    fgnode_data->fpnode_data[1] = fdnode_data;
			    ffnode_data->fpnode_data[0] = fgnode_data;

			    fpmiss[miss - 3]->fpnode_data[data[miss - 3]] =
				ffnode_data;
			}

			break;
		    } else {
			sBLACK(ffnode_data);
			sBLACK(fynode_data);
			fBLACK(fgnode_data);

			miss -= 2;
		    }
		} else {
		    int fast;
		    struct fpnode_type *fynode_data;

		    fynode_data = fgnode_data->fpnode_data[1];
		    if (fynode_data) {
			fast = eBLACK(fynode_data);
		    } else {
			fast = 1;
		    }

		    if (fast) {
			if (data[miss - 1]) {
			    fynode_data = ffnode_data->fpnode_data[1];
			    ffnode_data->fpnode_data[1] =
				fynode_data->fpnode_data[0];
			    fynode_data->fpnode_data[0] = ffnode_data;
			    fgnode_data->fpnode_data[0] = fynode_data;

			    ffnode_data = fynode_data;
			}

			fBLACK(fgnode_data);
			sBLACK(ffnode_data);

			if (1) {
			    struct fpnode_type *fdnode_data;

			    fdnode_data = ffnode_data->fpnode_data[1];
			    fgnode_data->fpnode_data[0] = fdnode_data;
			    ffnode_data->fpnode_data[1] = fgnode_data;

			    fpmiss[miss - 3]->fpnode_data[data[miss - 3]] =
				ffnode_data;
			}

			break;
		    } else {
			sBLACK(ffnode_data);
			sBLACK(fynode_data);
			fBLACK(fgnode_data);

			miss -= 2;
		    }
		}
	    }

	    sBLACK(tnline(tnline)->link_a.fpline.fplink.fpnode_data[0]);
	}
    }

    return status;
}
