/*
 * tqqp.v.c
 * Copyright (C) 2008-2010, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stddef.h>

#include <tqqp-defs.h>
#include <tqqp-types.h>

#define tqline(tqline)			((struct tqline_type *) (tqline))

int
_libx1f4l2_even_tqline(void *tqline, void *text, int (*land) (void *, void *),
		       unsigned offset, unsigned flat, void **push,
		       int (*line) (void *, unsigned, void **))
{
    int status;
    struct fpnode_type *fpnode_data, *fqnode_data;
    unsigned tilt = 0;
    void *tznode;

    fpnode_data = tqline(tqline)->link_a.fpline.fplink.fpnode_data[0];
    fqnode_data = NULL;

    if (!fpnode_data) {
	status = line(tqline, flat, &tznode);
	if (status) {
	} else {
	    struct fpnode_type *fnnode_data;

	    fnnode_data = tznode;

	    *push = fnnode_data + 1;

	    fnnode_data->fpnode_data[0] = NULL;
	    fnnode_data->fpnode_data[1] = NULL;

	    fnnode_data->uplink_data = NULL;

	    fnnode_data->fqnode.ever = 1;

	    tqline(tqline)->link_a.fpline.fplink.fpnode_data[0] = fnnode_data;
	}
    } else {
	while (1) {
	    int slip;

	    slip = land(text, (char *) fpnode_data + offset);

	    if (1) {
		if (slip < 0) {
		    fqnode_data = fpnode_data;
		    fpnode_data = fpnode_data->fpnode_data[0];
		    if (fpnode_data) {
		    } else {
			tilt = 0;
			status = line(tqline, flat, &tznode);
			if (1) {
			    break;
			}
		    }
		} else {
		    fqnode_data = fpnode_data;
		    fpnode_data = fpnode_data->fpnode_data[1];
		    if (fpnode_data) {
		    } else {
			tilt = 1;
			status = line(tqline, flat, &tznode);
			if (1) {
			    break;
			}
		    }
		}
	    }
	}

	if (status) {
	} else {
	    struct fpnode_type *fnnode_data, *fznode_data;

	    fnnode_data = tznode;

	    *push = fnnode_data + 1;

	    fnnode_data->fpnode_data[0] = NULL;
	    fnnode_data->fpnode_data[1] = NULL;

	    fqnode_data->fpnode_data[tilt] = fnnode_data;

	    fnnode_data->uplink_data = fqnode_data;

	    fnnode_data->fqnode.ever = 1;

	    fznode_data = &tqline(tqline)->link_a.fpline.fplink;

	    fznode_data->fpnode_data[0]->uplink_data = fznode_data;

	    do {
		struct fpnode_type *fjnode_data;

		fjnode_data = fqnode_data->fpnode_data[0];
		if (fjnode_data) {
		    if (fqnode_data->fqnode.ever
			!= fjnode_data->fqnode.ever + 1) {
			struct fpnode_type *fsnode_data;

			fsnode_data = fqnode_data->uplink_data;
			if (fqnode_data == fsnode_data->fpnode_data[0]) {
			    fsnode_data->fpnode_data[0] = fjnode_data;
			} else {
			    fsnode_data->fpnode_data[1] = fjnode_data;
			}

			fjnode_data->uplink_data = fsnode_data;
			fqnode_data->uplink_data = fjnode_data;

			fsnode_data = fjnode_data->fpnode_data[1];
			fqnode_data->fpnode_data[0] = fsnode_data;
			if (fsnode_data) {
			    fsnode_data->uplink_data = fqnode_data;
			}

			fjnode_data->fpnode_data[1] = fqnode_data;

			if (fsnode_data) {
			    fqnode_data->fqnode.ever =
				fsnode_data->fqnode.ever + 1;
			} else {
			    fqnode_data->fqnode.ever = 1;
			}

			fsnode_data = fqnode_data->fpnode_data[1];
			if (fsnode_data) {
			    if (fqnode_data->fqnode.ever
				!= fsnode_data->fqnode.ever) {
				fqnode_data = fqnode_data->uplink_data;
			    }
			} else {
			    fqnode_data = fqnode_data->uplink_data;
			}
		    }
		} else {
		    if (fqnode_data->fqnode.ever != 1) {
			struct fpnode_type *fsnode_data;

			fsnode_data = fqnode_data->uplink_data;
			if (fqnode_data == fsnode_data->fpnode_data[0]) {
			    fsnode_data->fpnode_data[0] = fjnode_data;
			} else {
			    fsnode_data->fpnode_data[1] = fjnode_data;
			}

			fjnode_data->uplink_data = fsnode_data;
			fqnode_data->uplink_data = fjnode_data;

			fsnode_data = fjnode_data->fpnode_data[1];
			fqnode_data->fpnode_data[0] = fsnode_data;
			if (fsnode_data) {
			    fsnode_data->uplink_data = fqnode_data;
			}

			fjnode_data->fpnode_data[1] = fqnode_data;

			if (fsnode_data) {
			    fqnode_data->fqnode.ever =
				fsnode_data->fqnode.ever + 1;
			} else {
			    fqnode_data->fqnode.ever = 1;
			}

			fsnode_data = fqnode_data->fpnode_data[1];
			if (fsnode_data) {
			    if (fqnode_data->fqnode.ever
				!= fsnode_data->fqnode.ever) {
				fqnode_data = fqnode_data->uplink_data;
			    }
			} else {
			    fqnode_data = fqnode_data->uplink_data;
			}
		    }
		}

		fpnode_data = fqnode_data->uplink_data;
		fjnode_data = fpnode_data->fpnode_data[1];
		if (fjnode_data) {
		    struct fpnode_type *fsnode_data;

		    fsnode_data = fjnode_data->fpnode_data[1];
		    if (fsnode_data) {
			if (fsnode_data->fqnode.ever
			    == fpnode_data->fqnode.ever) {
			    fsnode_data = fpnode_data->uplink_data;
			    if (fpnode_data == fsnode_data->fpnode_data[0]) {
				fsnode_data->fpnode_data[0] = fjnode_data;
			    } else {
				fsnode_data->fpnode_data[1] = fjnode_data;
			    }

			    fjnode_data->uplink_data = fsnode_data;
			    fpnode_data->uplink_data = fjnode_data;

			    fsnode_data = fjnode_data->fpnode_data[0];
			    fpnode_data->fpnode_data[1] = fsnode_data;
			    if (fsnode_data) {
				fsnode_data->uplink_data = fpnode_data;
			    }

			    fjnode_data->fpnode_data[0] = fpnode_data;
			    fjnode_data->fqnode.ever =
				fpnode_data->fqnode.ever + 1;
			} else {
			    break;
			}
		    } else {
			break;
		    }
		} else {
		    break;
		}

		fqnode_data = fqnode_data->uplink_data;
	    } while (fqnode_data != fznode_data);

	    fznode_data->fpnode_data[0]->uplink_data = NULL;
	}
    }

    return status;
}
