/*
 * tsqb.m.c
 * Copyright (C) 2008-2010, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stddef.h>

#include <sign.x.h>
#include <tsqp-names.h>
#include <tsqp-types.h>

#define __SIGN_SELECT__			1
#define __TEST_SELECT__			2

#define __HERE_SELECT__			__SIGN_SELECT__

#define ____HERE_SELECT__		__HERE_SELECT__

#define WAY_L(fpnode_data) \
    ((fpnode_data)->fqnode.fbnode.bits & LAST_T)
#define WAY_N(fpnode_data) \
    ((fpnode_data)->fqnode.fbnode.bits & NEXT_T)

#define WAY_X(fpnode_data, select) \
    ((fpnode_data)->fqnode.fbnode.bits & DECK_T((select)))

#define tsline(tsline)			((struct tsline_type *) (tsline))

static int find_list(struct fpnode_type *, void *, unsigned,
		     int (*) (void *, void *), void **);

static int
find_list(struct fpnode_type *fpnode_data, void *text, unsigned offset,
	  int (*land) (void *, void *), void **find)
{
    int delete;
#if ____HERE_SELECT__ == __TEST_SELECT__
    struct fpnode_type *fpnode_slip = NULL;
#elif __HERE_SELECT__ == __SIGN_SELECT__
    struct fpnode_type *fpnode_slip[2];
#endif				/* ____HERE_SELECT__ == __TEST_SELECT__ */

#if ____HERE_SELECT__ == __SIGN_SELECT__
    fpnode_slip[1] = NULL;
#endif				/* ____HERE_SELECT__ == __SIGN_SELECT__ */

    offset += sizeof(struct fpnode_type);

    while (1) {
	int slip;

	slip = land(text, (char *) fpnode_data + offset);
	if (0) {
	} else {
#if ____HERE_SELECT__ == __SIGN_SELECT__
	    slip = trans_integer(slip);

	    fpnode_slip[slip] = fpnode_data;

	    if (WAY_X(fpnode_data, slip)) {
		if (1) {
		    break;
		}
	    } else {
		fpnode_data = fpnode_data->fpnode_data[slip];
	    }
#else
	    if (slip < 1) {
		if (WAY_L(fpnode_data)) {
		    if (1) {
			break;
		    }
		} else {
		    fpnode_data = fpnode_data->fpnode_data[0];
		}
	    } else {
		fpnode_slip = fpnode_data;

		if (WAY_N(fpnode_data)) {
		    if (1) {
			break;
		    }
		} else {
		    fpnode_data = fpnode_data->fpnode_data[1];
		}
	    }
#endif				/* ____HERE_SELECT__ == __SIGN_SELECT__ */
	}
    }

#if ____HERE_SELECT__ == __TEST_SELECT__
    if (fpnode_slip) {
	delete = 1;
	if (1) {
	    *find = fpnode_slip + 1;
	}
    } else {
	delete = 0;
    }
#else
    if (fpnode_slip[1]) {
	delete = 1;
	if (1) {
	    *find = fpnode_slip[1] + 1;
	}
    } else {
	delete = 0;
    }
#endif				/* ____HERE_SELECT__ == __TEST_SELECT__ */

    return delete;
}


int
x1f4_llxd_tsline(void *tsline, void *text, unsigned slip,
		 int (*land) (void *, void *), void **find)
{
    int delete;
    void *miss;

    miss = tsline(tsline)->link_a.fpline.fplink.fpnode_data[0];
    if (miss) {
	delete = find_list(miss, text, slip, land, find);
    } else {
	delete = 0;
    }

    return delete;
}
