/*
 * tsqp-types.h
 * Copyright (C) 2008-2010, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <config.h>

#ifndef __LIBx1f4_tsqp_types_H__
#define __LIBx1f4_tsqp_types_H__

#include <trans.h>

#define LAST_T				(1 << 4)
#define NEXT_T				(1 << 5)

#define FLAT_T				(LAST_T | NEXT_T)

#define DECK_T(___d)			(1 << (4 + (___d)))

typedef struct fbnode_type {
    unsigned short bits;
} fbnode_type;

typedef struct fqnode_type {
    short tilt;
    struct fbnode_type fbnode;
} fqnode_type;

typedef struct fpnode_type {
    struct fpnode_type *fpnode_data[2];
    struct fqnode_type fqnode;
} fpnode_type;

typedef struct fpline_type {
    struct fpnode_type fplink;
} fpline_type;

typedef struct screen_type {
    struct trans_type *trans_data;
} screen_type;

typedef struct tsline_type {
    struct {
	struct fpline_type fpline;
    } link_a;
    struct {
	int (*free) (void *, void *), (*link) (void *, void **, unsigned),
	    (*mode) (void *, void **, unsigned);
	void *data;
    } link_m;
} tsline_type;

#endif				/* __LIBx1f4_tsqp_types_H__ */
