/*
 * tvxx.9.c
 * Copyright (C) 2008-2010, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <tvxx-defs.h>
#include <tvxx-inter.h>
#include <tvxx-names.h>
#include <tvxx-types.h>

#define tvlist(tvlist)			((struct tvlist_type *) (tvlist))

static int fast_list(struct tvlist_type *, unsigned, unsigned);

static int
fast_list(struct tvlist_type *tvlist_data, unsigned index, unsigned class)
{
    int status;
    void *tvnode;

    status = _libx1f4l2_lose_tvlist(tvlist_data, index, &tvnode);
    if (status) {
    } else {
	if (index < class) {
	    class--;
	}

	status = _libx1f4l2_moon_tvlist(tvlist_data, class, tvnode);
	if (status) {
	    /*
	     * TODO/FEATURES
	     *
	     * some leakage here...
	     */
	}
    }

    return status;
}


int
x1f4_move_tvlist(void *tvlist, unsigned index, unsigned class)
{
    int status;
    unsigned count;

    count = tvlist(tvlist)->link_a.fplist.fplink.fqnode.size;

    if (!(index < count)) {
	status = DECK_ERROR;
    } else {
	if (count < class) {
	    status = DECK_ERROR;
	} else {
	    if (index == class) {
		status = 0;
	    } else {
		if (index + 1 == class) {
		    status = 0;
		} else {
		    status = fast_list(tvlist, index, class);
		}
	    }
	}
    }

    return status;
}
