/*
 * tvxy.e.c
 * Copyright (C) 2008-2010, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <tvxx-names.h>
#include <tvxx-types.h>

#define tvlist(tvlist)			((struct tvlist_type *) (tvlist))

static int tick_list(void *, void *, unsigned, int (*) (void *, void *),
		     unsigned *, void **);

static int
tick_list(void *tvlist, void *text, unsigned offset,
	  int (*land) (void *, void *), unsigned *seek, void **find)
{
    int delete;
    struct fpnode_type *fpnode_data;
    unsigned left = 0;

    offset += sizeof(struct fpnode_type);

    fpnode_data = tvlist(tvlist)->link_a.fplist.fplink.fpnode_data[0];
    while (1) {
	int slip;

	slip = land(text, (char *) fpnode_data + offset);
	if (!slip) {
	    delete = 1;

	    *find = fpnode_data + 1;

	    fpnode_data = fpnode_data->fpnode_data[0];
	    if (fpnode_data) {
		left += fpnode_data->fqnode.size;
	    }

	    *seek = left;

	    break;
	} else {
	    if (slip < 0) {
		fpnode_data = fpnode_data->fpnode_data[0];
		if (fpnode_data) {
		} else {
		    delete = 0;
		    if (1) {
			break;
		    }
		}
	    } else {
		struct fpnode_type *fqnode_data;

		fqnode_data = fpnode_data;
		fpnode_data = fpnode_data->fpnode_data[1];
		if (fpnode_data) {
		    left++;
		    fqnode_data = fqnode_data->fpnode_data[0];
		    if (fqnode_data) {
			left += fqnode_data->fqnode.size;
		    }
		} else {
		    delete = 0;
		    if (1) {
			break;
		    }
		}
	    }
	}
    }

    return delete;
}


int
x1f4_tick_tvlist(void *tvlist, void *text, unsigned slip,
		 int (*land) (void *, void *), unsigned *seek, void **find)
{
    int delete;

    if (tvlist(tvlist)->link_a.fplist.fplink.fqnode.size) {
	delete = tick_list(tvlist, text, slip, land, seek, find);
    } else {
	delete = 0;
    }

    return delete;
}
