/*
 * tzqp.o.c
 * Copyright (C) 2008-2009, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stddef.h>

#include <tzqp-defs.h>
#include <tzqp-types.h>

#define aBLACK(fpnode, c) \
    ((fpnode)->fqnode.bits |= c)

#define dBLACK(fpnode, c) \
    (c = eBLACK(fpnode))

#define eBLACK(fpnode) \
    ((fpnode)->fqnode.bits & cBLACK)

#define fBLACK(fpnode) \
    ((fpnode)->fqnode.bits &= ~cBLACK)

#define sBLACK(fpnode) \
    ((fpnode)->fqnode.bits |= cBLACK)

#define tzline(tzline)			((struct tzline_type *) (tzline))

int
_libx1f4l2_nand_tzline(void *tzline, void *text, int (*land) (void *, void *),
		       unsigned offset, void *back,
		       int (*call) (void *, void *))
{
    int status = 0;
    struct fpnode_type fpnode, *fpnode_data;
    unsigned tilt = 0;

    fpnode_data = tzline(tzline)->link_a.fpline.fplink.fpnode_data[0];

    while (1) {
	int fast;

	fast = land(text, (char *) fpnode_data + offset);

	if (fast) {
	    if (fast < 0) {
		tilt = 0;
	    } else {
		tilt = 1;
	    }
	} else {
	    if (1) {
		break;
	    }
	}

	fpnode_data = fpnode_data->fpnode_data[tilt];
	if (fpnode_data) {
	} else {
	    status = MISS_CLASS;
	    if (1) {
		break;
	    }
	}
    }

    if (status) {
    } else {
	fpnode = *fpnode_data;

	status = call(back, fpnode_data);
    }

    if (status) {
#if 0
	if (status == MISS_CLASS) {
	    status = 0;
	}
#endif				/* 0 */
    } else {
	struct fpnode_type *fqnode_data;

	fpnode_data = &fpnode;

	if (0) {
	    fpnode_data->uplink_data->fpnode_data[tilt] = fpnode_data;
	}

	fqnode_data = fpnode_data->uplink_data;
	if (fqnode_data) {
	} else {
	    fqnode_data = &tzline(tzline)->link_a.fpline.fplink;
	}

	do {
	    struct fpnode_type *ffnode_data, *fhnode_data;

	    fhnode_data = fpnode_data->fpnode_data[1];
	    if (fhnode_data) {
		struct fpnode_type *fjnode_data;

		fjnode_data = fhnode_data->fpnode_data[0];
		if (fjnode_data) {
		    struct fpnode_type *flnode_data, *fxnode_data,
			*fznode_data;
		    unsigned j, p;

		    flnode_data = fjnode_data->fpnode_data[0];
		    while (flnode_data) {
			fjnode_data = flnode_data->fpnode_data[0];
			if (fjnode_data) {
			    flnode_data = fjnode_data->fpnode_data[0];
			} else {
			    fjnode_data = flnode_data;
			    if (1) {
				break;
			    }
			}
		    }

		    flnode_data = fjnode_data->uplink_data;
		    fxnode_data = fjnode_data->fpnode_data[1];
		    flnode_data->fpnode_data[0] = fxnode_data;
		    fznode_data = fpnode_data->fpnode_data[0];
		    fjnode_data->fpnode_data[0] = fznode_data;
		    fjnode_data->fpnode_data[1] = fhnode_data;
		    fqnode_data->fpnode_data[tilt] = fjnode_data;
		    if (fznode_data) {
			fznode_data->uplink_data = fjnode_data;
		    }

		    fhnode_data->uplink_data = fjnode_data;
		    fjnode_data->uplink_data = fqnode_data;
		    if (fxnode_data) {
			fxnode_data->uplink_data = flnode_data;
		    }

		    dBLACK(fpnode_data, p);
		    dBLACK(fjnode_data, j);
		    fBLACK(fpnode_data);
		    aBLACK(fpnode_data, j);
		    fBLACK(fjnode_data);
		    aBLACK(fjnode_data, p);

		    tilt = 0;

		    ffnode_data = flnode_data;
		} else {
		    unsigned h, p;

		    fjnode_data = fpnode_data->fpnode_data[0];
		    fhnode_data->fpnode_data[0] = fjnode_data;
		    fqnode_data->fpnode_data[tilt] = fhnode_data;
		    fhnode_data->uplink_data = fqnode_data;
		    if (fjnode_data) {
			fjnode_data->uplink_data = fhnode_data;
		    }

		    dBLACK(fpnode_data, p);
		    dBLACK(fhnode_data, h);
		    fBLACK(fpnode_data);
		    aBLACK(fpnode_data, h);
		    fBLACK(fhnode_data);
		    aBLACK(fhnode_data, p);

		    tilt = 1;

		    ffnode_data = fhnode_data;
		}
	    } else {
		fhnode_data = fpnode_data->fpnode_data[0];
		fqnode_data->fpnode_data[tilt] = fhnode_data;
		if (fhnode_data) {
		    fhnode_data->uplink_data = fqnode_data;
		}

		ffnode_data = fqnode_data;
	    }

	    if (eBLACK(fpnode_data)) {
		if (1) {
		    struct fpnode_type *fxnode_data;

		    fxnode_data = ffnode_data->fpnode_data[tilt];
		    if (fxnode_data) {
			if (eBLACK(fxnode_data)) {
			} else {
			    sBLACK(fxnode_data);
			    if (1) {
				goto xj;
			    }
			}
		    }

		    if (ffnode_data == &tzline(tzline)->link_a.fpline.fplink) {
			break;
		    }
		}

		fhnode_data = ffnode_data->fpnode_data[tilt];

		for (;;) {
		    struct fpnode_type *fgnode_data;

		    if (ffnode_data == &tzline(tzline)->link_a.fpline.fplink) {
			break;
		    }

		    fgnode_data = ffnode_data->uplink_data;
		    if (fgnode_data) {
		    } else {
			fgnode_data = &tzline(tzline)->link_a.fpline.fplink;
		    }

		    if (fhnode_data == ffnode_data->fpnode_data[1]) {
			struct fpnode_type *fvnode_data;

			fvnode_data = ffnode_data->fpnode_data[0];
			if (eBLACK(fvnode_data)) {
			} else {
			    sBLACK(fvnode_data);
			    fBLACK(ffnode_data);

			    ffnode_data->fpnode_data[0] =
				fvnode_data->fpnode_data[1];
			    fvnode_data->fpnode_data[1] = ffnode_data;
			    if (fgnode_data->fpnode_data[0] == ffnode_data) {
				fgnode_data->fpnode_data[0] = fvnode_data;
			    } else {
				fgnode_data->fpnode_data[1] = fvnode_data;
			    }

			    fvnode_data->uplink_data = fgnode_data;
			    ffnode_data->uplink_data = fvnode_data;

			    fgnode_data = fvnode_data;
			    fvnode_data = ffnode_data->fpnode_data[0];

			    fvnode_data->uplink_data = ffnode_data;
			}

			do {
			    struct fpnode_type *fbnode_data, *fynode_data;
			    unsigned f;

			    fbnode_data = fvnode_data->fpnode_data[0];
			    fynode_data = fvnode_data->fpnode_data[1];
			    if (fbnode_data) {
				if (eBLACK(fbnode_data)) {
				    if (fynode_data) {
					if (eBLACK(fynode_data)) {
					    fBLACK(fvnode_data);
					    if (1) {
						break;
					    }
					} else {
					    struct fpnode_type *fanode_data;

					    sBLACK(fynode_data);
					    fBLACK(fvnode_data);

					    fanode_data =
						fynode_data->fpnode_data[0];
					    fvnode_data->fpnode_data[1] =
						fanode_data;
					    fynode_data->fpnode_data[0] =
						fvnode_data;
					    if (fanode_data) {
						fanode_data->uplink_data =
						    fvnode_data;
					    }

					    fbnode_data = fvnode_data;

					    fvnode_data->uplink_data =
						fynode_data;

					    fvnode_data = fynode_data;
					    ffnode_data->fpnode_data[0] =
						fynode_data;
					}
				    } else {
					fBLACK(fvnode_data);
					if (1) {
					    break;
					}
				    }
				}
			    } else {
				if (fynode_data) {
				    if (eBLACK(fynode_data)) {
					fBLACK(fvnode_data);
					if (1) {
					    break;
					}
				    } else {
					struct fpnode_type *fanode_data;

					sBLACK(fynode_data);
					fBLACK(fvnode_data);

					fanode_data =
					    fynode_data->fpnode_data[0];
					fvnode_data->fpnode_data[1] =
					    fanode_data;
					fynode_data->fpnode_data[0] =
					    fvnode_data;
					if (fanode_data) {
					    fanode_data->uplink_data =
						fvnode_data;
					}

					fbnode_data = fvnode_data;

					fvnode_data->uplink_data = fynode_data;

					fvnode_data = fynode_data;
					ffnode_data->fpnode_data[0] =
					    fynode_data;
				    }
				} else {
				    fBLACK(fvnode_data);
				    if (1) {
					break;
				    }
				}
			    }

			    dBLACK(ffnode_data, f);
			    fBLACK(fvnode_data);
			    aBLACK(fvnode_data, f);
			    sBLACK(ffnode_data);
			    sBLACK(fbnode_data);

			    fynode_data = fvnode_data->fpnode_data[1];
			    ffnode_data->fpnode_data[0] = fynode_data;
			    fvnode_data->fpnode_data[1] = ffnode_data;
			    if (fgnode_data->fpnode_data[0] == ffnode_data) {
				fgnode_data->fpnode_data[0] = fvnode_data;
			    } else {
				fgnode_data->fpnode_data[1] = fvnode_data;
			    }

			    fvnode_data->uplink_data =
				ffnode_data->uplink_data;
			    ffnode_data->uplink_data = fvnode_data;
			    if (fynode_data) {
				fynode_data->uplink_data = ffnode_data;
			    }

			    goto xj;
			} while (0);
		    } else {
			struct fpnode_type *fvnode_data;

			fvnode_data = ffnode_data->fpnode_data[1];
			if (eBLACK(fvnode_data)) {
			} else {
			    sBLACK(fvnode_data);
			    fBLACK(ffnode_data);

			    ffnode_data->fpnode_data[1] =
				fvnode_data->fpnode_data[0];
			    fvnode_data->fpnode_data[0] = ffnode_data;
			    if (fgnode_data->fpnode_data[0] == ffnode_data) {
				fgnode_data->fpnode_data[0] = fvnode_data;
			    } else {
				fgnode_data->fpnode_data[1] = fvnode_data;
			    }

			    fvnode_data->uplink_data =
				ffnode_data->uplink_data;
			    ffnode_data->uplink_data = fvnode_data;

			    fgnode_data = fvnode_data;
			    fvnode_data = ffnode_data->fpnode_data[1];

			    fvnode_data->uplink_data = ffnode_data;
			}

			do {
			    struct fpnode_type *fbnode_data, *fynode_data;
			    unsigned f;

			    fbnode_data = fvnode_data->fpnode_data[1];
			    fynode_data = fvnode_data->fpnode_data[0];
			    if (fbnode_data) {
				if (eBLACK(fbnode_data)) {
				    if (fynode_data) {
					if (eBLACK(fynode_data)) {
					    fBLACK(fvnode_data);
					    if (1) {
						break;
					    }
					} else {
					    struct fpnode_type *fanode_data;

					    sBLACK(fynode_data);
					    fBLACK(fvnode_data);

					    fanode_data =
						fynode_data->fpnode_data[1];
					    fvnode_data->fpnode_data[0] =
						fanode_data;
					    fynode_data->fpnode_data[1] =
						fvnode_data;
					    if (fanode_data) {
						fanode_data->uplink_data =
						    fvnode_data;
					    }

					    fbnode_data = fvnode_data;

					    fvnode_data->uplink_data =
						fynode_data;

					    fvnode_data = fynode_data;
					    ffnode_data->fpnode_data[1] =
						fynode_data;
					}
				    } else {
					fBLACK(fvnode_data);
					if (1) {
					    break;
					}
				    }
				}
			    } else {
				if (fynode_data) {
				    if (eBLACK(fynode_data)) {
					fBLACK(fvnode_data);
					if (1) {
					    break;
					}
				    } else {
					struct fpnode_type *fanode_data;

					sBLACK(fynode_data);
					fBLACK(fvnode_data);

					fanode_data =
					    fynode_data->fpnode_data[1];
					fvnode_data->fpnode_data[0] =
					    fanode_data;
					fynode_data->fpnode_data[1] =
					    fvnode_data;
					if (fanode_data) {
					    fanode_data->uplink_data =
						fvnode_data;
					}

					fbnode_data = fvnode_data;

					fvnode_data->uplink_data = fynode_data;

					fvnode_data = fynode_data;
					ffnode_data->fpnode_data[1] =
					    fynode_data;
				    }
				} else {
				    fBLACK(fvnode_data);
				    if (1) {
					break;
				    }
				}
			    }

			    dBLACK(ffnode_data, f);
			    fBLACK(fvnode_data);
			    aBLACK(fvnode_data, f);
			    sBLACK(ffnode_data);
			    sBLACK(fbnode_data);

			    fynode_data = fvnode_data->fpnode_data[0];
			    ffnode_data->fpnode_data[1] = fynode_data;
			    fvnode_data->fpnode_data[0] = ffnode_data;
			    if (fgnode_data->fpnode_data[0] == ffnode_data) {
				fgnode_data->fpnode_data[0] = fvnode_data;
			    } else {
				fgnode_data->fpnode_data[1] = fvnode_data;
			    }

			    fvnode_data->uplink_data =
				ffnode_data->uplink_data;
			    ffnode_data->uplink_data = fvnode_data;
			    if (fynode_data) {
				fynode_data->uplink_data = ffnode_data;
			    }

			    goto xj;
			} while (0);
		    }

		    if (eBLACK(ffnode_data)) {
		    } else {
			sBLACK(ffnode_data);
			if (1) {
			    break;
			}
		    }
		    fhnode_data = ffnode_data;
		    ffnode_data = ffnode_data->uplink_data;
		    if (ffnode_data) {
		    } else {
			break;
		    }
		}

	      xj:
		;
	    }

	    fpnode_data = tzline(tzline)->link_a.fpline.fplink.fpnode_data[0];
	    if (fpnode_data) {
		fpnode_data->uplink_data = NULL;
	    }
	} while (0);
    }

    return status;
}
