/*
 * x1f4.c
 * Copyright (C) 2002-2012, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <config.h>

#if defined HAVE_FEATURES_H
# include <features.h>
#endif				/* HAVE_FEATURES_H */

#include <getopt.h>
#include <stddef.h>
#include <stdio.h>
#include <stdlib.h>

static void usage(void);

static void
usage(void)
{
    puts("Usage: x1f4 [OPTIONS]\n\
Exit successfully.\n\
\n\
Options:\n\
  --help			display this help and exit\n\
  --version			output version information and exit");
}


int
main(int argc, char **argv)
{
    unsetenv("POSIXLY_CORRECT");

    while (1) {
	char c;
	static struct option long_options[] = {
/* *INDENT-OFF* */
	    {	"version",	0x00,	NULL,	0x76	},
	    {	"help",		0x00,	NULL,	0x68	},
	    {	NULL,		0x00,	NULL,	0x00	}
/* *INDENT-ON* */
	};

	c = getopt_long(argc, argv, "", long_options, NULL);

	if (!~c) {
	    break;
	}

	switch (c) {
	case 'h':
	    usage();

	    return 0;
	case 'v':
	    printf("%s (%s) %s\n", argv[0], PACKAGE, VERSION);

	    return 0;
	case '?':
	    return 1;
	}
    }

    return 0;
}
